// ********************************************************************
//
//  Routine:	alca/actaxxComm.C
//  Author:		Dirk Kruecker
//
//  Description:	kuip commands for TAXX
//
//  Modifications:
//   -- creation					08/11/00 DK
//   -- polishing					19/12/00 DG
// ********************************************************************

#include <iostream.h>
#include "arte/arte.hh"
#include "farm/farm.hh"

extern "C"  {
    int   ku_npar();   // return the number of parameters 
    int   ku_geti();   // read an integer
    double ku_getr();  // read a float
    char* ku_gets();   // read a string
    char* ku_getc();   // read an uppercase string
    char* ku_getf();   // read a filename
    char* ku_getl();   // read a comma separated list
} 


extern "C" void kugeti_(int*);
extern "C" void kugetr_(float*);


#include "alca/actaxxComm.hh"
struct TACMD actaxx_Command =
{
	TACMD::off,			/* cmd */
	TACMD::ta_itr|TACMD::ta_otr	/* flg */
};





extern "C" void actaxxmode_(){
  ARTE_mark( "actaxxmode_ 0", GRR_OK );

  char * str=ku_getc();
  if      ( !strcmp(str,"TRACK")   )	actaxx_Command.cmd = TACMD::track;
  else if ( !strcmp(str,"EVENT")   )	actaxx_Command.cmd = TACMD::event;
  else if ( !strcmp(str,"EXTRACT") )	actaxx_Command.cmd = TACMD::extract;
  else if ( !strcmp(str,"FILL")    )	actaxx_Command.cmd = TACMD::fill;
  else if ( !strcmp(str,"OFF")     )	actaxx_Command.cmd = TACMD::off;
  else if ( !strcmp(str,"FITONLY") ){	actaxx_Command.cmd = TACMD::track;
					actaxx_Command.flg = TACMD::fitonly; }
  else cout<<"actaxxmode_: what do you mean by "<<str<<endl;

  ARTE_mark( "actaxxmode_ 1", GRR_OK );
}





extern "C" void actaxxsubd_()
{
	ARTE_mark( "actaxxsubd_ 0", GRR_OK );

	char * str = ku_getc();
	char * swt = ku_getc();

	if( !strcmp(str,"ITR") || !strcmp(str,"ALL") )
	{
		if ( !strcmp(swt,"ON")  ) actaxx_Command.flg |= TACMD::ta_itr;
		if ( !strcmp(swt,"OFF") ) actaxx_Command.flg &= ~TACMD::ta_itr;
	}

	if( !strcmp(str,"OTR") || !strcmp(str,"ALL") )
	{
		if ( !strcmp(swt,"ON")  ) actaxx_Command.flg |= TACMD::ta_otr;
		if ( !strcmp(swt,"OFF") ) actaxx_Command.flg &= ~TACMD::ta_otr;
	}

	ARTE_mark( "actaxxsubd_ 1", GRR_OK );
}





extern "C" void actaxxio_()
{
	ARTE_mark( "actaxxio_ 0", GRR_OK );

	char * str=ku_getc();
	// Only one output stream (?)
	if ( !strcmp(str,"OFF") ) actaxx_Command.flg &= ~(TACMD::taout|TACMD::rhp);

	if	( !strcmp(str,"TAOUT")) actaxx_Command.flg |= TACMD::taout;
	else if	( !strcmp(str,"RHP")  ) actaxx_Command.flg |= TACMD::rhp;
	else cout<<"actaxxio_: sorry, what do you mean by "<<str<<" ?\n";

	ARTE_mark( "actaxxio_ 1", GRR_OK );
}
