// ********************************************************************
//
//  Routine:	alca/actaxxCommITR.C
//  Author:		Torsten Zeuner
//
//  Description:	ITR-specific kuip commands for TAXX
//
//  Modifications:
//   -- creation					08/11/00 DK
//   -- remake + add ARTE_mark				14/12/00 DG
//   -- set ITR defaults				19/12/00 TZ
//
// ********************************************************************

#include <iostream.h>
#include "arte/arte.hh"
#include "farm/farm.hh"

#include "alca/actaxxComm.hh"

struct TACommITR taCommITR =
{
	0, 		/* nMC */
	15,		/* nPC */
	0,		/* nTC */

	0.1,		/* xcut */
	0.3,		/* xexc */

	650.,		/* zcut */
	10.,		/* pcut */

	10.		/* chi2_neighbour */
};





extern "C"  {
    int   ku_npar();   // return the number of parameters 
    int   ku_geti();   // read an integer
    double ku_getr();  // read a float
    char* ku_gets();   // read a string
    char* ku_getc();   // read an uppercase string
    char* ku_getf();   // read a filename
    char* ku_getl();   // read a comma separated list
} 


extern "C" void kugeti_(int*);
extern "C" void kugetr_(float*);





extern "C" void actaxxitrcuts_(){
  ARTE_mark( "actaxxitrcuts_ 0", GRR_OK );

  int i;
  kugeti_(&i);
  if(i!=-999) taCommITR.nMC		= i;

  kugeti_(&i);
  if(i!=-999) taCommITR.nPC		= i;

  kugeti_(&i);
  if(i!=-999) taCommITR.nTC		= i;


  float x;
  kugetr_(&x);
  if(x!=-999) taCommITR.xcut		= x;

  kugetr_(&x);
  if(x!=-999) taCommITR.xexc		= x;

  kugetr_(&x);
  if(x!=-999) taCommITR.zcut		= x;

  kugetr_(&x);
  if(x!=-999) taCommITR.pcut		= x;


  kugetr_(&x);
  if(x!=-999) taCommITR.chi2_neighbour	= x;
  ARTE_mark( "actaxxitrcuts_ 1", GRR_OK );
}
