#ifndef __TAFLG__
#define __TAFLG__

// ********************************************************************
//
//  Header:	alca/actaxxFLG.hh
//  Author:		Dmitri Goloubkov
//
//  Description:	Flags for TAXX
//
//  Modifications:
//   -- none yet					06/12/00 DG
//
// ********************************************************************

/*
** Least significant byte stores the associated TATR number
** Most significant bits indicate type of detector and other flags
*/


struct TAFLG
{
	enum {
		tatr	= 	0xff, /* corresponding TATR number byte */


		bit8    =      0x100, /* not assigned yet =first bit is bit0,*/
		bit9    =      0x200, /* not assigned yet =first bit is bit0,*/
		bit10   =      0x400, /* not assigned yet =first bit is bit0,*/
		bit11   =      0x800, /* not assigned yet =first bit is bit0,*/
		bit12   =     0x1000, /* not assigned yet =first bit is bit0,*/
		bit13   =     0x2000, /* not assigned yet =first bit is bit0,*/
		bit14   =     0x4000, /* not assigned yet =first bit is bit0,*/
		bit15   =     0x8000, /* not assigned yet =first bit is bit0,*/


		fit     =    0x10000, /* hit was used in track fit */

		itrsel	=    0x20000, /* selected by ITR selection */
		otrsel	=    0x40000, /* selected by OTR selection */

		bit19   =    0x80000, /* not assigned yet =first bit is bit0,*/
		bit20   =   0x100000, /* not assigned yet =first bit is bit0,*/
		bit21   =   0x200000, /* not assigned yet =first bit is bit0,*/
		bit22   =   0x400000, /* not assigned yet =first bit is bit0,*/
		bit23   =   0x800000, /* not assigned yet =first bit is bit0,*/


		otr	=  0x1000000, /* Outer Tracker hit */
		itr	=  0x2000000, /* Inner Tracker hit */

		bit26   =  0x4000000, /* not used yet */
		bit27   =  0x8000000, /* not used yet */
		bit28   = 0x10000000, /* not used yet */
		bit29   = 0x20000000, /* not used yet */
		bit30   = 0x40000000, /* not used yet */


		bitsign = 0x80000000  /* Kill bit (not used yet) */
	};
};

#endif
