*CMZ :          15/05/96  12.29.49  by  Hartwig Albrecht
*CMZ :  2.01/01 29/11/95  13.42.40  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   14/11/95
*--
*-- modified:   Thomas Lohse  May 9, 1999
*--             (initialization of variable  meson  in /ZDECAY/ added)
*-- modified:   Olya Igonkina 9/03/2001
*--             (add new processes of CSM and COM models)

      SUBROUTINE ALPDAT

************************************************************************
*
* Description: substitute for the Pythia BLOCK DATA
*              (Block datas are forbidden)
*
* Called from: KALUND
*
* External references: none
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/ZDECAY.fi"
#include "pyth/PYSUBS.fi"
#include "pyth/PYPARS.fi"
#include "pyth/PYINT1.fi"
#include "pyth/PYINT2.fi"
#include "pyth/PYINT6.fi"
#include "pyth/PYINT7.fi"
#include "jets/LUDAT2.fi"

      INTEGER I, J, K
      INTEGER LUCOMP
      EXTERNAL LUCOMP
      
      INTEGER IDKFIN(2,-40:40),IDMSTP(200),IDISET(200),IDKFPR(200,2),
     +  IDICOL(40,4,2)
      REAL FDCKIN(200),FDPARP(200)
      CHARACTER*28 CDPROC(0:200)

C...Default values for allowed processes and kinematics constraints.
      DATA ((IDKFIN(I,J),J=-40,40),I=1,2)/16*0,4*1,4*0,6*1,5*0,5*1,0,
     &5*1,5*0,6*1,4*0,4*1,16*0,16*0,4*1,4*0,6*1,5*0,5*1,0,5*1,5*0,
     &6*1,4*0,4*1,16*0/
      DATA FDCKIN/
     &   2.0, -1.0,  0.1, -1.0,  1.0,  1.0, -10.,  10., -10.,  10.,
     1  -10.,  10., -10.,  10., -10.,  10., -1.0,  1.0, -1.0,  1.0,
     2   0.0,  1.0,  0.0,  1.0, -1.0,  1.0, -1.0,  1.0,   0.,   0.,
     3   2.0, -1.0,   0.,   0.,  0.0, -1.0,  0.0, -1.0,   0.,   0.,
     4  12.0, -1.0, 12.0, -1.0, 12.0, -1.0, 12.0, -1.0,   0.,   0.,
     5   0.0, -1.0,  0.0, -1.0,  0.0, -1.0,   0.,   0.,   0.,   0.,
     6   140*0./

C...Default values for main switches and parameters. Reset information.
      DATA (IDMSTP(I),I=1,100)/
     &     3,    1,    2,    0,    0,    0,    0,    0,    0,    0,
     1     1,    0,    1,    0,    5,    0,    0,    0,    0,    0,
     2     1,    0,    1,    0,    0,    0,    0,    0,    0,    1,
     3     1,    2,    0,    1,    0,    2,    1,    5,    2,    0,
     4     1,    1,    3,    7,    3,    1,    1,    2,    2,    0,
     5     9,    1,    1,    1,    1,    1,    1,    6,    0,    0,
     6     1,    3,    2,    2,    1,    1,    2,    0,    0,    0,
     7     1,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     8     1,    1,  100,    0,    0,    0,    0,    0,    0,    0,
     9     1,    4,    1,    2,    0,    0,    0,    0,    0,    0/
      DATA (IDMSTP(I),I=101,200)/
     &     3,    1,    0,    0,    0,    0,    0,    0,    0,    0,
     1     1,    1,    1,    0,    0,    0,    0,    0,    0,    0,
     2     0,    1,    2,    1,    1,   20,    0,    0,   10,    0,
     3     0,    4,    0,    1,    0,    0,    0,    0,    0,    0,
     4     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     5     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     6     0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     7     0,    2,    0,    0,    0,    0,    0,    0,    0,    0,
     8     5,  710, 1995,   01,   27,  404,    0,    0,    0,    0,
     9     0,    0,    0,    0,    0,    0,    0,    0,    0,    0/
      DATA (FDPARP(I),I=1,100)/
     &  0.25,  10.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,
     1    0.,   0.,  1.0, 0.01,  0.5,  1.0,  1.0,   0.,   0.,   0.,
     2    0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,
     3   1.5,  2.0, 0.075,  0.,  0.2,   0.,  2.0, 0.70, 0.006,  0.,
     4  0.02,  2.0, 0.10, 1000., 2054., 123., 246., 0.,   0.,   0.,
     5   1.0,   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,
     6  0.25,  1.0, 0.25,  1.0,  2.0, 1E-3,  4.0, 1E-3,   0.,   0.,
     7   4.0,   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,
     8  1.40, 1.55,  0.5,  0.2, 0.33, 0.66,  0.7,  0.5,   0.,   0.,
     9  0.44, 0.20,  2.0,  1.0,   0.,  3.0,  1.0, 0.75, 0.44,  2.0/
      DATA (FDPARP(I),I=101,200)/
     &   0.5, 0.28,  1.0,   0.,   0.,   0.,   0.,   0.,   0.,   0.,
     1   2.0,   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,
     2   1.0,  0.4,   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,
     3  0.01,   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,
     4    0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,
     5    0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,
     6  2.20, 23.6, 18.4, 11.5,   0.,   0.,   0.,   0.,   0.,   0.,
     7    0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,
     8    0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,
     9    0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0.,   0./

C...Constants for the generation of the various processes.
      DATA (IDISET(I),I=1,100)/
     &    1,    1,    1,   -1,    3,   -1,   -1,    3,   -2,    2,
     1    2,    2,    2,    2,    2,    2,   -1,    2,    2,    2,
     2   -1,    2,    2,    2,    2,    2,   -1,    2,    2,    2,
     3    2,   -1,    2,    2,    2,    2,   -1,   -1,   -1,   -1,
     4   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
     5   -1,   -1,    2,    2,   -1,   -1,   -1,    2,   -1,   -1,
     6   -1,   -1,   -1,   -1,   -1,   -1,   -1,    2,    2,    2,
     7    4,    4,    4,   -1,   -1,    4,    4,   -1,   -1,    2,
     8    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
     9    0,    0,    0,    0,    0,    9,   -2,   -2,   -2,   -2/
      DATA (IDISET(I),I=101,200)/
*OI     &   -1,    1,    1,   -2,   -2,   -2,   -2,   -2,   -2,    2,
*OI     1    2,    2,    2,    2,    2,   -1,   -1,   -1,   -2,   -2,
     &   -1,    1,    1,    1,    1,    2,    2,    2,   -2,    2,
     1    2,    2,    2,    2,    2,   -1,   -1,   -1,    1,    1,
     2    5,    5,    5,    5,    2,    2,    2,   -2,   -2,   -2,
     3    6,    2,    2,    2,    2,    2,    2,   -2,   -2,   -2,
     4    1,    1,    1,    1,    1,   -2,    1,    1,    1,   -2,
     5    1,    1,    1,   -2,   -2,    1,    1,    1,   -2,   -2,
     6    2,    2,    2,    2,    2,    2,    2,    2,   -2,   -2,
     7    2,    2,    5,    5,   -2,    2,    2,    5,    5,   -2,
     8    5,    5,   -2,   -2,   -2,    5,    5,   -2,   -2,    2,
     9    2,    2,    2,    2,   -2,   -2,   -2,   -2,   -2,   -2/
      DATA ((IDKFPR(I,J),J=1,2),I=1,50)/
     &   23,    0,   24,    0,   25,    0,   24,    0,   25,    0,
     &   24,    0,   23,    0,   25,    0,    0,    0,    0,    0,
     1    0,    0,    0,    0,   21,   21,   21,   22,   21,   23,
     1   21,   24,   21,   25,   22,   22,   22,   23,   22,   24,
     2   22,   25,   23,   23,   23,   24,   23,   25,   24,   24,
     2   24,   25,   25,   25,    0,   21,    0,   22,    0,   23,
     3    0,   24,    0,   25,    0,   21,    0,   22,    0,   23,
     3    0,   24,    0,   25,    0,   21,    0,   22,    0,   23,
     4    0,   24,    0,   25,    0,   21,    0,   22,    0,   23,
     4    0,   24,    0,   25,    0,   21,    0,   22,    0,   23/
      DATA ((IDKFPR(I,J),J=1,2),I=51,100)/
     5    0,   24,    0,   25,    0,    0,    0,    0,    0,    0,
     5    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     6    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     6    0,    0,    0,    0,   21,   21,   24,   24,   23,   24,
     7   23,   23,   24,   24,   23,   24,   23,   25,   22,   22,
     7   23,   23,   24,   24,   24,   25,   25,   25,    0,  211,
     8    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     8  443,   21,10441,   21,20443,   21,  445,   21,30443,   21,
     9    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9    0,    0,    0,    0,    0,    0,    0,    0,    0,    0/
      DATA ((IDKFPR(I,J),J=1,2),I=101,150)/
     &   23,    0,   25,    0,   25,    0,10441,    0,  445,    0,
     &10441,    0,20443,    0,  445,    0,    0,    0,   22,   25,
     1   21,   25,    0,   25,   21,   25,   22,   22,   21,   22,
     1   22,   23,   23,   23,   24,   24,10441,    0,  445,    0,
     2   25,    6,   25,    6,   25,    0,   25,    0,   21,10441,
     2   21,20443,   21,  445,    0,    0,    0,    0,    0,    0,
     3   23,    5,10441,    0,20443,    0,  445,    0,   21,10441,
     3   21,20443,   21,  445,    0,    0,    0,    0,    0,    0,  
     4   32,    0,   34,    0,   37,    0,   40,    0,   39,    0,
     4    0,    0,    7,    0,    8,    0,   38,    0,    0,    0/
      DATA ((IDKFPR(I,J),J=1,2),I=151,200)/
     5   35,    0,   35,    0,   35,    0,    0,    0,    0,    0,
     5   36,    0,   36,    0,   36,    0,    0,    0,    0,    0,
     6    6,   37,   39,    0,   39,   39,   39,   39,   11,    0,
     6   11,    0,    0,    7,    0,    8,    0,    0,    0,    0,
     7   23,   35,   24,   35,   35,    0,   35,    0,    0,    0,
     7   23,   36,   24,   36,   36,    0,   36,    0,    0,    0,
     8   35,    6,   35,    6,    0,    0,    0,    0,    0,    0,
     8   36,    6,   36,    6,    0,    0,    0,    0,  443,   21,
     9 10441,  21,20443,   21,  445,   21,30443,   21,    0,    0,
     9    0,    0,    0,    0,    0,    0,    0,    0,    0,    0/
      DATA (((IDICOL(I,J,K),K=1,2),J=1,4),I=1,40)/
     1 4,0,3,0,2,0,1,0,3,0,4,0,1,0,2,0,2,0,0,1,4,0,0,3,3,0,0,4,1,0,0,2,
     2 3,0,0,4,1,4,3,2,4,0,0,3,4,2,1,3,2,0,4,1,4,0,2,3,4,0,3,4,2,0,1,2,
     3 3,2,1,0,1,4,3,0,4,3,3,0,2,1,1,0,3,2,1,4,1,0,0,2,2,4,3,1,2,0,0,1,
     4 3,2,1,4,1,4,3,2,4,2,1,3,4,2,1,3,3,4,4,3,1,2,2,1,2,0,3,1,2,0,0,0,
     5 4,2,1,0,0,0,1,0,3,0,0,3,1,2,0,0,4,0,0,4,0,0,1,2,2,0,0,1,4,4,3,3,
     6 2,2,1,1,4,4,3,3,3,3,4,4,1,1,2,2,3,2,1,3,1,2,0,0,4,2,1,4,0,0,1,2,
     7 4,0,0,0,4,0,1,3,0,0,3,0,2,4,3,0,3,4,0,0,1,0,0,1,0,0,3,4,2,0,0,2,
     8 3,0,0,0,1,0,0,0,0,0,3,0,2,0,0,0,2,0,3,1,2,0,0,0,3,2,1,0,1,0,0,0,
     9 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     & 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,4,1,0,0,2,0,2,2,1,1,0,0,0,0/

C...Character constants: name of processes.
      DATA CDPROC(0)/                    'All included subprocesses   '/
      DATA (CDPROC(I),I=1,20)/
     1'f + f~ -> gamma*/Z0         ',  'f + f~'' -> W+/-             ',
     2'f + f~ -> H0                ',  'gamma + W+/- -> W+/-        ',
     3'Z0 + Z0 -> H0               ',  'Z0 + W+/- -> W+/-           ',
     4'                            ',  'W+ + W- -> H0               ',
     5'                            ',  'f + f'' -> f + f'' (QFD)      ',
     6'f + f'' -> f + f'' (QCD)      ','f + f~ -> f'' + f~''          ',
     7'f + f~ -> g + g             ',  'f + f~ -> g + gamma         ',
     8'f + f~ -> g + Z0            ',  'f + f~'' -> g + W+/-         ',
     9'f + f~ -> g + H0            ',  'f + f~ -> gamma + gamma     ',
     &'f + f~ -> gamma + Z0        ',  'f + f~'' -> gamma + W+/-     '/
      DATA (CDPROC(I),I=21,40)/
     1'f + f~ -> gamma + H0        ',  'f + f~ -> Z0 + Z0           ',
     2'f + f~'' -> Z0 + W+/-        ', 'f + f~ -> Z0 + H0           ',
     3'f + f~ -> W+ + W-           ',  'f + f~'' -> W+/- + H0        ',
     4'f + f~ -> H0 + H0           ',  'f + g -> f + g              ',
     5'f + g -> f + gamma          ',  'f + g -> f + Z0             ',
     6'f + g -> f'' + W+/-          ', 'f + g -> f + H0             ',
     7'f + gamma -> f + g          ',  'f + gamma -> f + gamma      ',
     8'f + gamma -> f + Z0         ',  'f + gamma -> f'' + W+/-      ',
     9'f + gamma -> f + H0         ',  'f + Z0 -> f + g             ',
     &'f + Z0 -> f + gamma         ',  'f + Z0 -> f + Z0            '/
      DATA (CDPROC(I),I=41,60)/
     1'f + Z0 -> f'' + W+/-         ', 'f + Z0 -> f + H0            ',
     2'f + W+/- -> f'' + g          ', 'f + W+/- -> f'' + gamma      ',
     3'f + W+/- -> f'' + Z0         ', 'f + W+/- -> f'' + W+/-       ',
     4'f + W+/- -> f'' + H0         ', 'f + H0 -> f + g             ',
     5'f + H0 -> f + gamma         ',  'f + H0 -> f + Z0            ',
     6'f + H0 -> f'' + W+/-         ', 'f + H0 -> f + H0            ',
     7'g + g -> f + f~             ',  'g + gamma -> f + f~         ',
     8'g + Z0 -> f + f~            ',  'g + W+/- -> f + f~''         ',
     9'g + H0 -> f + f~            ',  'gamma + gamma -> f + f~     ',
     &'gamma + Z0 -> f + f~        ',  'gamma + W+/- -> f + f~''     '/
      DATA (CDPROC(I),I=61,80)/
     1'gamma + H0 -> f + f~        ',  'Z0 + Z0 -> f + f~           ',
     2'Z0 + W+/- -> f + f~''        ', 'Z0 + H0 -> f + f~           ',
     3'W+ + W- -> f + f~           ',  'W+/- + H0 -> f + f~''        ',
     4'H0 + H0 -> f + f~           ',  'g + g -> g + g              ',
     5'gamma + gamma -> W+ + W-    ',  'gamma + W+/- -> Z0 + W+/-   ',
     6'Z0 + Z0 -> Z0 + Z0          ',  'Z0 + Z0 -> W+ + W-          ',
     7'Z0 + W+/- -> Z0 + W+/-      ',  'Z0 + Z0 -> Z0 + H0          ',
     8'W+ + W- -> gamma + gamma    ',  'W+ + W- -> Z0 + Z0          ',
     9'W+/- + W+/- -> W+/- + W+/-  ',  'W+/- + H0 -> W+/- + H0      ',
     &'H0 + H0 -> H0 + H0          ',  'q + gamma -> q'' + pi+/-     '/
      DATA (CDPROC(I),I=81,100)/
     1'q + q~ -> Q + Q~, massive   ',  'g + g -> Q + Q~, massive    ',
     2'f + q -> f'' + Q, massive    ', 'g + gamma -> Q + Q~, massive',
     3'gamma + gamma -> F + F~, mas',  'g + g -> J/Psi + g  (CSM)   ',
     4'g + g -> chi_0c + g (CSM)   ',  'g + g -> chi_1c + g (CSM)   ',
     5'g + g -> chi_2c + g (CSM)   ',  'g + g -> psi(2S)+ g (CSM)   ',
     6'Elastic scattering          ',  'Single diffractive (XB)     ',
     7'Single diffractive (AX)     ',  'Double  diffractive         ',
     8'Low-pT scattering           ',  'Semihard QCD 2 -> 2         ',
     9'                            ',  '                            ',
     &'                            ',  '                            '/
      DATA (CDPROC(I),I=101,120)/
     1'g + g -> gamma*/Z0          ',  'g + g -> H0                 ',
     2'gamma + gamma -> H0         ',  'g + g -> chi_c0 (CSM)       ',
     3'g + g -> chi_c2 (CSM)       ',  'g + q -> chi_c0 + q (CSM)   ',
     4'g + q -> chi_c1 + q (CSM)   ',  'g + q -> chi_c2 + q (CSM)   ',
     5'                            ',  'f + f~ -> gamma + H0        ',
     6'f + f~ -> g + H0            ',  'q + g -> q + H0             ',
     7'g + g -> g + H0             ',  'g + g -> gamma + gamma      ',
     8'g + g -> g + gamma          ',  'g + g -> gamma + Z0         ',
     9'g + g -> Z0 + Z0            ',  'g + g -> W+ + W-            ',
     &'g + g -> chi_c0 (COM)       ',  'g + g -> chi_c2 (COM)       '/
      DATA (CDPROC(I),I=121,140)/
     1'g + g -> Q + Q~ + H0        ',  'q + q~ -> Q + Q~ + H0       ',
     2'f + f'' -> f + f'' + H0     ',  'f + f'' -> f" + f"'' + H0   ',
     3'q + q~ -> g + chi_c0 (CSM)  ',  'q + q~ -> g + chi_c1 (CSM)  ',
     4'q + q~ -> g + chi_c2 (CSM)  ',  '                            ',
     5'                            ',  '                            ',
     6'g + g -> Z0 + q + q~        ',  'g + q -> chi_c0 + q (COM)   ',
     7'g + q -> chi_c1 + q (COM)   ',  'g + q -> chi_c2 + q (COM)   ',
     8'q + q~-> g + chi_c0 (COM)   ',  'q + q~-> g + chi_c1 (COM)   ',
     9'q + q~-> g + chi_c2 (COM)   ',  '                            ',
     &'                            ',  '                            '/
      DATA (CDPROC(I),I=141,160)/
     1'f + f~ -> gamma*/Z0/Z''0     ', 'f + f~'' -> W''+/-            ',
     2'f + f~'' -> H+/-             ', 'f + f~'' -> R                ',
     3'q + l -> LQ                 ',  '                            ',
     4'd + g -> d*                 ',  'u + g -> u*                 ',
     5'g + g -> eta_techni         ',  '                            ',
     6'f + f~ -> H''0               ', 'g + g -> H''0                ',
     7'gamma + gamma -> H''0        ', '                            ',
     8'                            ',  'f + f~ -> A0                ',
     9'g + g -> A0                 ',  'gamma + gamma -> A0         ',
     &'                            ',  '                            '/
      DATA (CDPROC(I),I=161,180)/
     1'f + g -> f'' + H+/-          ', 'q + g -> LQ + l~            ',
     2'g + g -> LQ + LQ~           ',  'q + q~ -> LQ + LQ~          ',
     3'f + f~ -> f'' + f~'' (gamma/Z)',
     3'f +f~'' -> f" + f~"'' (W)     ',
     4'q + q'' -> q" + d*           ',  'q + q'' -> q" + u*           ',
     5'                            ',  '                            ',
     6'f + f~ -> Z0 + H''0          ', 'f + f~'' -> W+/- + H''0       ',
     7'f + f'' -> f + f'' + H''0      ',
     7'f + f'' -> f" + f"'' + H''0    ',
     8'                            ',  'f + f~ -> Z0 + A0           ',
     9'f + f~'' -> W+/- + A0        ',
     9'f + f'' -> f + f'' + A0       ',
     &'f + f'' -> f" + f"'' + A0     ',
     &'                            '/
      DATA (CDPROC(I),I=181,200)/
     1'g + g -> Q + Q~ + H''0       ',  'q + q~ -> Q + Q~ + H''0      ',
     2'                            ',  '                            ',
     3'                            ',  'g + g -> Q + Q~ + A0        ',
     4'q + q~ -> Q + Q~ + A0       ',  '                            ',
     5'                            ',  'g + g -> J/psi + g (COM)    ',
     6'g + g -> chi_c0 + g (COM)   ',  'g + g -> chi_c1 + g (COM)   ',
     7'g + g -> chi_c2 + g (COM)   ',  'g + g -> psi(2S) + g (COM)  ',
     8'                            ',  '                            ',
     9'                            ',  '                            ',
     &'                            ',  '                            '/

C...Cross sections and slope offsets.

      MSEL = 1
      PROC(0) = CDPROC(0)

      DO 20 I = 1, 200
        MSUB(I) = 0
        CKIN(I) = FDCKIN(I)
        MSTP(I) = IDMSTP(I)
        PARP(I) = FDPARP(I)
        MSTI(I) = 0
        PARI(I) = 0.
        ISET(I) = IDISET(I)
        KFPR(I,1) = IDKFPR(I,1)
        KFPR(I,2) = IDKFPR(I,2)

        DO 10 J = 1, 20
          COEF(I,J) = 0.
 10     CONTINUE
        PROC(I) = CDPROC(I)

 20   CONTINUE

      DO 30 I = -40, 40
        KFIN(1,I) = IDKFIN(1,I)
        KFIN(2,I) = IDKFIN(2,I)
 30   CONTINUE

      DO 40 I = 1, 400
        MINT(I) = 0
        VINT(I) = 0.
 40   CONTINUE

      DO 60 I = 1, 40
        DO 50 J = 1, 4
          ICOL(I,J,1) = IDICOL(I,J,1)
          ICOL(I,J,2) = IDICOL(I,J,2)
 50     CONTINUE
 60   CONTINUE

      DO 70 I = 0, 6
      DO 70 J = 0, 6
      DO 70 K = 0, 5
        SIGT(I,J,K) = 0.
 70   CONTINUE



C initialize the variable  meson  in /ZDECAY/  (used for special
C treatment of forced decay modes for particles with mixing)

      meson = 0

      END

************************************************************************
* End of ALPDAT
************************************************************************
