*-- Author :    Hartwig Albrecht   23/05/95

      SUBROUTINE DDATTC

************************************************************************
*
* Description: make include files *.h from the DATT command
*
* Called from: DDEXEC
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ZDDCOM.fi"
#include "arte/ZDDEFP.fi"
#include "auto/DDEF.fi"

      INTEGER K1, K2, K3, K4, L, Ll, CHCMPN, LENOCC
      INTEGER  IFF, IFH, IFB, IFU, IFC
      CHARACTER CC*200, CU*80, CL*80, CA*80, CR*80, C1*1

#include "arte/Arte.ff"
#include "auto/DDEF.ff"

      CALL CHCTOH ('F', IFF, 1)
      CALL CHCTOH ('H', IFH, 1)
      CALL CHCTOH ('B', IFB, 1)
      CALL CHCTOH ('U', IFU, 1)
      CALL CHCTOH ('C', IFC, 1)

C loop over tables

      DO 90 K1 = 1, NDDUSR
        IF (IDDEF_FLAG(K1) .NE. LDDEF_TAB)  GO TO 90

C new deck *.h

        CALL CHHTOC (IQ(HQDDEF_NAME(1,K1)), CU)
        CL = CU
        CALL CUTOL (CL)

        CALL DDOPEN (CU, 'h')
        CALL DDNDEF (CU, 'H')

        CALL DDCSTO ('typedef struct {')

C declarations for attributes

        DO 30 K2 = K1 + 1, NDDEF()
          IF (IDDEF_FLAG(K2) .GE. LDDEF_INI .AND.
     +        IDDEF_FLAG(K2) .LE. LDDEF_NAM)  GO TO 40

          CALL CHHTOC (IQ(HQDDEF_NAME(1,K2)), CA)
          CALL CUTOL (CA)

          IF (IDDEF_FLAG(K2) .EQ. LDDEF_ATT .OR.
     +        IDDEF_FLAG(K2) .EQ. LDDEF_POI)  THEN
            K4 = IDDEF_DIM(K2)
            CC = 'int'
            IF (IDDEF_FLAG(K2) .EQ. LDDEF_ATT)  THEN
              IF (HDDEF_NAM2(1,K2) .EQ. IFF)  THEN
                CC = 'float'
              ELSE IF (HDDEF_NAM2(1,K2) .EQ. IFH .OR.
     +                 HDDEF_NAM2(1,K2) .EQ. IFC)  THEN
                CC = 'char'
                K4 = 4 * MAX (K4, 1)
              ELSE IF (HDDEF_NAM2(1,K2) .EQ. IFB .OR.
     +                 HDDEF_NAM2(1,K2) .EQ. IFU)  THEN
                CC = 'unsigned'
              END IF
            END IF

            CALL CHAPBC (CC, CA)

            IF (K4 .NE. 0)  THEN
              CALL CHAPPC (CC, '[')
              CALL CHAPPI (CC, K4)
              CALL CHAPPC (CC, ']')
            END IF

          ELSE IF (IDDEF_FLAG(K2) .EQ. LDDEF_RE1 .OR.
     +             IDDEF_FLAG(K2) .EQ. LDDEF_IN1)  THEN

            CC = 'int o'
            CALL CHAPPC (CC, CA)

          ELSE IF (IDDEF_FLAG(K2) .EQ. LDDEF_REM .OR.
     +             IDDEF_FLAG(K2) .EQ. LDDEF_INM)  THEN

            CC = 'int p'
            CALL CHAPPC (CC, CA)

          ELSE

            GO TO 30

          END IF

          CALL DDCSTS (CC)

 30     CONTINUE

 40     CONTINUE

        CALL DDCSTS ('} ' // CU)

        CC = '#define  J'
        CALL CHAPPC (CC, CU)
        CALL CHAPBC (CC, '(gcbank_.iq+artelink_.j')
        CALL CHAPPC (CC, CL)
        CALL CHAPPC (CC, ')')
        CALL DDCSTO (CC)

        CC(10:) = 'N'
        CALL CHAPPC (CC, CU)
        CALL CHAPPC (CC, '() N_U(J')
        L = LENOCC (CC)
        CALL CHAPPC (CC, CU)
        CALL CHAPPC (CC, ')')

        CALL DDCSTO (CC)

        CC(9:10) = 'NC'
        CC(L-2:L-2) = 'C'
        CALL DDCSTO (CC)

        CC = '#define'
        CALL CHAPBC (CC, CU)
        CALL CHAPPC (CC, '(i) (*((')
        CALL CHAPPC (CC, CU)
        CALL CHAPPC (CC, '*)(J')
        CALL CHAPPC (CC,CU)
        CALL CHAPPC (CC, '+2)+(i)-1))')
        CALL DDCSTO (CC)

        DO 70 K2 = K1 + 1, NDDEF()
          IF (IDDEF_FLAG(K2) .GE. LDDEF_INI .AND.
     +        IDDEF_FLAG(K2) .LE. LDDEF_NAM)  GO TO 80

          CALL CHHTOC (IQ(HQDDEF_NAM3(1,K2)), CR)
          CALL CHHTOC (IQ(HQDDEF_NAME(1,K2)), CA)
          CALL CUTOL (CA)

          IF (IDDEF_FLAG(K2) .EQ. LDDEF_RE1 .OR.
     +        IDDEF_FLAG(K2) .EQ. LDDEF_IN1)  GO TO 60
          IF (IDDEF_FLAG(K2) .NE. LDDEF_REM .AND.
     +        IDDEF_FLAG(K2) .NE. LDDEF_INM)  GO TO 70

          DO 50 K3 = K1 + 1, K2 - 1
            IF (IDDEF_FLAG(K3) .NE. LDDEF_REM .OR.
     +          IDDEF_FLAG(K3) .NE. LDDEF_INM)  GO TO 50
            IF (CHCMPN (IQ(HQDDEF_NAM3(1,K2)),
     +                  IQ(HQDDEF_NAM3(1,K3))) .NE. 0)  GO TO 60
 50       CONTINUE

C #include relation.h

          CC = '#include "auto/'
          CALL CHAPPC (CC, CR)
          CALL CHAPPC (CC, '.h"')
          CALL DDCSTO (CC)

 60       CC = '#define'
          C1 = 'p'
          IF (IDDEF_FLAG(K2) .EQ. LDDEF_RE1 .OR.
     +        IDDEF_FLAG(K2) .EQ. LDDEF_IN1)  C1 = 'o'
          CALL CHAPBC (CC, CU)
          CALL CHAPPC (CC, '_')
          CALL CHAPPC (CC, C1)
          L = LENOCC (CC)
          CALL CHAPPC (CC, CA)
          CALL CHAPPC (CC, '(i)')
          CALL CHAPBC (CC, CU)
          CALL CHAPPC (CC, '(i).')
          CALL CHAPPC (CC, C1)
          CALL CHAPPC (CC, CA)
          CALL DDCSTO (CC)

          IF (IDDEF_FLAG(K2) .EQ. LDDEF_REM .OR.
     +       IDDEF_FLAG(K2) .EQ. LDDEF_INM)  THEN

            CC(L:) = 'm'
            CALL CHAPPC (CC, CA)
            CALL CHAPPC (CC, '(i)')
            LL = LENOCC (CC)
            CALL CHAPBC (CC, 'M_R(i,J')
            CALL DDRTYP (K2, K3)
            IF (K3 .EQ. 4)  THEN
              CC(LL+4:LL+4) = '1'
              IF (IDDEF_FLAG(K2) .EQ. LDDEF_INM)  CC(LL+4:LL+4) = '2'
            END IF

            CALL CHAPPC (CC, CR)
            CALL CHAPPC (CC, ')')
            CALL DDCSTO (CC)

            CC(L:L) = 'x'
            CC(LL+2:LL+2) = 'X'
            CALL DDCSTO (CC)

          END IF

 70     CONTINUE

 80     CALL DDCSTO ('#endif')

 90   CONTINUE

C relations

      DO 100 K1 = 1, NDDNEW
        IF (IDDEF_FLAG(K1) .NE. LDDEF_REL)  GO TO 100

        CALL CHHTOC (IQ(HQDDEF_NAME(1,K1)), CU)
        CL = CU
        CALL CUTOL (CL)

        CALL DDOPEN (CU, 'h')
        CALL DDNDEF (CU, 'H')

        CC = '#define J'
        
        CALL CHAPPC (CC, CU)
        CALL CHAPBC (CC, '(gcbank_.iq+artelink_.j')
        CALL CHAPPC (CC, CL)
        CALL CHAPPC (CC, ')')
        CALL DDCSTO (CC)
        CALL DDCSTO ('#endif')

 100  CONTINUE

      END

************************************************************************
* End of DDATTC
************************************************************************
