//                              -*- Mode: C++ -*-
//: CmdCareDglev.C
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 12/6/97
// Last Update ........
//

#include "care/CmdCareDglev.hh"
#include "arte/ArteMessage.hh"
#ifndef ONLINE
#  include "digi/dglev.h"
#  include "gean/ZGESL.h"
#endif


#define GESL_ECAL  LGESL_ECA-1

/////////////// The function seen by kuip
#ifdef USEKUIP
extern "C" {
  void caredglev_(){
      arteMsg<<"CARE/DGLEV lev  is obsolete!"
             <<"  please use /HBDIGI/DGSET ECAL lev ";
      arteMsg.allp();
//    CmdCareDglev dglev;
//    dglev.readAndExe();
  }
}
#endif
/////////////// Static data definition

Dglev_t CmdCareDglev::level = FULLDIGI;

/////////////// CmdCareDglev class member function definition

CmdCareDglev::CmdCareDglev(){}
CmdCareDglev::~CmdCareDglev(){}

void CmdCareDglev::defValues(){
  setDglev(FULLDIGI);
}


//--
//   Execute stored command
void CmdCareDglev::execute(){}

#ifdef USEKUIP
//--
//   Read acommand from external
void CmdCareDglev::read(){
  int levelread;
  levelread = readInt();
  if( levelread>=NODIGI && levelread<=FULLDIGI){
    setDglev( (Dglev_t) levelread) ;
  } else {
    arteMsg<<" Care/DGLEV: input level out of valid range ["
	   <<NODIGI<<", "<<FULLDIGI<<"]";
    arteMsg.warn();
  }
}
#endif

Dglev_t CmdCareDglev::dglevel(){
#ifndef ONLINE
  level = (Dglev_t) dglev_.idglev[GESL_ECAL];
#endif
  return level;
}

void CmdCareDglev::dump(){
   arteMsg<<" Digitalization level :"<<level;
  arteMsg.allp();
}


Dglev_t CmdCareDglev::setDglev(Dglev_t lev){
  if( lev>=NODIGI && lev<=FULLDIGI)
    level = lev;
#   ifndef ONLINE
      dglev_.idglev[GESL_ECAL] = level;
#   endif
  //  execute();
  return level;
}

