//                              -*- Mode: C++ -*-
//: CmdCareMCSIM.hh
//
//
// Author: Pietro Faccioli   
// ECAL group 
// HERA-B experiment, Desy

// Last Update ........
//

#ifndef CMDCAREMCSIM_HH_
#define CMDCAREMCSIM_HH_

#include "care/CmdBase.hh" 
#include "care/ECALtypes.hh"

/**
class  CmdCareMcSim
  Class to deal with the MCSIM kuip command
*/

class CmdCareMcSim : public CmdBase {
public:
  /// Constructor
  CmdCareMcSim();
  /// Destructor
  virtual ~CmdCareMcSim();
  
  //-- Behavioural operations
  ///   Reset stored data to default values
  virtual void defValues();
  //--
  ///   Execute stored command
  virtual void execute();
# ifdef USEKUIP
  //--
  ///   Read a command from external source (KUIP)
  virtual void read();
# endif
  //--
  ///   Dump internal data
  virtual void dump();
  //--
  ///   Set Internal data
  static void setMcSim( int nrun, int nver, char *db);
  //--
  inline int Nrun() const { return dbmajor;};
  inline int Nvers() const { return dbminor;};
  inline char* DBname() const { return dbname;};
 
private:
  //--
  static int dbmajor;
  static int dbminor;
  static char * dbname;
};

#endif  //   CMDCAREMCSIM_HH_
