#ifndef _AUTO_HH_
#define _AUTO_HH_

struct ACGA;
struct ACTR;
struct BEAM;
struct CDIM;
struct CEFF;
struct CLEN;
struct CPDW;
struct CPMD;
struct CPMI;
struct CPMT;
struct CPOI;
struct CSMI;
struct CSPM;
struct CSSM;
struct CSUP;
struct CVES;
struct D4LT;
struct DCAL;
struct DDAQ;
struct DDEF;
struct DDST;
struct DEVT;
struct DFCS;
struct DFLT;
struct DIGB;
struct HITB;
struct HIDI;
struct MIMP;
struct MIDI;
struct DIHD;
struct DITR;
struct DKEY;
struct DMUP;
struct DMUT;
struct DMUX;
struct DOTR;
struct DPTC;
struct DRIC;
struct DSLT;
struct DSVD;
struct DTA1;
struct DTAR;
struct DTLT;
struct DTRD;
struct DTST;
struct ECBO;
struct ECHF;
struct ECHS;
struct ECHT;
struct ECPD;
struct ECSN;
struct ERRC;
struct EVFN;
struct EVHD;
struct EVHI;
struct EVRC;
struct EVTI;
struct FELD;
struct GCAL;
struct GESL;
struct GSGC;
struct GMAT;
struct GMGC;
struct GCCE;
struct GCGD;
struct GEDE;
struct GSGD;
struct GMGD;
struct OTMO;
struct GDOM;
struct GEHD;
struct GWAL;
struct GSGW;
struct GMGW;
struct NEDE;
struct GMND;
struct NCAL;
struct GMNC;
struct NWAL;
struct GMNW;
struct GMIX;
struct GNEI;
struct GSSL;
struct GTAR;
struct RTRA;
struct RTHI;
struct MIHI;
struct RSEG;
struct RSHI;
struct RHIT;
struct HIRH;
struct HITC;
struct RTHC;
struct MCAL;
struct MCHC;
struct RCCL;
struct RCHC;
struct HITL;
struct MARK;
struct MTRA;
struct MTMC;
struct MCIN;
struct MCME;
struct MVER;
struct MVME;
struct MEIO;
struct MEMA;
struct MEMO;
struct MEMS;
struct MF01;
struct MF02;
struct MF03;
struct MF04;
struct MF05;
struct MF06;
struct MF07;
struct MF08;
struct MF09;
struct MF10;
struct MF11;
struct MF12;
struct MF13;
struct MF14;
struct MF15;
struct MF16;
struct MF17;
struct MF18;
struct MF19;
struct MF20;
struct MF21;
struct MFHD;
struct MFLD;
struct MTMI;
struct MTCP;
struct MTMP;
struct TOPP;
struct MTTO;
struct RTMT;
struct RCMT;
struct BVER;
struct MVMT;
struct BTRA;
struct MTMT;
struct ETRA;
struct EVER;
struct MTMV;
struct MTRS;
struct NBEA;
struct NESL;
struct NSNC;
struct NSND;
struct NSNW;
struct NFLD;
struct NGHD;
struct NTAR;
struct OTCD;
struct OTDR;
struct OTGL;
struct OTTE;
struct OTTS;
struct OTTZ;
struct PTAD;
struct PTFD;
struct PXAF;
struct PTCH;
struct PXCA;
struct PTAL;
struct PTMD;
struct PXGM;
struct PTGE;
struct PXGA;
struct PTCE;
struct PXGC;
struct PXCC;
struct PTCR;
struct PXCM;
struct PXFC;
struct RTRC;
struct RCRS;
struct RSRH;
struct RITH;
struct RPNT;
struct RTRP;
struct RSRP;
struct RREL;
struct RRRT;
struct RVER;
struct RRRV;
struct RTRS;
struct RBEG;
struct RSRS;
struct REND;
struct RSLA;
struct RSLI;
struct RTAR;
struct RTTO;
struct RVRT;
struct RTRI;
struct SHCA;
struct SHPR;
struct STPR;
struct SPSH;
struct SHRC;
struct STRC;
struct SRSH;
struct SNAB;
struct SNAV;
struct SBSN;
struct SNAX;
struct SNSN;
struct SPAR;
struct SPAS;
struct SSEE;
struct SPSS;
struct SSTA;
struct STCA;
struct SUSI;
struct TAHB;
struct TAHD;
struct TATR;
struct TDEC;
struct TEMP;
struct TMP0;
struct TMP1;
struct TMP2;
struct TMP3;
struct TMP4;
struct TMP5;
struct TMP6;
struct TMP7;
struct TMP8;
struct TMP9;
struct XTRA;
struct XTRI;
struct YTRA;
struct YTRI;

/** global alignment constants */
struct ACGA
{
/** subdetector cmp number */
  int cmp;
/** shift in x */
  float dx;
/** shift in y */
  float dy;
/** shift in z */
  float dz;
/** shearing in XZ */
  float dtx;
/** shearing in YZ */
  float dty;
/** scaling factor for z */
  float fz;
/** 3x3 rotation matrix */
  float rot[9];
/** reference point for shearings and rotation */
  float z;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** target alignment constants */
struct ACTR
{
/** wire number */
  int wire;
/** radial shift perpendicular to the wire
in cm. This offset is defined for DTAR
values. */
  float dr;
/** z position of the wire in cm */
  float dz;
/** rotation around z axis */
  float sin;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** beam geometry */
struct BEAM
{
/** x-position of beam center */
  float x;
/** y-position of beam center */
  float y;
/** z-position of beam center */
  float z;
/** beam width along the axis x-prime */
  float dx;
/** beam width along the axis y-prime */
  float dy;
/** beam time width */
  float dt;
/** mean time value for generation */
  float time;
/** MC time smearing switch: on -> .ne. 0 */
  int tsw;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** riCh: riCh Single Planar MIrror
CDIM: riCh DIelectric Material

A dielectric material is defined by refering to
a definition of a refractive index in the table
CPOI. The definition starts in this table CPOI
in the row iref and consists out of nref
points. Similar in the table CPOI the absorption
loss is defined with nabs points starting in
row iabs. For the simulation of rayleigh scat-
tering the particle densisity has to be defined.
Setting it to -1 switches the simulation of
Rayleigh scattering of. A quick simulation of
the reflexion loss occuring, when the photon
crosses the material can be switched on, by set-
ting rlos to a value greater zero. To allow
book keeping a name of the material have to be
defined.
 */
struct CDIM
{
/** name of the material */
  char name[80];
/** reflexion loss */
  float rlos;
/** particle density (Rayleigh Scattering) */
  float dens;
/** absorption loss: number of defined points */
  int nabs;
/** absorption loss: index in table CPOI */
  int iabs;
/** refractive index: number of defined points */
  int nref;
/** refractive index: index in table CPOI */
  int iref;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** RICH: table with efficiencies
CEFF: riCh EFFiciency

pm-channel dependent efficiency scaling factors */
struct CEFF
{
/** only a value for the efficiency */
  float eff;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** riCh LENse system
CLEN: riCh LENse system

A dielectric material is defined by refering to
The absorption properties of the lens system is
 */
struct CLEN
{
/** identifier */
  int id;
/** wavelength-loss: number of defined points */
  int nwav;
/** wavelength-loss: index in table CPOI */
  int iwav;
/** angular-loss: number of defined points */
  int nang;
/** angular-loss: index in table CPOI */
  int iang;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** riCh: riCh Single Planar MIrror
CPDW: riCh Photon Detector Window

The Photon Detector Window has a rectangular box
with horizontal dimension (along the x-axis)
hdim and with a vertical dimension (along the
y-axis) vdim. The orientation in space is
describe by the assigned coordinate system.
The origin is positioned on the surface, which
is in contact with the radiator gas. imat
points to the row in the table CDIM, where the
properties of the dielectric material are
stored.
 */
struct CPDW
{
/** lower left corner */
  float orig[3];
/** horizontal dimension * x-direction */
  float xvec[3];
/** vertical   dimension * y-direction */
  float yvec[3];
/** thickness of the window */
  float t;
/** material: row in table CDIM */
  int imat;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** RICH: properties of a certain Photomultiplier

riCh PhotoMultiplier Definiton

A PM with serial number "seno" is described
by setting the type-name, like its defined in
the table CPMT and the channel to channel
efficiency variation.
 */
struct CPMD
{
/** serial number */
  char seno[16];
/** type specification */
  char type[16];
/** supermodule id */
  int isup;
/** supermodule row */
  int irow;
/** supermodule col */
  int icol;
/** 1st row in table CEFF */
  int efv0;
/** lens system identifier */
  int lens;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** riCh: riCh Planar MIrror

CPMI: riCh Planar MIrror
 */
struct CPMI
{
/** radius of hole for electron beam */
  float rec;
/** reflectivity: number of defined points */
  int nref;
/** reflectivity: index in table CPOI */
  int iref;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** RICH: definition of the properties of a pm type
CPMT: riCh PhotoMultiplier Type

A PM type has to have a certain name, which
is stored as type. The number of channels
in x and in y direction nx and ny has
to be specified, as well as the dimensions
xdiv and ydiv of the at the moment square
area, which one channel covers. The wavelength
dependent efficiency off a certain type is
stored beginning in the row ieff in table CPOI
and is defined using neff values. It is
assumed, that the efficiency of a certain pm
is good enough describe, by multiplying this
shape with a certain correction factor.
 */
struct CPMT
{
/** name of the PM type */
  char type[16];
/** number of channels in x-direction */
  int nx;
/** cell size in x-direction */
  float xdiv;
/** number of channels in y-direction */
  int ny;
/** cell size in y-direction */
  float ydiv;
/** number of bins */
  int neff;
/** starting row in table CPOI */
  int ieff;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
///
struct CPOI
{
/** any pair of floats */
  float x[2];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** riCh: riCh Spherical MIrror

CSMI: riCh Spherical MIrror

The spherical mirror consists out of many single
spherical mirrors, that are stored in the CSSM
table. Here only some general information is
stored. */
struct CSMI
{
/** horizontal tiling */
  float ah;
/** horizontal tiling: start angle */
  float ah0;
/** vertical tiling */
  float av;
/** vertical tiling: start angle */
  float av0;
/** radius of curvature */
  float r;
/** radius of hole around proton beam */
  float rpc;
/** radius of hole around electron beam */
  float rec;
/** reflectivity: number of defined points */
  int nref;
/** reflectivity: index in table CPOI */
  int iref;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** riCh: riCh Single Planar MIrror

CSPM: riCh Single Planar MIrror
A Single Planar MIrror has a rectangular surface
with horizontal dimension (along the x-axis) and
with a vertical dimension (along the y-axis).
The orientation in space is describe by the
assigned coordinate system. "iref" points to the
row in the table CPOI, where the reflectivity is
stored.
 */
struct CSPM
{
/** lower left corner */
  float orig[3];
/** horizontal dimension * x-direction */
  float xvec[3];
/** vertical   dimension * y-direction */
  float yvec[3];
/** reflectivity: number of defined points */
  int nref;
/** reflectivity: index in table CPOI */
  int iref;
/** row */
  int row;
/** column */
  int col;
/** mirror type name (HEX,FIVE,FOUR,...) */
  char type[8];
/** name */
  char name[20];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** riCh: riCh Single Spherical Mirror
CSSM: riCh Single Spherical Mirror
        -  -      -         -

A Single Spherical MIrror is a cut out of a
sphere with radius ||norm||. The general
boundary is a regular hexagon. The smaller
horizontal (along the x-direction) extension
is 2*||xvec||.The normal direction points to
the center of  curvature. The origin of the
coordinate system is the center of the hexagon
and has to be placed on the mirror surface! The
hexagon fits into a circle with radius hdia.
The mirrors exist is various versions, which all
are some cuts of the general hexagonal boundary.
The coordinate system defined above is stored in
the row icor in the table CCOR. Similar iref
points to the row in the table CPOI, where the
reflectivity is stored. */
struct CSSM
{
/** origin */
  float orig[3];
/** radius * normal direction */
  float norm[3];
/** horizontal dimension/2 * horizontal direction */
  float xvec[3];
/** mirror type name (HEX,FIVE,FOUR,...) */
  char type[8];
/** half of the diameter the mirror */
  float hdia;
/** reflectivity: number of defined points */
  int nref;
/** reflectivity: index in table CPOI */
  int iref;
/** row */
  int row;
/** column */
  int col;
/** name */
  char name[20];
/** number of corners */
  int ncor;
/** max. 6 corners */
  float corn[18];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** RICH: definition of a supermodule
CSUP: riCh SUPermodule

CSUP describe the rectangular front surface of a
supermodule. The orientation in space is defined
by the three vectors x0,ex=xvec/||xvec||,
ey=yvec/||yvec||. The norm ||xvec|| and ||yvec||
defining the outer dimensions of the rectangle.
The supermodule is devide in matrice like cells.
This is done by setting nx=12, ny=36,
xdiv=ydiv=36 mm. */
struct CSUP
{
/** origin */
  float x0[3];
/** x-direction * xdim */
  float xvec[3];
/** y-direction * ydim */
  float yvec[3];
/** number of pms/cells in x-direction (rows) */
  int nx;
/** cell size in x-direction */
  float xdiv;
/** number of pms/cells in y-direction (columns) */
  int ny;
/** cell size in y-direction */
  float ydiv;
/** supermodule identifier */
  int id;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** riCh: VESsel
CVES: riCh VESsel

The information needed to trace the photons in
the RICH Vessel is stored. This is the dimen-
sions of the proton beam shroud and the electron
beam shroud (they are tubes) as well as the pro-
perties of the radiator. The radiator is descri-
bed as a general dielectric material. The infor-
mation you can find in the row irad of the
table CDIM */
struct CVES
{
/** center proton shroud */
  float pori[3];
/** axis   proton shroud */
  float pez[3];
/** radius proton shroud */
  float prad;
/** length proton shroud */
  float plen;
/** center electron shroud */
  float eori[3];
/** axis   electron shroud */
  float eez[3];
/** radius electron shroud */
  float erad;
/** length electron shroud */
  float elen;
/** radiator: row in table CDIM */
  int irad;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Level 4 */
struct D4LT
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** calorimeter digits */
struct DCAL
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** data acquisition digits */
struct DDAQ
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** data definition */
struct DDEF
{
/** flag: see sequence ZDDEFP */
  int flag;
/** attribute, relation, etc: column */
  int col;
/** table: extension; attribute: dimension; */
  int dim;
/** table,relation: flag: 0: table;
-1: subord.table; -2 parallel table
range: lower boundary for integer */
  int rflg;
/** Zebra division: 1=const; 2=event;
range: upper boundary for integer */
  int div;
/** lower boundary for float */
  float flo;
/** upper boundary for float */
  float fup;
/** accuracy for float */
  float fac;
/** name */
  char name[80];
/** menu name / format */
  char nam2[80];
/** relation name */
  char nam3[80];
/** comment */
  char text[80];
/** 1: attribute is a Leda key; 0: no Leda key */
  int key;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** header for DST digit tables (i.e. NOT DEVT) */
struct DDST
{
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** event digits */
struct DEVT
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** fast control system digits */
struct DFCS
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** 1st level trigger digits */
struct DFLT
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** MC digitization for all detectors except ECAL */
struct DIGB
{
/** strip / wire / pad identifier */
  int id;
/** Quantity: amplitude for SVD, MSGC
drift time for outer tracker
0 for RICH, TRD, MUON */
  float q;
/** many digits to one hit */
  ArtePointer<HITB> hitb;
/** many digits to many mimps */
  ArteManRelationPointer<MIDI,MIMP> mimp;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** header for measured digits */
struct DIHD
{
/** Bunch crossing number
from 1st FED output */
  int bx;
/** First Level Trigger number
from SLB output */
  int flt;
/** Second Level Trigger number
from DAQ event output */
  int slt;
/** Second Level Buffer number
from SLB output */
  int slb;
/** Component mask
from DAQ event output */
  int cmsk;
/** Event mask
from DAQ event output */
  int emsk;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Inner Tracker digits */
struct DITR
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** keys */
struct DKEY
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Muon Pad Chamber digits */
struct DMUP
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Muon Tube Chamber digits */
struct DMUT
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Muon Pixel Chamber digits */
struct DMUX
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Outer Tracker digits */
struct DOTR
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** High-pt chamber digits */
struct DPTC
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** RICH digits */
struct DRIC
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** 2nd level trigger digits */
struct DSLT
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Silicon Vertex Detector digits */
struct DSVD
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** target geometry - copy of table DTAR */
struct DTA1
{
/** wire material */
  int cmp;
/** wire number */
  int wnr;
/** wire thickness along the axis x */
  float dx;
/** wire thickness along the axis y */
  float dy;
/** wire thickness along the axis z */
  float dz;
/** x-position of wire center */
  float x;
/** y-position of wire center */
  float y;
/** z-position of wire center */
  float z;
/** 3*3 rotation matrix wire system to lab system */
  float rot[9];
/** multiple scattering angle for 1 GeV particles */
  float ms;
/** maximum of vertex distribution in x direction */
  float x0bm;
/** maximum of vertex distribution in y direction */
  float y0bm;
/** width of vertex distribution in x direction */
  float sxbm;
/** width of vertex distribution in y direction */
  float sybm;
/** shape integer (same as in GEDE) */
  int shap;
/** Station and wire name - 1i,1o,2t,2b for
Station 1 inner, 1 outer, 2 top 2, bottom etc */
  char name[4];
/** effectivity (eff = 0. means wire out) */
  float eff;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Target digits */
struct DTAR
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** 3rd level trigger digits
(whatever this means - H.A.) */
struct DTLT
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Transition Radiation Detector digits */
struct DTRD
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** any digits for test purposes */
struct DTST
{
/** any bit sequence
row 1: Flag */
  char bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Ecal readout BOard data */
struct ECBO
{
/** FED IDentification */
  int fdid;
/** Board status */
  int stat;
/** Board number [0,200] */
  int numb;
/** Shark link index */
  int link;
/** Index of connected cell
For each channed of the board there is
an integer number that point out a
single connected cell.
value -1 means no connection */
  int chan[32];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Ecal readout CHannel Calibration table (Fast)
 Fast update rate */
struct ECHF
{
/** status of the channel: bit field
see $HB/dev/care/include/ECHF_status.hh */
  int stat;
/** PEDestal Fast */
  float pedf;
/** Pedestal width */
  float wid;
/** Sensitivity in GeV/ADC channel */
  float sens;
/** Error on sensitivity in GeV/ADC channel */
  float esen;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Ecal readout CHannel Calibration table (Slow)
Geometry definitions */
struct ECHS
{
/** Channel indeces in the matrix convensions */
  int mod;
/** X position of the cell */
  float x;
/** Y position of the cell */
  float y;
/** Radial distance from beam pipe */
  float r;
/** Readout board FED ID */
  int fdid;
/** Readout channel identifier [0,31] */
  int chan;
/** Pointer to an ECBO bank entry */
  ArtePointer<ECBO> ecbo;
/** 6 calibration constants */
  float pcal[6];
/** 6 calibration const for error */
  float ecal[6];
/** PEDestal slow */
  float peds;
/** Threshold */
  float thrs;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Ecal Hot Channel table */
struct ECHT
{
/** Status of the channel */
  int stat;
/** Hot channel index (GCCE numbering) */
  int chan;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Ecal Pedestal table */
struct ECPD
{
/** Status of the channel (bitfield) */
  int stat;
/** PEDestal Fast */
  float pedf;
/** Pedestal width */
  float wid;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Ecal Sensitivity table */
struct ECSN
{
/** Status of the channel (bitfield) */
  int stat;
/** Sensitivity (GeV/ADC channel) */
  float sens;
/** Error on sensitivity (GeV/ADC channel) */
  float esen;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** error count */
struct ERRC
{
/** Text of the error message as appearing in the
1st CALL with the given error identifier. */
  char text[80];
/** Error identifier =
pointer to 1st argument in MEERRC (563415,...) */
  int id;
/** Message counter */
  int cnt;
/** Maximum number of print-outs */
  int prnt;
/** Fatal error condition when error count expires
this number */
  int ftl;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** DST etc. file names */
struct EVFN
{
/** file name */
  char name[80];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** event header bank */
struct EVHD
{
/** event number */
  int evt;
/** run number */
  int run;
/** experiment number
exp > 0: real data
exp < 0: Monte Carlo; specifies the lab:
     -1: DESY HH
     -2: DESY Zeuthen
    ...: not yet specified */
  int exp;
/** measurement/creation date (format: yymmdd) */
  int date;
/** measurement/creation time (format: hhmmss) */
  int time;
/** version of the mag field MC and reco */
  float vfld;
/** event classification flag from/to DST */
  int flagdst;
/** major key for constants on data base */
  int dbmajor;
/** minor key for constants on data base */
  int dbminor;
/** not used - historical reasons */
  int unused[2];
/** event classification flag from/to EDIR
if no EDIR: same as flagdst */
  int flag;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** hits per detector component */
struct EVHI
{
/** hits / detector component */
  int hit;
///
  int rhit;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** event reconstruction information */
struct EVRC
{
/** IP address of the farm node */
  unsigned int ipaddr;
/** error mask */
  unsigned int errmask;
/** reconstruction date and time (Unix seconds) */
  int date;
/** time consumption on farm in sec. */
  float cputime;
/** ARTE version */
  float artevers;
/** alignment/calibration mask
bitmask using component.h definitions
      0x00000001 for global alignment
  COMP_M_xxx       is set if constants are
                   available/read in
  COMP_M_xxx << 16 is set if constants are read
                   in by key mechanism */
  unsigned int alca;
/** mean of drift times in OTR */
  float ottmean;
/** width of drift times in OTR */
  float ottwidth;
/** cats flag ... to be defined */
  int cats;
/** holmes flag ... to be defined */
  int holmes;
/** ranger flag: 0: switched off;
-1: not executed due to inconsistency in data;
1: ok */
  int ranger;
/** riter flag ... to be defined */
  int riter;
/** rire flag ... to be defined */
  int rire;
/** rise flag ... to be defined */
  int rise;
/** care flag ... to be defined */
  int care;
/** trd flag ... to be defined */
  int trd;
/** mureca flag ... to be defined */
  int mureca;
/** murecb flag ... to be defined */
  int murecb;
/** marple flag ... to be defined */
  int marple;
/** event selection mask; needs further specification */
  unsigned int selmask;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** event reconstruction time consumption (in sec) */
struct EVTI
{
/** track reconstruction in the VDS */
  float vds;
/** track reconstruction in the main tracker */
  float ranger;
/** Ranger refit */
  float refit;
/** RICH reconstruction */
  float rich;
/** ECAL reconstruction */
  float ecal;
/** TRD reconstruction */
  float trd;
/** MUON reconstruction */
  float muon;
/** MARPLE track match */
  float marple;
/** vertex reconstruction */
  float vertex;
/** particle identification */
  float pid;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** bank of magnetic field (temporary - const field) */
struct FELD
{
/** x-position of field center */
  float x;
/** y-position of field center */
  float y;
/** z-position of field center */
  float z;
/** radius of field region */
  float r;
/** strength of field (in kG) */
  float h;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
///
struct GCAL
{
/** number of subsectors per block
1: outer  calorimeter - block division 1*1
2: middle calorimeter - block division 2*2
5: inner  calorimeter - block division 5*5 */
  int ncl;
/** block number within the superlayer (packed) */
  int sec;
/** x of the left edge of the block */
  float xmin;
/** y of the right edge */
  float xmax;
/** y of the lower edge */
  float ymin;
/** y of the upper edge */
  float ymax;
/** z of the front side */
  float zmin;
/** z of the rear side */
  float zmax;
/** additional word for complicated shapes */
  float xmad;
/** additional word for complicated shapes */
  float ymad;
/** additional word for complicated shapes */
  float zmad;
/** light efficiency */
  float eff;
/** multiple scattering angle for 1 GeV particles */
  float ms;
/** detector component (see table GESL) */
  int cmp;
/** one super-layer <-> many detector planes */
  ArtePointer<GESL> gesl;
/** one material <-> many detector planes */
  ArtePointer<GMAT> gmat;
/** Geant volume name */
  char gvol[4];
/** first cell of given module in GCCE */
  int fcl;
/** first MIMP */
  ArteTableIterator<MIMP> mim1;
/** last MIMP */
  ArteTableIterator<MIMP> miml;
/** first DIGB */
  ArteTableIterator<DIGB> dig1;
/** last DIGB */
  ArteTableIterator<DIGB> digl;
/** first HITB */
  ArteTableIterator<HITB> hit1;
/** last HITB */
  ArteTableIterator<HITB> hitl;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** ECAL Cell Informations */
struct GCCE
{
/** Cell Identification in GCAL numbering */
  int ceid;
/** Number of neibourings in the GNEI table */
  int neib;
/** Neibourings position in the table GNEI */
  int adrs;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Ecal Cell Grid */
struct GCGD
{
/** index of the first cell contained in the module */
  int cidx;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** detector geometry: planes */
struct GEDE
{
/** detector component (see table GESL) */
  int cmp;
/** layer number within the superlayer */
  int lay;
/** sector number */
  int sec;
/** detector shape */
  int shp;
/** x of the left edge of the detector */
  float xmin;
/** y of the right edge */
  float xmax;
/** y of the lower edge */
  float ymin;
/** y of the upper edge */
  float ymax;
/** z of the front side */
  float zmin;
/** z of the rear side */
  float zmax;
/** outer tracker: x of the left edge
of the sensitive area
muon: the size of sensitive area near pad */
  float sxmn;
/** outer tracker: y of the right edge
muon: efficiency in the gap between pads */
  float sxmx;
/** outer tracker: y of the lower edge
muon: y-distance from chamber edge to pad */
  float symn;
/** outer tracker: y of the upper edge
muon: y-gap between pads */
  float symx;
/** cosine of the wire angle with respect to y-axis */
  float cos;
/** sine of the wire angle with respect to y axis */
  float sin;
/** 3 by 3 rotation matrix */
  float rot[9];
/** measurement accuracy (for MC digitization) */
  float acc;
/** hit efficiency (for MC digitization) */
  float eff;
/** max drift distance or double hit resolution */
  float dod;
/** pitch */
  float pit;
/** multiple scattering angle **2 for 1 GeV particles */
  float ms;
/** SVD   1   d_min: distance of first wire to z axis
 */
  float xfw[4];
/** outer tracker: z of first wire in sublayer 1...4
muon: 1 - z of wires
muon: 2 - z of pads
muon: 3 - y-size of first (small) pad or pixel
muon: 4 - y-size of large pads */
  float zfw[4];
/** outer tracker: number of wires in sublayer 1...4
muon: 1 - number of wires or pixels in x-dir
muon: 2 - number of pixels in y-direction
muon: 3 - number of connected pixels in x-dir
muon: 4 - number of connected pixels in y-dir */
  int nwi[4];
/** number of sublayers in a segment */
  int nsl;
/** one super-layer <-> many detector planes */
  ArtePointer<GESL> gesl;
/** one material <-> many detector planes */
  ArtePointer<GMAT> gmat;
/** number of walls connected to this detector */
  int nwl;
/** first wall connected to this detector */
  int fwl;
/** additional word for comp. geometrical shapes */
  float xmad;
/** additional word for comp. geometrical shapes */
  float ymad;
/** additional word for comp. geometrical shapes */
  float zmad;
/** lower boundary in y for wires in sublayer 1...4 */
  float y1w[4];
/** upper boundary in y for wires in sublayer 1...4 */
  float y2w[4];
/** Geant volume name (up to 4 characters) */
  char gvol[4];
/** Hardware code for the given detector */
  char hwc[12];
/** energy loss of a mip in the given detector */
  float dedx;
/** Geant copy number - so called user number */
  int gcop;
/** noise */
  float noise;
/** resolution of the alignment */
  float ares;
/** first MIMP */
  ArteTableIterator<MIMP> mim1;
/** last MIMP */
  ArteTableIterator<MIMP> miml;
/** first DIGB */
  ArteTableIterator<DIGB> dig1;
/** last DIGB */
  ArteTableIterator<DIGB> digl;
/** first HITB */
  ArteTableIterator<HITB> hit1;
/** last HITB */
  ArteTableIterator<HITB> hitl;
/** one OT module (readout) in gede --> one OT module */
  ArtePointer<OTMO> otmo;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** header for the detector geometry */
struct GEHD
{
/** version number for the geometry constants */
  float geom;
/** version number of the hbgean program producing
the constants */
  float gean;
/** date */
  int date;
/** time */
  int time;
/** version number for the geometry constants
the vector is given by gehd.geom(LGESL_... ,I)
LGESL_MOTH = 30 = overall geometry = datt geom
LGESL_RPOT = 29 = Roman Pot
LGESL_TAR  = 11 = target
LGESL_SIL  = 1  = SVD
LGESL_MAG  = 28 = Magnet elements
LGESL_FLD  = 12 = magnetic field
LGESL_PPIP = 27 = Proton beam pipe
LGESL_EPIP = 26 = Electron beam pipe
LGESL_WCH  = 2  = OTR
LGESL_MSG  = 3  = ITR
LGESL_PTC  = 4  = PTL
LGESL_RIC  = 5  = RICH
LGESL_TRSL = 24 = TRD
LGESL_ECA  = 7  = ECA
LGESL_MUON = 25 = MUON System
LGESL_HOD1 = 13 = new trigger hodoscope
LGESL_HOD2 = 14 = trigger hodoscope
LGESL_HOD3 = 15 = last (in z) hodoscope */
  float gevs[32];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** detector geometry: superlayers */
struct GESL
{
/** superlayer name (up to 4 characters) */
  char name[4];
/** detector component:
 1 SIL silicon vertex detector
 2 WCH wire chambers
 3 MSG microstrip chambers
 4 PTC chambers (pi-pi trigger)
 5 RIC Cerenkov counter
 6 TRD forward TRD
 7 CAL electromagnetic calorimeter
 8 MUO muon outer chambers
 9 MUX muon central chambers
11 TAR target
12 FLD field
13 HOD1 hodoscope 1
14 HOD2 hodoscope 2
15 HOD3 hodoscope 3
25 MUON system
26 Electron pipe
27 Proton pipe
28 Magnet
29 Roman Pot */
  int cmp;
/** shape of the superlayer
 1 box
 3 trapezoid (ie. x and y varying along z)
 5 tube
 9 spherical shell */
  int shp;
/** nth superlayer of this component */
  int nsl;
/** magnet flag (0 = no mag. field) */
  int mfl;
/** number of layers */
  int lay;
/** box:  left  boundary in x
trap: left boundary in x at smaller z
tube and sphere: inner radius */
  float x1;
/** box:  right boundary in x
trap: right boundary in x at smaller z
tube and sphere: x-pos. of tube/sphere center */
  float x2;
/** box:  lower boundary in y
trap: lower boundary in y at smaller z
tube and sphere : outer radius */
  float y1;
/** box:  upper boundary in y
trap: upper boundary in y at smaller z
tube and sphere: y-pos. of tube/sphere center */
  float y2;
/** z of begin of superlayer */
  float z1;
/** z of end of superlayer */
  float z2;
/** trap: difference in x to x1 at bigger z */
  float dx;
/** trap: difference in y to y1 at bigger z */
  float dy;
/** number of detector planes (nlayers*nsectors) */
  int npl;
/** first det. plane belonging to this superlayer */
  int fpl;
/** number of walls in this superlayer */
  int nwl;
/** first wall belonging to this superlayer */
  int fwl;
/** layer types/sequences */
  int ltyp;
/** radiation length */
  float radl;
/** relation to detector planes */
  ArteInvOneRelationPointer<GSGD,GEDE> gede;
/** relation to calorimeter planes */
  ArteInvOneRelationPointer<GSGC,GCAL> gcal;
/** relation to walls */
  ArteInvOneRelationPointer<GSGW,GWAL> gwal;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Table of Materials */
struct GMAT
{
/** material name */
  char name[12];
/** average A */
  float a;
/** Z */
  float z;
/** density */
  float dens;
/** radiation length */
  float radl;
/** absortion length */
  float absl;
/** number of components in mixtures
=0 = w only one component
>0 = w is the proportional weight in mixt
<0 = w is the number of atoms in a molecule */
  int nmix;
/** flag
1 = nonsensitive nonmagnetic medium
2 = nonsensitive magnetic medium
4 = sensitive nonmagnetic medium
8 = sensitive magnetic medium */
  int flag;
/** number of row for first component in table gmix */
  ArtePointer<GMIX> gmix;
/** energy loss for MIPS */
  float loss;
/** relation to detector planes */
  ArteInvOneRelationPointer<GMGD,GEDE> gede;
/** relation to calorimeter planes */
  ArteInvOneRelationPointer<GMGC,GCAL> gcal;
/** relation to walls */
  ArteInvOneRelationPointer<GMGW,GWAL> gwal;
/** relation to detector planes for nominal geometry */
  ArteInvOneRelationPointer<GMND,NEDE> nede;
///
  ArteInvOneRelationPointer<GMNC,NCAL> ncal;
/** relation to walls for nominal geometry */
  ArteInvOneRelationPointer<GMNW,NWAL> nwal;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Table of components of material mixtures */
struct GMIX
{
/** component name */
  char name[12];
/** A */
  float a;
/** Z */
  float z;
/** weights of this component */
  float w;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Adjacent ECAL cells references */
struct GNEI
{
/** code information about neighbors */
  int ncod;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Selection flags for superlayers */
struct GSSL
{
/** flag */
  int flag;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** target geometry */
struct GTAR
{
/** wire material */
  int cmp;
/** wire number */
  int wnr;
/** wire thickness along the axis x */
  float dx;
/** wire thickness along the axis y */
  float dy;
/** wire thickness along the axis z */
  float dz;
/** x-position of wire center */
  float x;
/** y-position of wire center */
  float y;
/** z-position of wire center */
  float z;
/** 3*3 rotation matrix wire system to lab system */
  float rot[9];
/** multiple scattering angle for 1 GeV particles */
  float ms;
/** maximum of vertex distribution in x direction */
  float x0bm;
/** maximum of vertex distribution in y direction */
  float y0bm;
/** width of vertex distribution in x direction */
  float sxbm;
/** width of vertex distribution in y direction */
  float sybm;
/** shape integer (same as in GEDE) */
  int shap;
/** Station and wire name - 1i,1o,2t,2b for
Station 1 inner, 1 outer, 2 top 2, bottom etc */
  char name[4];
/** effectivity (eff = 0. means wire out) */
  float eff;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** walls */
struct GWAL
{
/** detector shape */
  int shp;
/** x of the left edge */
  float xmin;
/** y of the right edge */
  float xmax;
/** y of the lower edge */
  float ymin;
/** y of the upper edge */
  float ymax;
/** z of the front side */
  float zmin;
/** z of the rear side */
  float zmax;
/** additional word for complicated shapes */
  float xmad;
/** additional word for complicated shapes */
  float ymad;
/** additional word for complicated shapes */
  float zmad;
/** 3 by 3 rotation matrix */
  float rot[9];
/** multiple scattering angle **2 for 1 GeV particles */
  float ms;
/** number of sublayers in a segment */
  int nsl;
/** one super-layer <-> many walls */
  ArtePointer<GESL> gesl;
/** one material <-> many walls */
  ArtePointer<GMAT> gmat;
/** detector connected to this wall */
  ArtePointer<GEDE> gede;
/** Geant volume name (up to 4 characters) */
  char gvol[4];
/** energy loss of a mip in the given wall */
  float dedx;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** hits in all detectors except ECAL */
struct HITB
{
/** z coordinate */
  float z;
/** x coordinate */
  float x;
/** y coordinate (for pad chambers only)
or drift time */
  float y;
/** Quantity: amplitude for SVD, MSGC
drift distance for TRD, Outer Tracker
0 for RICH, MUON */
  float q;
/** Resolution of quantity Q */
  float r;
/** detector plane */
  ArtePointer<GEDE> gede;
/** many hits to many tracks */
  ArteManRelationPointer<RTHI,RTRA> rtra;
/** many hits to many MC impact points */
  ArteManRelationPointer<MIHI,MIMP> mimp;
/** many hits to manytrack segments */
  ArteManRelationPointer<RSHI,RSEG> rseg;
/** channel identifier */
  int chid;
/** many digits to one hit */
  ArteInvOneRelationPointer<HIDI,DIGB> digb;
/** one fitted hit to many reconstructed hits */
  ArteInvOneRelationPointer<HIRH,RHIT> rhit;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** hits in ECAL */
struct HITC
{
/** x coordinate */
  float x;
/** y coordinate (for pad chambers only) */
  float y;
/** energy */
  float q;
/** energy resolution */
  float r;
/** detector cell */
  ArtePointer<GCCE> gcce;
/** ADC value read (-pedestal) */
  float adc;
/** many hits to many tracks */
  ArteManRelationPointer<RTHC,RTRA> rtra;
/** many ECAL impact points to many hits */
  ArteManRelationPointer<MCHC,MCAL> mcal;
/** many clusters to many ECAL hitc */
  ArteManRelationPointer<RCHC,RCCL> rccl;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** ECAL hits for lumi */
struct HITL
{
/** Ecal Cell id */
  int cell;
/** Ecal Cell energy in GeV */
  float ener;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** SUSi hit Mark Table */
struct MARK
{
/** Hit is used for SUSi Reconstruction */
  int used;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** MC calorimeter energy deposition */
struct MCAL
{
/** energy release of particle in the given block */
  float de;
/** block plane in table GCAL */
  int gcal;
/** one MTRA to many MCAL */
  ArtePointer<MTRA> mtra;
/** many hits to many MC impact points */
  ArteInvManRelationPointer<MCHC,HITC> hitc;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** MC general information */
struct MCIN
{
/** mixing information: iijjkkll = ii interactions
from file evin1 + jj from file evin2 + ...
 ... file evin4 */
  char mix[4];
/** version of the geometry constants */
  float vgeo;
/** GEANT version */
  float vgea;
/** random seed for GEANT */
  int rgea[2];
/** random seed for digitisation */
  int rdig[2];
/** number of tracks from particle generator */
  int nmtr;
/** number of vertices from particle generator */
  int nmve;
/** random seed for L1SIMU */
  int rl1s[2];
/** long MC: bit flags */
  char fmcl[4];
/** short MC: bit flags */
  char fmcs[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** MC data for event mixing */
struct MCME
{
/** event number */
  int evt;
/** run number */
  int run;
/** experiment number. For unmixed events: the same
as the corresponding number in table EVHD */
  int exp;
/** flag for the generated physics process.
   0 ...  999 light quarks u,d,s
1000 ... 1999 c cbar or J/psi not from b-decay
2000 ... 2999 b bbar with J/psi
         2000: J/psi K0s
3000 ... 3999 b bbar with bs or b-baryon
4000 ... 4999 b bbar with semileptonic b-decay
Further specification necessary ! */
  int phy;
/** random seed for particle generator */
  int rlun[2];
/** primary vertex */
  ArtePointer<MVER> mver;
/** version of the particle generator (LUND) */
  float vlun;
/** generation time of the subevent (sec) */
  float time;
/** weight */
  float wgth;
/** wire number 1...8 */
  int wire;
/** wire material (characters as for Fritiof) */
  char mat[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** input/output files */
struct MEIO
{
/** file name */
  char name[120];
/** stream name */
  char stream[80];
/** Zebra options for FZFILE */
  char zoption[8];
/** logical unit associated to bit N (=1...32) */
  char bit;
/** 0: no io package; 1: Zebra IO
2: gpack */
  int pack;
/** IO status (from INQUIRE, OPEN, CLOSE, REWIND) */
  int iostat;
/** -1: unused; 0 reserved; 1: file name specified;
2: open at begin of file; 3: open;
4: end-of-file/closed (?); 5: closed. */
  int flag;
/** 0: sequential data set; >0: record length */
  int rleng;
/** 1: formatted IO; 0: unformatted; -1: unknown */
  int format;
/** pointer to concatenated data set */
  int concat;
/** pointer to to the file currently being open */
  int current;
/** number of records */
  int nrec;
/** next table on input file */
  int table;
/** flag: skip */
  int fskip;
/** number of events to be skipped */
  int nskip;
/** pointer from cfopen */
  int cfopen;
/** maximum number of bytes for output files */
  float maxout;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** DD: attribute description */
struct MEMA
{
/** attribute name */
  char name[80];
/** attribute type:
 */
  int type;
/** relation: pointer to relation */
  int rela;
/** relation: pointer to the other table */
  int relt;
/** relation: position inside table */
  int relp;
/** 1: attribute is a Leda key; 0: no Leda key */
  int key;
/** lower boundary for type integer */
  int ilow;
/** upper boundary for type integer
number of bits for type bit */
  int iupp;
/** lower boundary for type real */
  float flow;
/** upper boundary for type real */
  float fupp;
/** accuracy for type real */
  float accu;
/** minimum value */
  int imin;
/** maximum value */
  int imax;
/** minimum value
fmax must be the last attribute !!! */
  float fmin;
/** maximum value */
  float fmax;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** data description: tables */
struct MEMO
{
/** table name */
  char name[80];
/** Zebra format */
  int fmt;
/** bits for default I/O units */
  char iod[4];
/** bits for active I/O units */
  char ioa[4];
/** Zebra division; IXCONS or IXEVNT */
  int div;
/** number of columns/row */
  int col;
/** number of output columns */
  int ocol;
/** extend table by this value */
  int ext;
/** -2: parallel table; -1: subord.; 0: other table
1: one-one; 2: one-many; 4: many-many */
  int flag;
/** positions for storing relations; */
  int pos[2];
/** superior tables */
  int sup[2];
/** pointer to SUBT (subordinate tables) */
  int sub1;
/** pointer to SUBT (subordinate tables)
ISUBT_SUB(IMEMO_SUB1(irow)...
 ... ISUBT_SUB(IMEMO_SUB2(irow) */
  int sub2;
/** pointer to attribute description MEMA */
  ArtePointer<MEMA> mema;
/** # bookings */
  int book;
/** # droppings */
  int drop;
/** # extensions */
  int extn;
/** maximum number of rows */
  int maxr;
/** accumulated number of rows */
  int accrow;
/** 2nd moment */
  float mom2;
/** # read from input files */
  int nin;
/** # written to output files
!!!! NOUT must be the last word !!!! */
  int nout;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** subordinate tables */
struct MEMS
{
/** Link number of a subordinate bank */
  int sub;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 01 */
struct MF01
{
/** coefficient of polinomial */
  float para[3];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 02 */
struct MF02
{
/** coefficient of polinomial */
  float para[24];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 03 */
struct MF03
{
/** coefficient of polinomial */
  float para[24];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 04 */
struct MF04
{
/** coefficient of polinomial */
  float para[24];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 05 */
struct MF05
{
/** coefficient of polinomial */
  float para[24];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 06 */
struct MF06
{
/** coefficient of polinomial */
  float para[24];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 07 */
struct MF07
{
/** field at interpolation knot */
  float para[1];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 08 */
struct MF08
{
/** coefficient of polinomial */
  float para[24];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 09 */
struct MF09
{
/** field at interpolation knot */
  float para[1];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 10 */
struct MF10
{
/** field at interpolation knot */
  float para[1];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 11 */
struct MF11
{
/** coefficient of polinomial */
  float para[24];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 12 */
struct MF12
{
/** field at interpolation knot */
  float para[1];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 13 */
struct MF13
{
/** field at interpolation knot */
  float para[1];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 14 */
struct MF14
{
/** coefficient of polinomial */
  float para[24];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 15 */
struct MF15
{
/** field at interpolation knot */
  float para[1];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 16 */
struct MF16
{
/** field at interpolation knot */
  float para[1];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 17 */
struct MF17
{
/** coefficient of polinomial */
  float para[24];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 18 */
struct MF18
{
/** field at interpolation knot */
  float para[1];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 19 */
struct MF19
{
/** coefficient of polinomial */
  float para[24];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 20 */
struct MF20
{
/** coefficient of polinomial */
  float para[60];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** parameter of the magnetic field region 21 */
struct MF21
{
/** coefficient of polinomial */
  float para[30];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** header for magnetic field constants */
struct MFHD
{
/** version number */
  float vers;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** regions for the magnetic field */
struct MFLD
{
/** method of field evaluation */
  int meth;
/** number of region subdivision on x */
  int nr_x;
/** number of region subdivision on y */
  int nr_y;
/** number or region subdivision on z */
  int nr_z;
/** size of region subdivision on x */
  float dr_x;
/** size of region subdivision on y */
  float dr_y;
/** size of region subdivision on z */
  float dr_z;
/** lower bound of region on x */
  float xmin;
/** upper bound of region on x */
  float xmax;
/** lower bound of region on y */
  float ymin;
/** upper bound of region on y */
  float ymax;
/** lower bound of region on z */
  float zmin;
/** upper bound of region on z */
  float zmax;
/** scale factor for coordinates */
  float scal;
/** nonzero if region include e-pipe */
  int pipe;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** MC detector impact points */
struct MIMP
{
/** z coordinate; note the order: z x y ! */
  float z;
/** x coordinate */
  float x;
/** y coordinate */
  float y;
/** tan(px/pz) */
  float tx;
/** tan(py/pz) */
  float ty;
/** momentum multiplied by the sign of pz */
  float p;
/** Time of flight */
  float time;
/** detector plane in table GEDE */
  ArtePointer<GEDE> gede;
/** relation one track to many impact points */
  ArtePointer<MTRA> mtra;
/** any other quantity (now for TRD only) */
  float q;
/** many digits to many mimps */
  ArteInvManRelationPointer<MIDI,DIGB> digb;
/** many hits to many MC impact points */
  ArteInvManRelationPointer<MIHI,HITB> hitb;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** MC-Track-Entry-Point in calorimeter */
struct MTCP
{
/** z coordinate; note the order: z x y ! */
  float z;
/** x coordinate */
  float x;
/** y coordinate */
  float y;
/** px/pz */
  float tx;
/** py/pz */
  float ty;
/** momentum multiplied by the sign of pz */
  float p;
/** Pointer to track entering into the calorimeter */
  ArtePointer<MTRA> mtra;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** MC particles / tracks */
struct MTRA
{
/** Px */
  float px;
/** Py */
  float py;
/** Pz */
  float pz;
/** Particle mass for resonances;
track length for stable particles */
  float ml;
/** whereabout of the track:
0: just created; not yet processed
1: expected to decay according to QMTRA_LENG
2: decayed resonance or electromagnetic decay
   (production vertex = decay vertex)
3: decay with non-zero track length
4: track ends in a electromagnetic or
   hadronic interaction
5: track leaves the detector volume
6: track stops inside detector volume
7: track curls up inside detector volume */
  int flag;
/** particle code */
  ArtePointer<TOPP> topp;
/** data for MTRA_BVER, MTRA_BTRA */
  int orig;
/** many reconstructed tracks to many MC tracks */
  ArteManRelationPointer<RTMT,RTRA> rtra;
/** many MC tracks to many clusters */
  ArteManRelationPointer<RCMT,RCCL> rccl;
/** mass */
  float mass;
/** track length */
  float leng;
/** one vertex to many outgoing tracks */
  ArtePointer<MVER> bver;
/** one track to many outgoing tracks */
  ArtePointer<MTRA> btra;
/** many outgoing tracks to one track */
  ArteInvOneRelationPointer<MTMT,MTRA> etra;
/** many end vertices to one track */
  ArteInvOneRelationPointer<MTMV,MVER> ever;
/** many impact points to one track */
  ArteInvOneRelationPointer<MTMI,MIMP> mimp;
/** many ECALs to one track */
  ArteInvOneRelationPointer<MTMC,MCAL> mcal;
/** many MC tracks to many track segments */
  ArteInvManRelationPointer<MTRS,RSEG> rseg;
/** to calorimeter entry point in bank MTCP */
  ArtePointer<MTCP> mtcp;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** MC vertices */
struct MVER
{
/** x coordinate */
  float x;
/** y coordinate */
  float y;
/** z coordinate */
  float z;
/** 0: primary vertex; x=y=z=0;
1: primary vertex at target;
2: decay vertex; 3: kink;
4: 2ndary,3rtiary, ... interaction */
  int flag;
/** one mother track to many vertices */
  ArtePointer<MTRA> btra;
/** many outgoing tracks to one origin vertex */
  ArteInvOneRelationPointer<MVMT,MTRA> etra;
/** primary interaction in MCME */
  ArtePointer<MCME> mcme;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** beam geometry */
struct NBEA
{
/** x-position of beam center */
  float x;
/** y-position of beam center */
  float y;
/** z-position of beam center */
  float z;
/** beam width along the axis x-prime */
  float dx;
/** beam width along the axis y-prime */
  float dy;
/** beam time width */
  float dt;
/** mean time value for generation */
  float time;
/** MC time smearing switch: on -> .ne. 0 */
  int tsw;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** nominal detector geometry: calorimeter/scintill. */
struct NCAL
{
/** number of subsectors per block
1: outer  calorimeter - block division 1*1
2: middle calorimeter - block division 2*2
5: inner  calorimeter - block division 5*5 */
  int ncl;
/** block number within the superlayer (packed) */
  int sec;
/** x of the left edge of the block */
  float xmin;
/** y of the right edge */
  float xmax;
/** y of the lower edge */
  float ymin;
/** y of the upper edge */
  float ymax;
/** z of the front side */
  float zmin;
/** z of the rear side */
  float zmax;
/** additional word for complicated shapes */
  float xmad;
/** additional word for complicated shapes */
  float ymad;
/** additional word for complicated shapes */
  float zmad;
/** light efficiency */
  float eff;
/** multiple scattering angle for 1 GeV particles */
  float ms;
/** detector component (see table NESL) */
  int cmp;
/** one super-layer <-> many detector planes */
  ArtePointer<NESL> nesl;
/** one material <-> many detector planes */
  ArtePointer<GMAT> gmat;
/** Geant volume name */
  char gvol[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** nominal detector geometry: planes */
struct NEDE
{
/** detector component (see table NESL) */
  int cmp;
/** layer number within the superlayer */
  int lay;
/** sector number */
  int sec;
/** detector shape */
  int shp;
/** x of the left edge of the detector */
  float xmin;
/** y of the right edge */
  float xmax;
/** y of the lower edge */
  float ymin;
/** y of the upper edge */
  float ymax;
/** z of the front side */
  float zmin;
/** z of the rear side */
  float zmax;
/** outer tracker: x of the left edge
of the sensitive area
muon: the size of sensitive area near pad */
  float sxmn;
/** outer tracker: y of the right edge
muon: efficiency in the gap between pads */
  float sxmx;
/** outer tracker: y of the lower edge
muon: y-distance from chamber edge to pad */
  float symn;
/** outer tracker: y of the upper edge
muon: y-gap between pads */
  float symx;
/** cosine of the wire angle with respect to y-axis */
  float cos;
/** sine of the wire angle with respect to y axis */
  float sin;
/** 3 by 3 rotation matrix */
  float rot[9];
/** measurement accuracy (for MC digitization) */
  float acc;
/** hit efficiency (for MC digitization) */
  float eff;
/** max drift distance or double hit resolution */
  float dod;
/** pitch */
  float pit;
/** multiple scattering angle **2 for 1 GeV particles */
  float ms;
/** outer tracker: x of first wire in sublayer 1...4
muon: 1 - x of first wire
muon: 2 - x-size of pad or pixel cell
muon: 3 - x-distance from chamber edge to pad
muon: 4 - x-gap between pads */
  float xfw[4];
/** outer tracker: z of first wire in sublayer 1...4
muon: 1 - z of wires
muon: 2 - z of pads
muon: 3 - y-size of first (small) pad or pixel
muon: 4 - y-size of large pads */
  float zfw[4];
/** outer tracker: number of wires in sublayer 1...4
muon: 1 - number of wires or pixels in x-dir
muon: 2 - number of pixels in y-direction
muon: 3 - number of connected pixels in x-dir
muon: 4 - number of connected pixels in y-dir */
  int nwi[4];
/** number of sublayers in a segment */
  int nsl;
/** one super-layer <-> many detector planes */
  ArtePointer<NESL> nesl;
/** one material <-> many detector planes */
  ArtePointer<GMAT> gmat;
/** number of walls connected to this detector */
  int nwl;
/** first wall connected to this detector */
  int fwl;
/** additional word for comp. geometrical shapes */
  float xmad;
/** additional word for comp. geometrical shapes */
  float ymad;
/** additional word for comp. geometrical shapes */
  float zmad;
/** lower boundary in y for wires in sublayer 1...4 */
  float y1w[4];
/** upper boundary in y for wires in sublayer 1...4 */
  float y2w[4];
/** Geant volume name (up to 4 characters) */
  char gvol[4];
/** Hardware code for the given detector */
  char hwc[12];
/** energy loss of a mip in the given detector */
  float dedx;
/** Geant copy number - so called user number */
  int gcop;
/** noise */
  float noise;
/** resolution of the alignment */
  float ares;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** nominal detector geometry: superlayers */
struct NESL
{
/** superlayer name (up to 4 characters) */
  char name[4];
/** detector component:
 1 SIL silicon vertex detector
 2 WCH wire chambers
 3 MSG microstrip chambers
 4 PTC chambers (pi-pi trigger)
 5 RIC Cerenkov counter
 6 TRD forward TRD
 7 CAL electromagnetic calorimeter
 8 MUO muon outer chambers
 9 MUX muon central chambers
11 TAR target
12 FLD field
13 HOD1 hodoscope 1
14 HOD2 hodoscope 2
15 HOD3 hodoscope 3
25 MUON system
26 Electron pipe
27 Proton pipe
28 Magnet
29 Roman Pot */
  int cmp;
/** shape of the superlayer
 1 box
 3 trapezoid (ie. x and y varying along z)
 5 tube
 9 spherical shell */
  int shp;
/** nth superlayer of this component */
  int nsl;
/** magnet flag (0 = no mag. field) */
  int mfl;
/** number of layers */
  int lay;
/** box:  left  boundary in x
trap: left boundary in x at smaller z
tube and sphere: inner radius */
  float x1;
/** box:  right boundary in x
trap: right boundary in x at smaller z
tube and sphere: x-pos. of tube/sphere center */
  float x2;
/** box:  lower boundary in y
trap: lower boundary in y at smaller z
tube and sphere : outer radius */
  float y1;
/** box:  upper boundary in y
trap: upper boundary in y at smaller z
tube and sphere: y-pos. of tube/sphere center */
  float y2;
/** z of begin of superlayer */
  float z1;
/** z of end of superlayer */
  float z2;
/** trap: difference in x to x1 at bigger z */
  float dx;
/** trap: difference in y to y1 at bigger z */
  float dy;
/** number of detector planes (nlayers*nsectors) */
  int npl;
/** first det. plane belonging to this superlayer */
  int fpl;
/** number of walls in this superlayer */
  int nwl;
/** first wall belonging to this superlayer */
  int fwl;
/** layer types/sequences */
  int ltyp;
/** relation to detector planes */
  ArteInvOneRelationPointer<NSND,NEDE> nede;
/** relation to calorimeter planes */
  ArteInvOneRelationPointer<NSNC,NCAL> ncal;
/** relation to walls */
  ArteInvOneRelationPointer<NSNW,NWAL> nwal;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** bank of magnetic field (temporary - const field) */
struct NFLD
{
/** x-position of field center */
  float x;
/** y-position of field center */
  float y;
/** z-position of field center */
  float z;
/** radius of field region */
  float r;
/** strength of field (in kG) */
  float h;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** header for the nominal detector geometry */
struct NGHD
{
/** version number for the geometry constants */
  float geom;
/** version number of the hbgean program producing
the constants */
  float gean;
/** date */
  int date;
/** time */
  int time;
/** version number for the geometry constants
the vector is given by gehd.geom(LGESL_... ,I)
LGESL_MOTH = 30 = overall geometry = datt geom
LGESL_RPOT = 29 = Roman Pot
LGESL_TAR  = 11 = target
LGESL_SIL  = 1  = SVD
LGESL_SML  = 16 = Silicon in magnet
LGESL_MAG  = 28 = Magnet elements
LGESL_FLD  = 12 = magnetic field
LGESL_PPIP = 27 = Proton beam pipe
LGESL_EPIP = 26 = Electron beam pipe
LGESL_WCH  = 2  = OTR
LGESL_MSG  = 3  = ITR
LGESL_PTC  = 4  = PTL
LGESL_RIC  = 5  = RICH
LGESL_TRSL = 24 = TRD
LGESL_ECA  = 7  = ECA
LGESL_MUON = 25 = MUON System
LGESL_HOD1 = 13 = new trigger hodoscope
LGESL_HOD2 = 14 = trigger hodoscope
LGESL_HOD3 = 15 = last (in z) hodoscope */
  float gevs[32];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** target geometry */
struct NTAR
{
/** wire material */
  int cmp;
/** wire number */
  int wnr;
/** wire thickness along the axis x */
  float dx;
/** wire thickness along the axis y */
  float dy;
/** wire thickness along the axis z */
  float dz;
/** x-position of wire center */
  float x;
/** y-position of wire center */
  float y;
/** z-position of wire center */
  float z;
/** 3*3 rotation matrix wire system to lab system */
  float rot[9];
/** multiple scattering angle for 1 GeV particles */
  float ms;
/** maximum of vertex distribution in x direction */
  float x0bm;
/** maximum of vertex distribution in y direction */
  float y0bm;
/** width of vertex distribution in x direction */
  float sxbm;
/** width of vertex distribution in y direction */
  float sybm;
/** shape integer (same as in GEDE) */
  int shap;
/** Station and wire name - 1i,1o,2t,2b for
Station 1 inner, 1 outer, 2 top 2, bottom etc */
  char name[4];
/** effectivity (eff = 0. means wire out) */
  float eff;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** nominal walls */
struct NWAL
{
/** detector shape */
  int shp;
/** x of the left edge */
  float xmin;
/** y of the right edge */
  float xmax;
/** y of the lower edge */
  float ymin;
/** y of the upper edge */
  float ymax;
/** z of the front side */
  float zmin;
/** z of the rear side */
  float zmax;
/** additional word for complicated shapes */
  float xmad;
/** additional word for complicated shapes */
  float ymad;
/** additional word for complicated shapes */
  float zmad;
/** 3 by 3 rotation matrix */
  float rot[9];
/** multiple scattering angle **2 for 1 GeV particles */
  float ms;
/** number of sublayers in a segment */
  int nsl;
/** one super-layer <-> many walls */
  ArtePointer<NESL> nesl;
/** one material <-> many walls */
  ArtePointer<GMAT> gmat;
/** detector connected to this wall */
  ArtePointer<NEDE> nede;
/** Geant volume name (up to 4 characters) */
  char gvol[4];
/** energy loss of a mip in the given wall */
  float dedx;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** OT channel description (parallel to OTMO) */
struct OTCD
{
/** number of channel */
  int chan;
/** bit string of status bits, meaning of  bit:
=0 if channel is used for HITB, =1 if not used */
  int bits[4];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** OT(IT) dead regions */
struct OTDR
{
/** gede identifier */
  ArtePointer<GEDE> gede;
/** hardware code for the given detector */
  char hwc[12];
/** sublayer number
for OT
sub=1 means common dead region for sublayer 1&2
sub=3 means common dead region for sublayer 3&4 */
  int sub;
/** lower boundary in x of dead region */
  float xmin;
/** upper boudary in x of dead region */
  float xmax;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** OT global constants */
struct OTGL
{
/** number of rows in GEDE related to OT(=2485) */
  int gede;
/** maximal number of channel(wire)/gede row (=128) */
  int mchn;
/** method of storage of time-space relations in DB
=0, coefficients of splines (default) */
  int medb;
/** method of storage of time-space relations in OTTS
=0, tabulated form ,TDC=0,1,2, ... 256(default)
=1,                , uniform binning of TDC
=2,                , arbitrary */
  int meth;
/** number of knots for tabulation(=129) */
  int knot;
/** signal propagation velocity on wire (=28.2 cm/ns) */
  float wvel;
/** [0] average drift velocity for 5mm  (=0.01 cm/ns)
[1]                            10mm */
  float vd[2];
/** [0]                            5mm  in magnet
[1]                            10mm in magnet */
  float vdmf[2];
/** electronic resolution in ns (=0.8) */
  float fele;
/** ns per one TDC count (=0.39 ns/tdc count) */
  float ntdc;
/** fraction of electrons that reach the wire (=0.25) */
  float fatt;
/**             charge seen by the amplifier (=0.2) */
  float damp;
/** parameter of Polya distribution (=1.222) */
  float db;
/** elementary charge (=1.602e-19) */
  float dqe;
/** doubled primary ionization density (=102. 1/cm) */
  float dlam;
/** probability of x-talk through cell */
  float xtcl;
/**                               readout circuit */
  float xtre;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** OT module parameters */
struct OTMO
{
/** mean y-coordinate for what t_zero was defined */
  float yt0;
/** direction of signal propagation on wire
=+1 propagation from gede->symn to gede->symx
=-1                  gede->symx to gede->symn */
  int ydir;
/** first word in table OTTZ(OTTE) related to module */
  int idtz;
/** identifier of time-space relations stored in OTTS
for otgl->meth = 0,1 and 2 :
first row in OTTS is otgl->knot*otmo->idts+1 */
  int idts;
/** one OT module <--> one OT sensitive gede */
  ArtePointer<GEDE> gede;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** OT error of t_zero values */
struct OTTE
{
/** byte string, error(t_zero)*8 is stored in byte */
  int ert0;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** OT time-space relations */
struct OTTS
{
/** TDC value */
  float tdc;
/** drift distance (r) in cm */
  float r;
/** resolution of drift distance in cm */
  float resr;
/** drift velocity in cm/ns */
  float v;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** OT t_zero values */
struct OTTZ
{
///
  float t0;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** High-Pt ASD-8 board
Each ASD-8 board reads 16 channels
for gas pixel chambers */
struct PTAD
{
/** ASD-8/Cable unique mark (8 symbols)
for example for run98:  PT1M0011 */
  char name[8];
/** ASD-8/Cable position */
  int pos;
/** First channel in table PTCH */
  int fstc;
/** Last  channel in table PTCH */
  int lstc;
/** one FED board to many ASD-8 boards */
  ArtePointer<PTFD> ptfd;
/** one ASD-8 board to many channels */
  ArteInvOneRelationPointer<PXCA,PTCH> ptch;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** High-Pt Alignment information */
struct PTAL
{
/** flag */
  int flag;
/** x offset */
  float xoff;
/** y offset */
  float yoff;
/** z offset */
  float zoff;
/** rotation matrix */
  float rotm[9];
/** one module to one geom info */
  ArtePointer<PTMD> ptmd;
/** one PTGE to many geom info */
  ArtePointer<PTGE> ptge;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Cells of PT chambers */
struct PTCE
{
/** Cell Flag */
  int flag;
/** Cell ID */
  int id;
/** one PTGE to many PT Cells */
  ArtePointer<PTGE> ptge;
/** one PT Channel to one PT Cell */
  ArtePointer<PTCH> ptch;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** High-pt Channel */
struct PTCH
{
/** Channel number */
  int id;
/** one ASD-8 to many channels */
  ArtePointer<PTAD> ptad;
/** one PT Cell to one PT Channel */
  ArtePointer<PTCE> ptce;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** High-Pt FED Mother Board/Crate
High-Pt FED description */
struct PTCR
{
/** Mother board/Crate number */
  int id;
/** Mother Board/Crate name (8 symbols) */
  char name[8];
/** Short Description     (128 symbols) */
  char text[128];
/** one module to many crates */
  ArtePointer<PTMD> ptmd;
/** one crate to many boards */
  ArteInvOneRelationPointer<PXFC,PTFD> ptfd;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** High-Pt Daugther Board
High-Pt Readout board description
Board houses up to 18 ASD-8 chips */
struct PTFD
{
/** Daugther Board number */
  int id;
/** Daugther Board name  (8 symbols) */
  char name[8];
/** Comment/short description (128 symbols) */
  char text[128];
/** one crate to many boards */
  ArtePointer<PTCR> ptcr;
/** one board to many ASD-8 */
  ArteInvOneRelationPointer<PXAF,PTAD> ptad;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** PT detector geometry: planes and walls */
struct PTGE
{
/** Flag:    =  1 Detector
         = -1 Wall
 else    =  dummy row */
  int flag;
/** Arte Element: >0    (GEDE row)
              =0 dummy row
              <0 -1*(GWAL row) */
  int arte;
/** DataBase Flag */
  int db;
/** Detector/Wall name   (   4 symbols ) */
  char name[4];
/** Superlayer name      (   4 symbols ) */
  char supl[4];
/** GEANT Mother name    (   4 symbols ) */
  char moth[4];
/** Shape of the volume  (   4 symbols ) */
  char shap[4];
/** Matherial name       (<=12 symbols ) */
  char mate[12];
/** MANY/ONLY flag for GEANT */
  char maon[4];
/** Rotation matrix flag/index */
  int irot;
/** 3x3 Rotation Matrix
For following 8 attributes see also
definitions in gean/PTGEA.fi,PTGEA.ff */
  float rotm[9];
/** minimal X          ( for BOX  shape )
Outer Radius       ( for TUBE shape )
X-length           ( for TRD2 shape ) */
  float xmin;
/** maximal X          ( for BOX  shape )
Thickness          ( for TUBE shape )
Y-length           ( for TRD2 shape ) */
  float xmax;
/** minimal Y          ( for BOX  shape )
Length             ( for TUBE shape )
Z-length           ( for TRD2 shape ) */
  float ymin;
/** maximal Y          ( for BOX  shape )
X-position         ( for TUBE shape )
X-position         ( for TUBE shape ) */
  float ymax;
/** minimal Z          ( for BOX  shape )
Y-position         ( for TUBE shape )
Y-position         ( for TUBE shape ) */
  float zmin;
/** maximal Z          ( for BOX  shape )
Z-position         ( for TUBE shape )
Z-position         ( for TUBE shape ) */
  float zmax;
/** DX                 ( for TRD2 shape ) */
  float dx;
/** DY                 ( for TRD2 shape ) */
  float dy;
/** NX - chamber division in X-direction */
  int nx;
/** NY - chamber division in Y-direction */
  int ny;
/** Direction of hardware addressing
 MOD(DIR,10000)<=1 - from Xmin to Xmax
  suitable for X>0 chambers
 MOD(DIR,10000)>=2 - from Xmax to Xmin
  suitable for X<0 chambers
 DIR/10000     <=1 - from Ymin to Ymax
  suitable for Y>0 chambers
 DIR/10000     >=2 - from Ymax to Ymin
  suitable for Y<0 chambers
 DIR =   0,1 - normal    ordering
 DIR =     2 - inverse X-ordering
 DIR = 20000 - inverse Y-ordering
 DIR = 20002 - inverse X and Y-ordering */
  int dir;
/** COLOR attribute for GEANT */
  int colo;
/** FILL  attribute for GEANT */
  int fill;
/** SEEN  attribute for GEANT */
  int seen;
/** Comment,short description (128 symbols) */
  char comm[128];
/** First Cell in table PTCE */
  int fstc;
/** Last  Cell in table PTCE */
  int lstc;
/** one PTGE to many cells */
  ArteInvOneRelationPointer<PXGC,PTCE> ptce;
/** one PTGE to many geom info */
  ArteInvOneRelationPointer<PXGA,PTAL> ptal;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** High-Pt Module
High-Pt Module description */
struct PTMD
{
/** Module number */
  int id;
/** Module name  (8 symbols) */
  char name[8];
/** Short Description (128 symbols) */
  char text[128];
/** one module to many crates */
  ArteInvOneRelationPointer<PXCM,PTCR> ptcr;
/** one module to many geom info */
  ArteInvOneRelationPointer<PXGM,PTAL> ptal;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** cluster table */
struct RCCL
{
/** z of the cluster */
  float z;
/** x of the corrected cog for electrons */
  float x;
/** y of the corrected cog for electrons */
  float y;
/** px/pz of the cluster axis */
  float tx;
/** py/pz of the cluster axis */
  float ty;
/** Total energy of cluster */
  float esum;
/** matrix of the errors (5x5) */
  float cve[15];
/** width of the cluster */
  float wid;
/** asymmetry of the cluster */
  float asym;
/** flag */
  int flag;
/** likelyhood of electromagnetic shower */
  float lemp;
/** likelyhood of MIP */
  float lmip;
/** likelyhood of hadron shower */
  float lhad;
/** x of the cog */
  float xcog;
/** y of the cog */
  float ycog;
/** Covariances (2x2) of COG */
  float vcog[3];
/** many tracks to many clusters */
  ArteManRelationPointer<RTRC,RTRA> rtra;
/** many clusters to many ECAL hitc */
  ArteInvManRelationPointer<RCHC,HITC> hitc;
/** many clusters to many MC tracks */
  ArteInvManRelationPointer<RCMT,MTRA> mtra;
/** many clusters to many segments */
  ArteInvManRelationPointer<RCRS,RSEG> rseg;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** fitted hits in all detectors except ECAL */
struct RHIT
{
/** x coordinate */
  float x;
/** y coordinate */
  float y;
/** px / pz */
  float tx;
/** py / pz */
  float ty;
/** 1 / p signed according to charge */
  float p;
/** quantity (detector dependent) */
  float q;
/** weight function of hit (usage dependent) */
  float w;
/** track number */
  ArtePointer<RTRA> rtra;
/** one fitted hit to one measured hit */
  ArtePointer<HITB> hitb;
/** one track segment to many reconstr. hits */
  ArtePointer<RSEG> rseg;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Rich reconstruction utility */
struct RITH
{
/** Cherenkov radius for beta = 1 */
  float rad0;
/** reference run number */
  int run;
/** reference version number */
  int ver;
/** reference experiment number */
  int exp;
/** reference Unix time */
  int time;
/** Reco parameters
exp > 0: real data */
  float par[10];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** point on a track (e.g. impact point into muon) */
struct RPNT
{
/** z coordinate at begin of track */
  float zf;
/** x coordinate */
  float xf;
/** y coordinate */
  float yf;
/** px / pz */
  float txf;
/** py / pz */
  float tyf;
/** 1/p (signed according to charge) */
  float pf;
/** covariance matric of parameters at first point */
  float cvf[15];
/** many tracks to many points on it */
  ArteManRelationPointer<RTRP,RTRA> rtra;
/** one track segment to many points on it */
  ArtePointer<RSEG> rseg;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** relation between tracks and  vertices */
struct RREL
{
/** 0/1: not used / used for the vertex fit */
  int flag;
/** used particle hypothesis; 0: no hyp. */
  ArtePointer<TOPP> topp;
/** contribution to chi */
  float chi;
/** one track to many track-vertex relations */
  ArtePointer<RTRA> rtra;
/** one vertex to many track-vertex relations */
  ArtePointer<RVER> rver;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** reconstructed track segments */
struct RSEG
{
/** z coordinate at begin of track */
  float zf;
/** x coordinate */
  float xf;
/** y coordinate */
  float yf;
/** px / pz */
  float txf;
/** py / pz */
  float tyf;
/** 1/p (signed according to charge) */
  float pf;
/** covariance matrix of parameters at first point */
  float cvf[15];
/** time in ns */
  float time;
/** error on time */
  float dtim;
/** z coordinate at end of track
z=0: end of track is not determined */
  float ze;
/** x coordinate */
  float xe;
/** y coordinate */
  float ye;
/** px / pz */
  float txe;
/** py / pz */
  float tye;
/** 1/p (signed according to charge) */
  float pe;
/** covariance matrix of parameters at end point */
  float cve[15];
/** chi**2 of fit */
  float chi;
/** fit flag
    0: reconstructed charged track segment
    1: reconstructed momentum to main vertex
    2: reconstructed short decay
    3: reconstructed long decay
    4: conversion (from tracks)
    5: space point (no angular measurements)
    6: neutral particle (from ECAL)
    7: match segment
    8: charged particle direction (from RICH)
    9: track seed (eg from TC area)
   10: conversion direction (from RICH)
   12: seeded ring (from RICH)
   13: seeded gamma conversion (from RICH) */
  int fit;
/** detector component (bit flags ?) */
  int cmp;
/** many track segments to one track */
  ArteManRelationPointer<RTRS,RTRA> rtra;
/** many track segments at the begin of
this segment to many segments */
  ArteManRelationPointer<RSRS,RSEG> rbeg;
/** error flag */
  int err;
/** many track segments to many ECAL clusters */
  ArteManRelationPointer<RCRS,RCCL> rccl;
/** many MC tracks to many track segments */
  ArteManRelationPointer<MTRS,MTRA> mtra;
/** number of hits */
  int nhit;
/** number of parameters: NDGF = NHIT - NPAR */
  int npar;
/** many hits to many track segments */
  ArteInvManRelationPointer<RSHI,HITB> hitb;
/** many track segment to many reconstructed points */
  ArteInvOneRelationPointer<RSRP,RPNT> rpnt;
/** one track segment to many reconstr. hits */
  ArteInvOneRelationPointer<RSRH,RHIT> rhit;
/** many track segments at the end of
this segment to many segments */
  ArteInvManRelationPointer<RSRS,RSEG> rend;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** SLT track output */
struct RSLA
{
/** Absolute track number (= FLT track number) */
  int itra;
/** Flag for track accepts (= 1 if ACC) */
  int flag;
/** FLT RoI on TC2 (x2,y2,z2,x2_err,y2_err) */
  float flt2[5];
/** FLT RoI on PC1 (x1,y1,z1,x1_err,y1_err) */
  float flt1[5];
/** Track slope after refit-xz */
  float slox;
/** Track intercept after refit-xz */
  float intx;
/** Covariance matrix after refit-xz */
  float covx[3];
/** Track slope after refit-yz */
  float sloy;
/** Track intercept after refit-yz */
  float inty;
/** Covariance matrix after refit-yz */
  float covy[3];
/** Number of hits in full refit */
  int nhit;
/** Chisquare of full refit */
  float chi;
/** momentum estimate */
  float p;
/** Track x-slope after l2sili */
  float tx;
/** Track y-slope after l2sili */
  float ty;
/** Track x-intercept after l2sili */
  float bx;
/** Track y-intercept after l2sili */
  float by;
/** Hits in x-view used in l2sili */
  int hitx;
/** Hits in y-view used in l2sili */
  int hity;
/** Chisquare in x-view in l2sili */
  float xchi;
/** Chisquare in y-view in l2sili */
  float ychi;
/** Covariance matrix for x-view in l2sili */
  float xcov[3];
/** Covariance matrix for y-view in l2sili */
  float ycov[3];
/** Track ID */
  int id;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** SLT trigger output */
struct RSLI
{
/** Absolute trigger number */
  int itri;
/** Trigger type */
  int type;
/** Flag for trigger accepts (= 1 if ACC) */
  int flag;
/** Number of tracks for this trigger */
  int ntra;
/** Index to XTRA bank */
  int tra[2];
/** Chisquare of vertex fit */
  float chi;
/** Fitted vertex position */
  float pos[3];
/** Fitted errors on vertex position */
  float err[3];
/** Distance between tracks */
  float dxy;
/** Distance in z to closest wire */
  float dz;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** reconstructed target */
struct RTAR
{
/** wire number */
  int wnr;
/** x position of wire centre */
  float x;
/** y position of wire centre */
  float y;
/** z position of wire centre */
  float z;
/** error on x */
  float dx;
/** error on y */
  float dy;
/** error on z */
  float dz;
/** sigma x (width of distribution) */
  float sx;
/** sigma y */
  float sy;
/** sigma z */
  float sz;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** reconstructed tracks */
struct RTRA
{
/** z coordinate at begin of track */
  float zf;
/** x coordinate */
  float xf;
/** y coordinate */
  float yf;
/** px / pz */
  float txf;
/** py / pz */
  float tyf;
/** charged tracks: Q/p
neutral decays: 1/p */
  float pf;
/** covariance matrix of parameters at first point */
  float cvf[15];
/** number of hits in the SVD */
  int hsi;
/** number of hits in the inner tracker */
  int hin;
/** number of hits in the outer tracker */
  int hou;
/** number of hits in the RICH */
  int hri;
/** number of hits in the calorimeter */
  int hca;
/** number of hits in the TRD */
  int htr;
/** number of hits in the muon chambers */
  int hmu;
/** fit flag: D + 100 * E with ...
D = 0: reconstructed charged track
    1: reconstructed momentum to main vertex
    2: reconstructed short decay
    3: reconstructed long decay
    4: conversion (from tracks)
    5: space point (no angular measurements)
    6: neutral particle (from ECAL)
    7: match segment
    8: charged particle direction (from RICH)
    9: track seed (eg from TC area)
   10: conversion direction (from RICH)
   11: track fit without momentum
E: error flag from track or vertex fit */
  int fit;
/** chi of track or vertex fit */
  float chi;
/** Rich: likelihood of electron hypothesis */
  float lre;
/** Rich: likelihood of muon hypothesis */
  float lrmu;
/** Rich: likelihood of pion hypothesis */
  float lrpi;
/** Rich: likelihood of kaon hypothesis */
  float lrk;
/** Rich: likelihood of proton hypothesis */
  float lrp;
/** Rich: particle identification flag */
  int flr;
/** particle code
for charged tracks: hypothesis used for the
track fit; BY NO MEANS: the only hypothesis
for decays with mass constraint: hypothesis
for decays without mass constraint: 0 */
  ArtePointer<TOPP> topp;
/** TRD: likelihood of electron hypothesis */
  float lte;
/** TRD: likelihood of hadron hypothesis */
  float lth;
/** TRD: particle identification flag */
  int flt;
/** ECAL: likelihood of electron hypothesis */
  float lee;
/** ECAL: likelihood of MIP hypothesis */
  float lemi;
/** ECAL: likelihood of hadron hypothesis */
  float leh;
/** ECAL: particle identification flag */
  int fle;
/** MUON: likelihood of muon hypothesis */
  float lmmu;
/** MUON: likelihood of hadron hypothesis */
  float lmh;
/** MUON: particle identification flag */
  int flm;
/** global likelihood of electron hypothesis */
  float le;
/** global likelihood of muon hypothesis */
  float lmu;
/** global likelihood of pion hypothesis */
  float lpi;
/** global likelihood of kaon hypothesis */
  float lk;
/** global likelihood of proton hypothesis */
  float lp;
/** global particle identification flag */
  int fid;
/** bit flag for hit layers in the SVD
clone flag: 0 : no clone
clone flag: >0 : there is at least one other
track which is a potential clone */
  unsigned int bsi;
/** clone flag for SVD */
  int csvd;
/** clone flag for the main tracker (inner + outer) */
  int cmain;
/** clone flag for RICH */
  int crich;
/** clone flag for ECAL */
  int cecal;
/** clone flag for MUON */
  int cmuon;
/** tx determined in the RICH */
  float txr;
/** ty determined in the RICH */
  float tyr;
/** KCerenkov angle */
  float cer;
/** describes how the momentum has been determined
 1 - estimated by REFIT on all hits assigned
 */
  int mommask;
/** the same as CMP in RSEG */
  unsigned int cmp;
/** Rich: likelihood for multi electron hypothesis */
  float lrme;
/** number of degrees of freedom in refit */
  int ndof;
/** bit flag for hit main tracker super layers
 bit 1-13:  otr super layers 1-13
 bit 14-22: itr super layers 1-9
 super layer index is taken from gesl->nsl */
  unsigned int bmain;
/** one incoming track to one vertex */
  ArtePointer<RVER> ever;
/** one track to many track-vertex relations */
  ArteInvOneRelationPointer<RRRT,RREL> rrel;
/** many hits to many reconstructed tracks */
  ArteInvManRelationPointer<RTHI,HITB> hitb;
/** many ECAL hits to many reconstructed track */
  ArteInvManRelationPointer<RTHC,HITC> hitc;
/** one track to many points on it */
  ArteInvManRelationPointer<RTRP,RPNT> rpnt;
/** many reconstructed tracks to many MC tracks */
  ArteInvManRelationPointer<RTMT,MTRA> mtra;
/** many track segments to one track */
  ArteInvManRelationPointer<RTRS,RSEG> rseg;
/** many clusters to many tracks */
  ArteInvManRelationPointer<RTRC,RCCL> rccl;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** RICH results with 2 methods: Riter and Rise
This table will disppear when the final Rich
analysis is available */
struct RTRI
{
/** Rise: likelihood of electron hypothesis */
  float lte;
/** Rise: likelihood of muon hypothesis */
  float ltmu;
/** Rise: likelihood of pion hypothesis */
  float ltpi;
/** Rise: likelihood of kaon hypothesis */
  float ltk;
/** Rise: likelihood of proton hypothesis */
  float ltp;
/** Rise: particle identification flag */
  int flt;
/** Riter: likelihood of electron hypothesis */
  float lse;
/** Riter: likelihood of muon hypothesis */
  float lsmu;
/** Riter: likelihood of pion hypothesis */
  float lspi;
/** Riter: likelihood of kaon hypothesis */
  float lsk;
/** Riter: likelihood of proton hypothesis */
  float lsp;
/** Riter: particle identification flag */
  int fls;
/** Riter: likelihood of multi electron hypothesis */
  float lsme;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** reconstructed vertices */
struct RVER
{
/** x coordinate */
  float xv;
/** y coordinate */
  float yv;
/** z coordinate */
  float zv;
/** covariance matrix */
  float cv[6];
/** reconstructed mass */
  float mass;
/** error on reconstructed mass
The particle hypothesis used for
a mass constraint fit is stored in RTRA */
  float merr;
/** number of tracks used for the fit */
  int nt;
/** one vertex to one incoming track */
  ArtePointer<RTRA> btra;
/** wire number */
  int wire;
/** chi**2 */
  float chi2;
/** type */
  int type;
/** number of degrees of freedom */
  int ndgf;
/** one vertex to many track-vertex relations */
  ArteInvOneRelationPointer<RRRV,RREL> rrel;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Silicon Hits for SUSi Candidates */
struct SHCA
{
/** Plane number */
  int plan;
/** The measured value */
  float meas;
/** Delta Chi2 for a hit */
  float dchi;
/** (4)   SUSi Parameters */
  float p[4];
/** (4x4) Covariance Error Matrix */
  float c[16];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Silicon Hits for SUSi Proper Tracks */
struct SHPR
{
/** HITB row number */
  ArtePointer<HITB> hitb;
/** one reconctructed   track to many hits */
  ArtePointer<STPR> stpr;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Silicon Hits for Reconstructed Tracks */
struct SHRC
{
/** Row in HITB table */
  ArtePointer<HITB> hitb;
/** SUSi Plane of measurement */
  int plan;
/** Parameters */
  float p[4];
/** Covariance Matrix */
  float c[10];
/** Measurement for Kalman Smoothing */
  float meas;
/** Residial for Kalman Smoothing */
  float res;
/** one reconctructed   track to many hits */
  ArtePointer<STRC> strc;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** SUSi Navigation Table (to) */
struct SNAB
{
/** NEXT plane to be searched for */
  int next;
/** one PLANE to many PLANES */
  ArtePointer<SNAV> snav;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** SUSi Navigation Table (from) */
struct SNAV
{
/** GEDE plane Number */
  ArtePointer<GEDE> gede;
/** Number of SNAX to be connected */
  int npla;
/** Number of SNAB to be connected */
  int nbac;
/** C */
  ArteInvOneRelationPointer<SNSN,SNAX> snax;
/** C */
  ArteInvOneRelationPointer<SBSN,SNAB> snab;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** SUSi Navigation Table (to) */
struct SNAX
{
/** NEXT plane to be searched for */
  int next;
/** one PLANE to many PLANES */
  ArtePointer<SNAV> snav;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** SUSi Parameters Table
This table consiists of almost all
vital SUSi parameters. Be careful
to modify them! In the case of
errors table automatically reset
to default values. */
struct SPAR
{
/** Number of Modification(normally=1) */
  int nmod;
/** Default Flag:
 >0 Default Parameters
 <0 Not default Parametrs
 =0 Not Yet Defined! Dangerous!!!! */
  int dfla;
/** Dimension of the SEEDing algorithm
 = 4 Standard documented 4-plane
     seeds  for SUSi, robust and
     well tested. Disadvantage -
     execution time proportional
     to n_hit**4, very low track
     reconstruction efficiency for
     large occupancy.
 = 2 Very Simple 2-plane seeding
     algorithm. Advantages:
     5-10 times faster and much
     larger efficiency for high
     occupancy. It is DEFAULT!! */
  int seed;
/**  = 0 Minimal Z approach in 2-plane
     seeding algorithm(default)
 = 1 Minimal Angular difference
     approach */
  int angu;
/** =   0 No PROPER TRACK business */
  int prop;
/** =   0 No refit business
=   1 Kalman  Smother refit
=   2 Reverse Kalman  refit */
  int algo;
/** Number of Hitted SL */
  int mhsl;
/** Minimal Track Quality Cut */
  float qual;
/** Minimal Correct hits contents */
  float perc;
/** Weight for missing hits */
  float wmis;
/** Weight for chi2 */
  float wch2;
/** Minimal Tolerance Parameter */
  float mnto;
/** Maximal Tolerance Parameter */
  float mxto;
/** Angle Tolerance Parameter */
  float anto;
/** CRITICAL Parameter */
  float crit;
/** TARGET_WINDOW Parameter */
  float twin;
/** Minimal Momenta for a Particle
Used twice:
a) for a Proper Track Definition
b) for MS estimation in s_klmpre.F */
  float pmin;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** SUSi PASS Table */
struct SPAS
{
/** C */
  ArteInvOneRelationPointer<SPSS,SSEE> ssee;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** SUSi SEEDing Table */
struct SSEE
{
/** First Plane Number in Combination */
  int pln1;
/** First Plane Number in Combination */
  int pln2;
/** First Plane Number in Combination */
  int pln3;
/** First Plane Number in Combination */
  int pln4;
/** one PASS to many SEEDs */
  ArtePointer<SPAS> spas;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** SUSi Statistics Table */
struct SSTA
{
/** Start NEVENT  for Statistics */
  int frst;
/** Last  NEVENT  for Statistics */
  int last;
/** Print Flag: 0 - no print
  N - print stat for N events
 -N - print stat every N events */
  int prn;
/** Minimal number of Prop. Tracks */
  int mnpf;
/** Maximal number of Prop. Tracks */
  int mxpf;
/** Minimal number of Pre.Rec.Tracks */
  int mnpr;
/** Maximal number of Pre.Rec.Tracks */
  int mxpr;
/** Minimal number of Rec.Tracks */
  int mnre;
/** Maximal number of Rec.Tracks */
  int mxre;
/** Minimal number of Prop.Rec.Tracks */
  int mnpt;
/** Maximal number of Prop.Rec.Tracks */
  int mxpt;
/** Minimal number of Ext.Rec.Tracks */
  int mnex;
/** Maximal number of Ext.Rec.Tracks */
  int mxex;
/** Minimal number of Ghost Rec.Tracks */
  int mngh;
/** Maximal number of Ghost Rec.Tracks */
  int mxgh;
/** Minimal number of RSEGs */
  int mnse;
/** Maximal number of RSEGs */
  int mxse;
/** Minimal number of RPNTs */
  int mnrp;
/** Maximal number of RPNTs */
  int mxrp;
/** Minimal calls of s_propseed.F */
  int mncp;
/** Maximal calls of s_propseed.F */
  int mxcp;
/** Total number of Proper Tracks */
  int nstp;
/** AUXinfo  for error in NSTP */
  float ystp;
/** Total number of Prelim.Rec.Tracks */
  int npre;
/** AUXinfo  for error in NPRE */
  float ypre;
/** Total number of Reconctruc.Tracks */
  int nrec;
/** AUXinfo  for error in NREC */
  float yrec;
/** Total number of Rec.Segments */
  int nseg;
/** AUXinfo  for error in NSEG */
  float yseg;
/** Total number of GHOSTS */
  int ngho;
/** AUXinfo  for error in NGHO */
  float ygho;
/** Total number of RPNTs */
  int npnt;
/** AUXinfo  for error in NPNT */
  float ypnt;
/** Total calls of s_propseed.F */
  int nncp;
/** AUXinfo  for error in NNCP */
  float yncp;
/** Eff. for Prop.Rec.Tracks */
  float epro;
/** AUXinfo  for error in EPRO */
  float apro;
/** Eff. for Extra Rec.Tracks */
  float eext;
/** AUXinfo  for error in EEXT */
  float aext;
/** Eff. for Ghost Rec.Tracks */
  float egho;
/** AUXinfo  for error in EGHO */
  float agho;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** SUSi Track Candidates */
struct STCA
{
/** Number of Silicon HITS for a candidate */
  int nhit;
/** Number of Missing HITS */
  int nmis;
/** Number of dbl foults */
  int n2mi;
/** hit seeding pl for a cand */
  int hspl;
/** lpl_x parameter for a candidat */
  int lplx;
/** lpl_y parameter for a candidat */
  int lply;
/** Ac_bit 1=tracking,2=finished,0=dead */
  int ac;
/** Chi2 for a candidate */
  float chi2;
/** AUXinfo - Plane */
  int plan;
/** AUXinfo - Parameters for a candidate */
  float p[4];
/** AUXinfo - Covariant matrix for a candidate */
  float c[16];
/** List of SHCA for this STCA */
  int hili[40];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** SUSi Reconstructable Tracks */
struct STPR
{
/** MTRA Row Number for the Proper Track */
  ArtePointer<MTRA> mtra;
/** Number of Silicon HITS for the track */
  int nhit;
/** Many Silicon HITS to One Proper Track */
  ArteInvOneRelationPointer<SPSH,SHPR> shpr;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** SUSi Reconstructed Tracks */
struct STRC
{
/** Number of Silicon HITS for a track */
  int nhit;
/** Number of Missing HITS */
  int nmis;
/** last Plane of measurement */
  int plan;
/** MTRA row number for a track */
  ArtePointer<MTRA> mtra;
/** responsible SEED for a track */
  int seed;
/** percentage of correctly associated hits */
  int perc;
/** chi2 for a track */
  float chi2;
/** Track Quality */
  float qual;
/** Z of last plane of measurement */
  float z;
/** (4)  Track Parameters  at Z */
  float p[4];
/** (4x4)Covariance Matrix at Z */
  float c[10];
/** Activation bit */
  int ac;
/** Many SI hits to one Reconstructed SUSi Track */
  ArteInvOneRelationPointer<SRSH,SHRC> shrc;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** SUSi Navigation Table (to) */
struct SUSI
{
/** SUSi Version */
  float vers;
/** Navigation Table Version */
  float nver;
/** SEEDing Table Version */
  float sver;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** HITS */
struct TAHB
{
/** channel id */
  int channel;
/** drift time */
  float dt;
/** flags etc., see struct TAFLG */
  int flg;
/** detector plane */
  ArtePointer<GEDE> gede;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Tracker Alignment&Cal Header */
struct TAHD
{
/** event number */
  int evt;
/** run number */
  int run;
/** experiment number
exp > 0: real data
exp < 0: Monte Carlo */
  int exp;
/** major key for constants on data base */
  int dbmajor;
/** minor key for constants on data base */
  int dbminor;
/** unix time */
  int time;
/** geometry version */
  float vgeo;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** tracks or seeds */
struct TATR
{
/** selected by: 1= alig.,2=calib.,3=both */
  int who;
/** chi**2 of fit */
  float chi;
/** detector component ITR=3,OTR=2 */
  int cmp;
/** fit flag */
  int fit;
/** 1/p (signed acc. charge) of first RHIT */
  float p;
/** first related TAHB */
  int tahb1;
/** last  related TAHB */
  int tahbl;
/** seed x */
  float x;
/** seed y */
  float y;
/** seed px/pz */
  float tx;
/** seed py/pz */
  float ty;
/** seed z */
  float z;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Table of Particle decays */
struct TDEC
{
/** Arte code for mother particle */
  int moth;
/** Arte code for daughter particles */
  int daug[5];
/** Lund MDME array */
  int mdme[2];
/** branching ratio */
  float brat;
/** next decay channel for same mother */
  ArtePointer<TDEC> next;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** temporary working space */
struct TEMP
{
/** any */
  int temp;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** temporary working space */
struct TMP0
{
/** any */
  int temp;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** temporary working space */
struct TMP1
{
/** any */
  int temp;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** temporary working space */
struct TMP2
{
/** any */
  int temp;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** temporary working space */
struct TMP3
{
/** any */
  int temp;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** temporary working space */
struct TMP4
{
/** any */
  int temp;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** temporary working space */
struct TMP5
{
/** any */
  int temp;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** temporary working space */
struct TMP6
{
/** any */
  int temp;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** temporary working space */
struct TMP7
{
/** any */
  int temp;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** temporary working space */
struct TMP8
{
/** any */
  int temp;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** temporary working space */
struct TMP9
{
/** any */
  int temp;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** Table of Particle Properties */
struct TOPP
{
/** particle name */
  char name[12];
/** mass */
  float mass;
/** width */
  float wid;
/** truncate Breit-Wigner at mass - trbw */
  float trbw;
/** life time */
  float life;
/** 3 * charge */
  int chrg;
/** colour information: 0 = colour singlet;
2 = gluon; 1 = quark or anti-diquark;
-1 = anti-quark or diquark */
  int colo;
/** Lund decay flag (0 = no decay) */
  int deca;
/** LUND code */
  int lund;
/** GEANT code */
  int gean;
/** anti-particle row number */
  ArtePointer<TOPP> anti;
/** 1st entry in table TDEC */
  ArtePointer<TDEC> tdec;
/** relation to many MC tracks */
  ArteInvOneRelationPointer<MTTO,MTRA> mtra;
/** relation to many reconstructed tracks */
  ArteInvOneRelationPointer<RTTO,RTRA> rtra;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** L2Simu track output */
struct XTRA
{
/** Absolute track number (= FLT track number) */
  int itra;
/** Flag for track accepts (= 1 if ACC) */
  int flag;
/** Total number of layers used in L2SIMU run */
  int nlay;
/** FLT RoI on TC2 (x2,y2,z2,x2_err,y2_err) */
  float flt2[5];
/** FLT RoI on PC1 (x1,y1,z1,x1_err,y1_err) */
  float flt1[5];
/** Number of hits used in refit-xz */
  int nhix;
/** Number of holes in refit-xz */
  int nhox;
/** Track slope after refit-xz */
  float slox;
/** Track intercept after refit-xz */
  float intx;
/** Covariance matrix after refit-xz */
  float covx[3];
/** Chisquare sum after refit-xz */
  float chix;
/** Number of hits used in refit-yz */
  int nhiy;
/** Number of holes in refit-yz */
  int nhoy;
/** Track slope after refit-yz */
  float sloy;
/** Track intercept after refit-yz */
  float inty;
/** Covariance matrix after refit-yz */
  float covy[3];
/** Chisquare sum after refit-yz */
  float chiy;
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** L2Simu trigger output */
struct XTRI
{
/** BX number for this trigger */
  int bx;
/** Absolute trigger number */
  int itri;
/** Pretrigger type */
  int type;
/** Flag for trigger accepts (= 1 if ACC) */
  int flag;
/** Last stage before trigger was rejected */
  int step;
/** Number of tracks for this trigger */
  int ntra;
/** Index to XTRA bank */
  int tra[2];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** L1 output track candidate */
struct YTRA
{
/** BunchCrossing for this message */
  int bx;
/** Pretrigger name */
  char id[4];
/** Total energy reconstructed */
  float e;
/** Px/Pz reconstructed */
  float pxpz;
/** Py/Pz reconstructed */
  float pypz;
/** charge reconstructed */
  int chrg;
/** X position of the center of the hit in TC2 SL */
  float xtc2;
/** Hit width in TC2 SL (+/- 0.5sx) */
  float sx2;
/** Y position of the center of the hit in TC2 SL */
  float ytc2;
/** Z position of the hit in TC2 SL */
  float ztc2;
/** X position of the center of the hit in PC1 SL */
  float xpc1;
/** Hit width in PC1 SL (+/- 0.5sx) */
  float sx1;
/** Z position of the hit in PC1 SL */
  float zpc1;
/** Hardware message (80 bits) */
  int msg[3];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 
/** L1 trigger message */
struct YTRI
{
/** BX for the trigger */
  int bx;
/** trigger pair names */
  char id[8];
/** First message of the pair in table L1TRA */
  int tra1;
/** Second message of the pair in table L1TRA */
  int tra2;
/** Pair invariant mass */
  float mass;
/** Hardware trigger descriptor (48 bit) */
  int msg[2];
#ifdef USE_ROOT
  void Streamer(TBuffer &R__b);
#endif
};
 

#ifdef __CINT__
template ArteTable<ACGA>;
template ArteTable<BEAM>;
template ArteTable<CDIM>;
template ArteTable<CEFF>;
template ArteTable<CLEN>;
template ArteTable<CPDW>;
template ArteTable<CPMD>;
template ArteTable<CPMI>;
template ArteTable<CPMT>;
template ArteTable<CPOI>;
template ArteTable<CSMI>;
template ArteTable<CSPM>;
template ArteTable<CSSM>;
template ArteTable<CSUP>;
template ArteTable<CVES>;
template ArteTable<D4LT>;
template ArteTable<DCAL>;
template ArteTable<DDAQ>;
template ArteTable<DDEF>;
template ArteTable<DDST>;
template ArteTable<DEVT>;
template ArteTable<DFCS>;
template ArteTable<DFLT>;
template ArteTable<DIGB>;
template ArteTable<DIHD>;
template ArteTable<DITR>;
template ArteTable<DKEY>;
template ArteTable<DMUP>;
template ArteTable<DMUT>;
template ArteTable<DMUX>;
template ArteTable<DOTR>;
template ArteTable<DPTC>;
template ArteTable<DRIC>;
template ArteTable<DSLT>;
template ArteTable<DSVD>;
template ArteTable<DTAR>;
template ArteTable<DTLT>;
template ArteTable<DTRD>;
template ArteTable<DTST>;
template ArteTable<ECBO>;
template ArteTable<ECHF>;
template ArteTable<ECHS>;
template ArteTable<ECHT>;
template ArteTable<ECPD>;
template ArteTable<ECSN>;
template ArteTable<ERRC>;
template ArteTable<EVFN>;
template ArteTable<EVHD>;
template ArteTable<FELD>;
template ArteTable<GCAL>;
template ArteTable<GCCE>;
template ArteTable<GCGD>;
template ArteTable<GEDE>;
template ArteTable<GEHD>;
template ArteTable<GESL>;
template ArteTable<GMAT>;
template ArteTable<GMIX>;
template ArteTable<GNEI>;
template ArteTable<GSSL>;
template ArteTable<GTAR>;
template ArteTable<GWAL>;
template ArteTable<HITB>;
template ArteTable<HITC>;
template ArteTable<MARK>;
template ArteTable<MCAL>;
template ArteTable<MCIN>;
template ArteTable<MCME>;
template ArteTable<MEIO>;
template ArteTable<MEMA>;
template ArteTable<MEMO>;
template ArteTable<MEMS>;
template ArteTable<MF01>;
template ArteTable<MF02>;
template ArteTable<MF03>;
template ArteTable<MF04>;
template ArteTable<MF05>;
template ArteTable<MF06>;
template ArteTable<MF07>;
template ArteTable<MF08>;
template ArteTable<MF09>;
template ArteTable<MF10>;
template ArteTable<MF11>;
template ArteTable<MF12>;
template ArteTable<MF13>;
template ArteTable<MF14>;
template ArteTable<MF15>;
template ArteTable<MF16>;
template ArteTable<MF17>;
template ArteTable<MF18>;
template ArteTable<MF19>;
template ArteTable<MF20>;
template ArteTable<MF21>;
template ArteTable<MFHD>;
template ArteTable<MFLD>;
template ArteTable<MIMP>;
template ArteTable<MTCP>;
template ArteTable<MTRA>;
template ArteTable<MVER>;
template ArteTable<NBEA>;
template ArteTable<NCAL>;
template ArteTable<NEDE>;
template ArteTable<NESL>;
template ArteTable<NFLD>;
template ArteTable<NGHD>;
template ArteTable<NTAR>;
template ArteTable<NWAL>;
template ArteTable<OTCD>;
template ArteTable<OTDR>;
template ArteTable<OTGL>;
template ArteTable<OTMO>;
template ArteTable<OTTE>;
template ArteTable<OTTS>;
template ArteTable<OTTZ>;
template ArteTable<PTAD>;
template ArteTable<PTAL>;
template ArteTable<PTCE>;
template ArteTable<PTCH>;
template ArteTable<PTCR>;
template ArteTable<PTFD>;
template ArteTable<PTGE>;
template ArteTable<PTMD>;
template ArteTable<RCCL>;
template ArteTable<RHIT>;
template ArteTable<RPNT>;
template ArteTable<RREL>;
template ArteTable<RSEG>;
template ArteTable<RTRA>;
template ArteTable<RVER>;
template ArteTable<SHCA>;
template ArteTable<SHPR>;
template ArteTable<SHRC>;
template ArteTable<SNAB>;
template ArteTable<SNAV>;
template ArteTable<SNAX>;
template ArteTable<SPAR>;
template ArteTable<SPAS>;
template ArteTable<SSEE>;
template ArteTable<SSTA>;
template ArteTable<STCA>;
template ArteTable<STPR>;
template ArteTable<STRC>;
template ArteTable<SUSI>;
template ArteTable<TDEC>;
template ArteTable<TEMP>;
template ArteTable<TMP0>;
template ArteTable<TMP1>;
template ArteTable<TMP2>;
template ArteTable<TMP3>;
template ArteTable<TMP4>;
template ArteTable<TMP5>;
template ArteTable<TMP6>;
template ArteTable<TMP7>;
template ArteTable<TMP8>;
template ArteTable<TMP9>;
template ArteTable<TOPP>;
template ArteTable<XTRA>;
template ArteTable<XTRI>;
template ArteTable<YTRA>;
template ArteTable<YTRI>;
class ArteRelationPointer<HIDI,DIGB>;
class ArteRelationPointer<MIDI,DIGB>;
class ArteRelationPointer<GSGC,GCAL>;
class ArteRelationPointer<GMGC,GCAL>;
class ArteRelationPointer<GSGD,GEDE>;
class ArteRelationPointer<GMGD,GEDE>;
class ArteRelationPointer<GDOM,OTMO>;
class ArteRelationPointer<GSGW,GWAL>;
class ArteRelationPointer<GMGW,GWAL>;
class ArteRelationPointer<GMND,NEDE>;
class ArteRelationPointer<GMNC,NCAL>;
class ArteRelationPointer<GMNW,NWAL>;
class ArteRelationPointer<RTHI,HITB>;
class ArteRelationPointer<MIHI,HITB>;
class ArteRelationPointer<RSHI,HITB>;
class ArteRelationPointer<HIRH,RHIT>;
class ArteRelationPointer<RTHC,HITC>;
class ArteRelationPointer<MCHC,HITC>;
class ArteRelationPointer<RCHC,HITC>;
class ArteRelationPointer<MTMC,MCAL>;
class ArteRelationPointer<MVME,MCME>;
class ArteRelationPointer<MTMI,MIMP>;
class ArteRelationPointer<MTMP,MTCP>;
class ArteRelationPointer<MTTO,MTRA>;
class ArteRelationPointer<RTMT,MTRA>;
class ArteRelationPointer<RCMT,MTRA>;
class ArteRelationPointer<MVMT,MTRA>;
class ArteRelationPointer<MTMT,MTRA>;
class ArteRelationPointer<MTMV,MVER>;
class ArteRelationPointer<MTRS,RSEG>;
class ArteRelationPointer<NSNC,NCAL>;
class ArteRelationPointer<NSND,NEDE>;
class ArteRelationPointer<NSNW,NWAL>;
class ArteRelationPointer<PXAF,PTAD>;
class ArteRelationPointer<PXCA,PTCH>;
class ArteRelationPointer<PXGM,PTAL>;
class ArteRelationPointer<PXGA,PTAL>;
class ArteRelationPointer<PXGC,PTCE>;
class ArteRelationPointer<PXCC,PTCE>;
class ArteRelationPointer<PXCM,PTCR>;
class ArteRelationPointer<PXFC,PTFD>;
class ArteRelationPointer<RTRC,RCCL>;
class ArteRelationPointer<RCRS,RSEG>;
class ArteRelationPointer<RSRH,RHIT>;
class ArteRelationPointer<RTRP,RPNT>;
class ArteRelationPointer<RSRP,RPNT>;
class ArteRelationPointer<RRRT,RREL>;
class ArteRelationPointer<RRRV,RREL>;
class ArteRelationPointer<RTRS,RSEG>;
class ArteRelationPointer<RSRS,RSEG>;
class ArteRelationPointer<RTTO,RTRA>;
class ArteRelationPointer<RVRT,RVER>;
class ArteRelationPointer<SPSH,SHPR>;
class ArteRelationPointer<SRSH,SHRC>;
class ArteRelationPointer<SBSN,SNAB>;
class ArteRelationPointer<SNSN,SNAX>;
class ArteRelationPointer<SPSS,SSEE>;
template ArteTable<TAHB>;
template ArteTable<TAHD>;
template ArteTable<TATR>;
template ArteTable<ACTR>;
template ArteTable<EVRC>;
template ArteTable<RITH>;
template ArteTable<EVHI>;
template ArteTable<DTA1>;
template ArteTable<EVTI>;
template ArteTable<RTRI>;
template ArteTable<RTAR>;
template ArteTable<RSLA>;
template ArteTable<RSLI>;
template ArteTable<HITL>;
#endif /* defined(__CINT__) */

#ifndef CREATELINKS
extern
#endif
struct ArteLinkStruct
{
#ifndef NO_ARTE
ArteVector larln1,larlnl,narlnk,jlink;
#endif
ArteVector jacga;
ArteVector jbeam;
ArteVector jcdim;
ArteVector jceff;
ArteVector jclen;
ArteVector jcpdw;
ArteVector jcpmd;
ArteVector jcpmi;
ArteVector jcpmt;
ArteVector jcpoi;
ArteVector jcsmi;
ArteVector jcspm;
ArteVector jcssm;
ArteVector jcsup;
ArteVector jcves;
ArteVector jd4lt;
ArteVector jdcal;
ArteVector jddaq;
ArteVector jddef;
ArteVector jddst;
ArteVector jdevt;
ArteVector jdfcs;
ArteVector jdflt;
ArteVector jdigb;
ArteVector jdihd;
ArteVector jditr;
ArteVector jdkey;
ArteVector jdmup;
ArteVector jdmut;
ArteVector jdmux;
ArteVector jdotr;
ArteVector jdptc;
ArteVector jdric;
ArteVector jdslt;
ArteVector jdsvd;
ArteVector jdtar;
ArteVector jdtlt;
ArteVector jdtrd;
ArteVector jdtst;
ArteVector jecbo;
ArteVector jechf;
ArteVector jechs;
ArteVector jecht;
ArteVector jecpd;
ArteVector jecsn;
ArteVector jerrc;
ArteVector jevfn;
ArteVector jevhd;
ArteVector jfeld;
ArteVector jgcal;
ArteVector jgcce;
ArteVector jgcgd;
ArteVector jgede;
ArteVector jgehd;
ArteVector jgesl;
ArteVector jgmat;
ArteVector jgmix;
ArteVector jgnei;
ArteVector jgssl;
ArteVector jgtar;
ArteVector jgwal;
ArteVector jhitb;
ArteVector jhitc;
ArteVector jmark;
ArteVector jmcal;
ArteVector jmcin;
ArteVector jmcme;
ArteVector jmeio;
ArteVector jmema;
ArteVector jmemo;
ArteVector jmems;
ArteVector jmf01;
ArteVector jmf02;
ArteVector jmf03;
ArteVector jmf04;
ArteVector jmf05;
ArteVector jmf06;
ArteVector jmf07;
ArteVector jmf08;
ArteVector jmf09;
ArteVector jmf10;
ArteVector jmf11;
ArteVector jmf12;
ArteVector jmf13;
ArteVector jmf14;
ArteVector jmf15;
ArteVector jmf16;
ArteVector jmf17;
ArteVector jmf18;
ArteVector jmf19;
ArteVector jmf20;
ArteVector jmf21;
ArteVector jmfhd;
ArteVector jmfld;
ArteVector jmimp;
ArteVector jmtcp;
ArteVector jmtra;
ArteVector jmver;
ArteVector jnbea;
ArteVector jncal;
ArteVector jnede;
ArteVector jnesl;
ArteVector jnfld;
ArteVector jnghd;
ArteVector jntar;
ArteVector jnwal;
ArteVector jotcd;
ArteVector jotdr;
ArteVector jotgl;
ArteVector jotmo;
ArteVector jotte;
ArteVector jotts;
ArteVector jottz;
ArteVector jptad;
ArteVector jptal;
ArteVector jptce;
ArteVector jptch;
ArteVector jptcr;
ArteVector jptfd;
ArteVector jptge;
ArteVector jptmd;
ArteVector jrccl;
ArteVector jrhit;
ArteVector jrpnt;
ArteVector jrrel;
ArteVector jrseg;
ArteVector jrtra;
ArteVector jrver;
ArteVector jshca;
ArteVector jshpr;
ArteVector jshrc;
ArteVector jsnab;
ArteVector jsnav;
ArteVector jsnax;
ArteVector jspar;
ArteVector jspas;
ArteVector jssee;
ArteVector jssta;
ArteVector jstca;
ArteVector jstpr;
ArteVector jstrc;
ArteVector jsusi;
ArteVector jtdec;
ArteVector jtemp;
ArteVector jtmp0;
ArteVector jtmp1;
ArteVector jtmp2;
ArteVector jtmp3;
ArteVector jtmp4;
ArteVector jtmp5;
ArteVector jtmp6;
ArteVector jtmp7;
ArteVector jtmp8;
ArteVector jtmp9;
ArteVector jtopp;
ArteVector jxtra;
ArteVector jxtri;
ArteVector jytra;
ArteVector jytri;
ArteRelVector<HIDI> jhidi;
ArteRelVector<MIDI> jmidi;
ArteRelVector<GSGC> jgsgc;
ArteRelVector<GMGC> jgmgc;
ArteRelVector<GSGD> jgsgd;
ArteRelVector<GMGD> jgmgd;
ArteRelVector<GDOM> jgdom;
ArteRelVector<GSGW> jgsgw;
ArteRelVector<GMGW> jgmgw;
ArteRelVector<GMND> jgmnd;
ArteRelVector<GMNC> jgmnc;
ArteRelVector<GMNW> jgmnw;
ArteRelVector<RTHI> jrthi;
ArteRelVector<MIHI> jmihi;
ArteRelVector<RSHI> jrshi;
ArteRelVector<HIRH> jhirh;
ArteRelVector<RTHC> jrthc;
ArteRelVector<MCHC> jmchc;
ArteRelVector<RCHC> jrchc;
ArteRelVector<MTMC> jmtmc;
ArteRelVector<MVME> jmvme;
ArteRelVector<MTMI> jmtmi;
ArteRelVector<MTMP> jmtmp;
ArteRelVector<MTTO> jmtto;
ArteRelVector<RTMT> jrtmt;
ArteRelVector<RCMT> jrcmt;
ArteRelVector<MVMT> jmvmt;
ArteRelVector<MTMT> jmtmt;
ArteRelVector<MTMV> jmtmv;
ArteRelVector<MTRS> jmtrs;
ArteRelVector<NSNC> jnsnc;
ArteRelVector<NSND> jnsnd;
ArteRelVector<NSNW> jnsnw;
ArteRelVector<PXAF> jpxaf;
ArteRelVector<PXCA> jpxca;
ArteRelVector<PXGM> jpxgm;
ArteRelVector<PXGA> jpxga;
ArteRelVector<PXGC> jpxgc;
ArteRelVector<PXCC> jpxcc;
ArteRelVector<PXCM> jpxcm;
ArteRelVector<PXFC> jpxfc;
ArteRelVector<RTRC> jrtrc;
ArteRelVector<RCRS> jrcrs;
ArteRelVector<RSRH> jrsrh;
ArteRelVector<RTRP> jrtrp;
ArteRelVector<RSRP> jrsrp;
ArteRelVector<RRRT> jrrrt;
ArteRelVector<RRRV> jrrrv;
ArteRelVector<RTRS> jrtrs;
ArteRelVector<RSRS> jrsrs;
ArteRelVector<RTTO> jrtto;
ArteRelVector<RVRT> jrvrt;
ArteRelVector<SPSH> jspsh;
ArteRelVector<SRSH> jsrsh;
ArteRelVector<SBSN> jsbsn;
ArteRelVector<SNSN> jsnsn;
ArteRelVector<SPSS> jspss;
ArteVector jtahb;
ArteVector jtahd;
ArteVector jtatr;
ArteVector jactr;
ArteVector jevrc;
ArteVector jrith;
ArteVector jevhi;
ArteVector jdta1;
ArteVector jevti;
ArteVector jrtri;
ArteVector jrtar;
ArteVector jrsla;
ArteVector jrsli;
ArteVector jhitl;
ArteVector jlast;
} artelink_;
template <> inline void* ArteTable<ACGA>::getLink()
{ return &artelink_.jacga; }

template <> inline void* ArteTable<BEAM>::getLink()
{ return &artelink_.jbeam; }

template <> inline void* ArteTable<CDIM>::getLink()
{ return &artelink_.jcdim; }

template <> inline void* ArteTable<CEFF>::getLink()
{ return &artelink_.jceff; }

template <> inline void* ArteTable<CLEN>::getLink()
{ return &artelink_.jclen; }

template <> inline void* ArteTable<CPDW>::getLink()
{ return &artelink_.jcpdw; }

template <> inline void* ArteTable<CPMD>::getLink()
{ return &artelink_.jcpmd; }

template <> inline void* ArteTable<CPMI>::getLink()
{ return &artelink_.jcpmi; }

template <> inline void* ArteTable<CPMT>::getLink()
{ return &artelink_.jcpmt; }

template <> inline void* ArteTable<CPOI>::getLink()
{ return &artelink_.jcpoi; }

template <> inline void* ArteTable<CSMI>::getLink()
{ return &artelink_.jcsmi; }

template <> inline void* ArteTable<CSPM>::getLink()
{ return &artelink_.jcspm; }

template <> inline void* ArteTable<CSSM>::getLink()
{ return &artelink_.jcssm; }

template <> inline void* ArteTable<CSUP>::getLink()
{ return &artelink_.jcsup; }

template <> inline void* ArteTable<CVES>::getLink()
{ return &artelink_.jcves; }

template <> inline void* ArteTable<D4LT>::getLink()
{ return &artelink_.jd4lt; }

template <> inline void* ArteTable<DCAL>::getLink()
{ return &artelink_.jdcal; }

template <> inline void* ArteTable<DDAQ>::getLink()
{ return &artelink_.jddaq; }

template <> inline void* ArteTable<DDEF>::getLink()
{ return &artelink_.jddef; }

template <> inline void* ArteTable<DDST>::getLink()
{ return &artelink_.jddst; }

template <> inline void* ArteTable<DEVT>::getLink()
{ return &artelink_.jdevt; }

template <> inline void* ArteTable<DFCS>::getLink()
{ return &artelink_.jdfcs; }

template <> inline void* ArteTable<DFLT>::getLink()
{ return &artelink_.jdflt; }

template <> inline void* ArteTable<DIGB>::getLink()
{ return &artelink_.jdigb; }

template <> inline void* ArteTable<DIHD>::getLink()
{ return &artelink_.jdihd; }

template <> inline void* ArteTable<DITR>::getLink()
{ return &artelink_.jditr; }

template <> inline void* ArteTable<DKEY>::getLink()
{ return &artelink_.jdkey; }

template <> inline void* ArteTable<DMUP>::getLink()
{ return &artelink_.jdmup; }

template <> inline void* ArteTable<DMUT>::getLink()
{ return &artelink_.jdmut; }

template <> inline void* ArteTable<DMUX>::getLink()
{ return &artelink_.jdmux; }

template <> inline void* ArteTable<DOTR>::getLink()
{ return &artelink_.jdotr; }

template <> inline void* ArteTable<DPTC>::getLink()
{ return &artelink_.jdptc; }

template <> inline void* ArteTable<DRIC>::getLink()
{ return &artelink_.jdric; }

template <> inline void* ArteTable<DSLT>::getLink()
{ return &artelink_.jdslt; }

template <> inline void* ArteTable<DSVD>::getLink()
{ return &artelink_.jdsvd; }

template <> inline void* ArteTable<DTAR>::getLink()
{ return &artelink_.jdtar; }

template <> inline void* ArteTable<DTLT>::getLink()
{ return &artelink_.jdtlt; }

template <> inline void* ArteTable<DTRD>::getLink()
{ return &artelink_.jdtrd; }

template <> inline void* ArteTable<DTST>::getLink()
{ return &artelink_.jdtst; }

template <> inline void* ArteTable<ECBO>::getLink()
{ return &artelink_.jecbo; }

template <> inline void* ArteTable<ECHF>::getLink()
{ return &artelink_.jechf; }

template <> inline void* ArteTable<ECHS>::getLink()
{ return &artelink_.jechs; }

template <> inline void* ArteTable<ECHT>::getLink()
{ return &artelink_.jecht; }

template <> inline void* ArteTable<ECPD>::getLink()
{ return &artelink_.jecpd; }

template <> inline void* ArteTable<ECSN>::getLink()
{ return &artelink_.jecsn; }

template <> inline void* ArteTable<ERRC>::getLink()
{ return &artelink_.jerrc; }

template <> inline void* ArteTable<EVFN>::getLink()
{ return &artelink_.jevfn; }

template <> inline void* ArteTable<EVHD>::getLink()
{ return &artelink_.jevhd; }

template <> inline void* ArteTable<FELD>::getLink()
{ return &artelink_.jfeld; }

template <> inline void* ArteTable<GCAL>::getLink()
{ return &artelink_.jgcal; }

template <> inline void* ArteTable<GCCE>::getLink()
{ return &artelink_.jgcce; }

template <> inline void* ArteTable<GCGD>::getLink()
{ return &artelink_.jgcgd; }

template <> inline void* ArteTable<GEDE>::getLink()
{ return &artelink_.jgede; }

template <> inline void* ArteTable<GEHD>::getLink()
{ return &artelink_.jgehd; }

template <> inline void* ArteTable<GESL>::getLink()
{ return &artelink_.jgesl; }

template <> inline void* ArteTable<GMAT>::getLink()
{ return &artelink_.jgmat; }

template <> inline void* ArteTable<GMIX>::getLink()
{ return &artelink_.jgmix; }

template <> inline void* ArteTable<GNEI>::getLink()
{ return &artelink_.jgnei; }

template <> inline void* ArteTable<GSSL>::getLink()
{ return &artelink_.jgssl; }

template <> inline void* ArteTable<GTAR>::getLink()
{ return &artelink_.jgtar; }

template <> inline void* ArteTable<GWAL>::getLink()
{ return &artelink_.jgwal; }

template <> inline void* ArteTable<HITB>::getLink()
{ return &artelink_.jhitb; }

template <> inline void* ArteTable<HITC>::getLink()
{ return &artelink_.jhitc; }

template <> inline void* ArteTable<MARK>::getLink()
{ return &artelink_.jmark; }

template <> inline void* ArteTable<MCAL>::getLink()
{ return &artelink_.jmcal; }

template <> inline void* ArteTable<MCIN>::getLink()
{ return &artelink_.jmcin; }

template <> inline void* ArteTable<MCME>::getLink()
{ return &artelink_.jmcme; }

template <> inline void* ArteTable<MEIO>::getLink()
{ return &artelink_.jmeio; }

template <> inline void* ArteTable<MEMA>::getLink()
{ return &artelink_.jmema; }

template <> inline void* ArteTable<MEMO>::getLink()
{ return &artelink_.jmemo; }

template <> inline void* ArteTable<MEMS>::getLink()
{ return &artelink_.jmems; }

template <> inline void* ArteTable<MF01>::getLink()
{ return &artelink_.jmf01; }

template <> inline void* ArteTable<MF02>::getLink()
{ return &artelink_.jmf02; }

template <> inline void* ArteTable<MF03>::getLink()
{ return &artelink_.jmf03; }

template <> inline void* ArteTable<MF04>::getLink()
{ return &artelink_.jmf04; }

template <> inline void* ArteTable<MF05>::getLink()
{ return &artelink_.jmf05; }

template <> inline void* ArteTable<MF06>::getLink()
{ return &artelink_.jmf06; }

template <> inline void* ArteTable<MF07>::getLink()
{ return &artelink_.jmf07; }

template <> inline void* ArteTable<MF08>::getLink()
{ return &artelink_.jmf08; }

template <> inline void* ArteTable<MF09>::getLink()
{ return &artelink_.jmf09; }

template <> inline void* ArteTable<MF10>::getLink()
{ return &artelink_.jmf10; }

template <> inline void* ArteTable<MF11>::getLink()
{ return &artelink_.jmf11; }

template <> inline void* ArteTable<MF12>::getLink()
{ return &artelink_.jmf12; }

template <> inline void* ArteTable<MF13>::getLink()
{ return &artelink_.jmf13; }

template <> inline void* ArteTable<MF14>::getLink()
{ return &artelink_.jmf14; }

template <> inline void* ArteTable<MF15>::getLink()
{ return &artelink_.jmf15; }

template <> inline void* ArteTable<MF16>::getLink()
{ return &artelink_.jmf16; }

template <> inline void* ArteTable<MF17>::getLink()
{ return &artelink_.jmf17; }

template <> inline void* ArteTable<MF18>::getLink()
{ return &artelink_.jmf18; }

template <> inline void* ArteTable<MF19>::getLink()
{ return &artelink_.jmf19; }

template <> inline void* ArteTable<MF20>::getLink()
{ return &artelink_.jmf20; }

template <> inline void* ArteTable<MF21>::getLink()
{ return &artelink_.jmf21; }

template <> inline void* ArteTable<MFHD>::getLink()
{ return &artelink_.jmfhd; }

template <> inline void* ArteTable<MFLD>::getLink()
{ return &artelink_.jmfld; }

template <> inline void* ArteTable<MIMP>::getLink()
{ return &artelink_.jmimp; }

template <> inline void* ArteTable<MTCP>::getLink()
{ return &artelink_.jmtcp; }

template <> inline void* ArteTable<MTRA>::getLink()
{ return &artelink_.jmtra; }

template <> inline void* ArteTable<MVER>::getLink()
{ return &artelink_.jmver; }

template <> inline void* ArteTable<NBEA>::getLink()
{ return &artelink_.jnbea; }

template <> inline void* ArteTable<NCAL>::getLink()
{ return &artelink_.jncal; }

template <> inline void* ArteTable<NEDE>::getLink()
{ return &artelink_.jnede; }

template <> inline void* ArteTable<NESL>::getLink()
{ return &artelink_.jnesl; }

template <> inline void* ArteTable<NFLD>::getLink()
{ return &artelink_.jnfld; }

template <> inline void* ArteTable<NGHD>::getLink()
{ return &artelink_.jnghd; }

template <> inline void* ArteTable<NTAR>::getLink()
{ return &artelink_.jntar; }

template <> inline void* ArteTable<NWAL>::getLink()
{ return &artelink_.jnwal; }

template <> inline void* ArteTable<OTCD>::getLink()
{ return &artelink_.jotcd; }

template <> inline void* ArteTable<OTDR>::getLink()
{ return &artelink_.jotdr; }

template <> inline void* ArteTable<OTGL>::getLink()
{ return &artelink_.jotgl; }

template <> inline void* ArteTable<OTMO>::getLink()
{ return &artelink_.jotmo; }

template <> inline void* ArteTable<OTTE>::getLink()
{ return &artelink_.jotte; }

template <> inline void* ArteTable<OTTS>::getLink()
{ return &artelink_.jotts; }

template <> inline void* ArteTable<OTTZ>::getLink()
{ return &artelink_.jottz; }

template <> inline void* ArteTable<PTAD>::getLink()
{ return &artelink_.jptad; }

template <> inline void* ArteTable<PTAL>::getLink()
{ return &artelink_.jptal; }

template <> inline void* ArteTable<PTCE>::getLink()
{ return &artelink_.jptce; }

template <> inline void* ArteTable<PTCH>::getLink()
{ return &artelink_.jptch; }

template <> inline void* ArteTable<PTCR>::getLink()
{ return &artelink_.jptcr; }

template <> inline void* ArteTable<PTFD>::getLink()
{ return &artelink_.jptfd; }

template <> inline void* ArteTable<PTGE>::getLink()
{ return &artelink_.jptge; }

template <> inline void* ArteTable<PTMD>::getLink()
{ return &artelink_.jptmd; }

template <> inline void* ArteTable<RCCL>::getLink()
{ return &artelink_.jrccl; }

template <> inline void* ArteTable<RHIT>::getLink()
{ return &artelink_.jrhit; }

template <> inline void* ArteTable<RPNT>::getLink()
{ return &artelink_.jrpnt; }

template <> inline void* ArteTable<RREL>::getLink()
{ return &artelink_.jrrel; }

template <> inline void* ArteTable<RSEG>::getLink()
{ return &artelink_.jrseg; }

template <> inline void* ArteTable<RTRA>::getLink()
{ return &artelink_.jrtra; }

template <> inline void* ArteTable<RVER>::getLink()
{ return &artelink_.jrver; }

template <> inline void* ArteTable<SHCA>::getLink()
{ return &artelink_.jshca; }

template <> inline void* ArteTable<SHPR>::getLink()
{ return &artelink_.jshpr; }

template <> inline void* ArteTable<SHRC>::getLink()
{ return &artelink_.jshrc; }

template <> inline void* ArteTable<SNAB>::getLink()
{ return &artelink_.jsnab; }

template <> inline void* ArteTable<SNAV>::getLink()
{ return &artelink_.jsnav; }

template <> inline void* ArteTable<SNAX>::getLink()
{ return &artelink_.jsnax; }

template <> inline void* ArteTable<SPAR>::getLink()
{ return &artelink_.jspar; }

template <> inline void* ArteTable<SPAS>::getLink()
{ return &artelink_.jspas; }

template <> inline void* ArteTable<SSEE>::getLink()
{ return &artelink_.jssee; }

template <> inline void* ArteTable<SSTA>::getLink()
{ return &artelink_.jssta; }

template <> inline void* ArteTable<STCA>::getLink()
{ return &artelink_.jstca; }

template <> inline void* ArteTable<STPR>::getLink()
{ return &artelink_.jstpr; }

template <> inline void* ArteTable<STRC>::getLink()
{ return &artelink_.jstrc; }

template <> inline void* ArteTable<SUSI>::getLink()
{ return &artelink_.jsusi; }

template <> inline void* ArteTable<TDEC>::getLink()
{ return &artelink_.jtdec; }

template <> inline void* ArteTable<TEMP>::getLink()
{ return &artelink_.jtemp; }

template <> inline void* ArteTable<TMP0>::getLink()
{ return &artelink_.jtmp0; }

template <> inline void* ArteTable<TMP1>::getLink()
{ return &artelink_.jtmp1; }

template <> inline void* ArteTable<TMP2>::getLink()
{ return &artelink_.jtmp2; }

template <> inline void* ArteTable<TMP3>::getLink()
{ return &artelink_.jtmp3; }

template <> inline void* ArteTable<TMP4>::getLink()
{ return &artelink_.jtmp4; }

template <> inline void* ArteTable<TMP5>::getLink()
{ return &artelink_.jtmp5; }

template <> inline void* ArteTable<TMP6>::getLink()
{ return &artelink_.jtmp6; }

template <> inline void* ArteTable<TMP7>::getLink()
{ return &artelink_.jtmp7; }

template <> inline void* ArteTable<TMP8>::getLink()
{ return &artelink_.jtmp8; }

template <> inline void* ArteTable<TMP9>::getLink()
{ return &artelink_.jtmp9; }

template <> inline void* ArteTable<TOPP>::getLink()
{ return &artelink_.jtopp; }

template <> inline void* ArteTable<XTRA>::getLink()
{ return &artelink_.jxtra; }

template <> inline void* ArteTable<XTRI>::getLink()
{ return &artelink_.jxtri; }

template <> inline void* ArteTable<YTRA>::getLink()
{ return &artelink_.jytra; }

template <> inline void* ArteTable<YTRI>::getLink()
{ return &artelink_.jytri; }

struct HIDI {};
template <> inline ArteRelVector<HIDI>& ArteInvOneRelationPointer<HIDI,DIGB>::getLink()
{ return artelink_.jhidi; }

struct MIDI {};
template <> inline ArteRelVector<MIDI>& ArteManRelationPointer<MIDI,MIMP>::getLink()
{ return artelink_.jmidi; }

template <> inline ArteRelVector<MIDI>& ArteInvManRelationPointer<MIDI,DIGB>::getLink()
{ return artelink_.jmidi; }

struct GSGC {};
template <> inline ArteRelVector<GSGC>& ArteInvOneRelationPointer<GSGC,GCAL>::getLink()
{ return artelink_.jgsgc; }

struct GMGC {};
template <> inline ArteRelVector<GMGC>& ArteInvOneRelationPointer<GMGC,GCAL>::getLink()
{ return artelink_.jgmgc; }

struct GSGD {};
template <> inline ArteRelVector<GSGD>& ArteInvOneRelationPointer<GSGD,GEDE>::getLink()
{ return artelink_.jgsgd; }

struct GMGD {};
template <> inline ArteRelVector<GMGD>& ArteInvOneRelationPointer<GMGD,GEDE>::getLink()
{ return artelink_.jgmgd; }

struct GDOM {};
template <> inline ArteRelVector<GDOM>& ArteInvOneRelationPointer<GDOM,OTMO>::getLink()
{ return artelink_.jgdom; }

struct GSGW {};
template <> inline ArteRelVector<GSGW>& ArteInvOneRelationPointer<GSGW,GWAL>::getLink()
{ return artelink_.jgsgw; }

struct GMGW {};
template <> inline ArteRelVector<GMGW>& ArteInvOneRelationPointer<GMGW,GWAL>::getLink()
{ return artelink_.jgmgw; }

struct GMND {};
template <> inline ArteRelVector<GMND>& ArteInvOneRelationPointer<GMND,NEDE>::getLink()
{ return artelink_.jgmnd; }

struct GMNC {};
template <> inline ArteRelVector<GMNC>& ArteInvOneRelationPointer<GMNC,NCAL>::getLink()
{ return artelink_.jgmnc; }

struct GMNW {};
template <> inline ArteRelVector<GMNW>& ArteInvOneRelationPointer<GMNW,NWAL>::getLink()
{ return artelink_.jgmnw; }

struct RTHI {};
template <> inline ArteRelVector<RTHI>& ArteManRelationPointer<RTHI,RTRA>::getLink()
{ return artelink_.jrthi; }

template <> inline ArteRelVector<RTHI>& ArteInvManRelationPointer<RTHI,HITB>::getLink()
{ return artelink_.jrthi; }

struct MIHI {};
template <> inline ArteRelVector<MIHI>& ArteManRelationPointer<MIHI,MIMP>::getLink()
{ return artelink_.jmihi; }

template <> inline ArteRelVector<MIHI>& ArteInvManRelationPointer<MIHI,HITB>::getLink()
{ return artelink_.jmihi; }

struct RSHI {};
template <> inline ArteRelVector<RSHI>& ArteManRelationPointer<RSHI,RSEG>::getLink()
{ return artelink_.jrshi; }

template <> inline ArteRelVector<RSHI>& ArteInvManRelationPointer<RSHI,HITB>::getLink()
{ return artelink_.jrshi; }

struct HIRH {};
template <> inline ArteRelVector<HIRH>& ArteInvOneRelationPointer<HIRH,RHIT>::getLink()
{ return artelink_.jhirh; }

struct RTHC {};
template <> inline ArteRelVector<RTHC>& ArteManRelationPointer<RTHC,RTRA>::getLink()
{ return artelink_.jrthc; }

template <> inline ArteRelVector<RTHC>& ArteInvManRelationPointer<RTHC,HITC>::getLink()
{ return artelink_.jrthc; }

struct MCHC {};
template <> inline ArteRelVector<MCHC>& ArteManRelationPointer<MCHC,MCAL>::getLink()
{ return artelink_.jmchc; }

template <> inline ArteRelVector<MCHC>& ArteInvManRelationPointer<MCHC,HITC>::getLink()
{ return artelink_.jmchc; }

struct RCHC {};
template <> inline ArteRelVector<RCHC>& ArteManRelationPointer<RCHC,RCCL>::getLink()
{ return artelink_.jrchc; }

template <> inline ArteRelVector<RCHC>& ArteInvManRelationPointer<RCHC,HITC>::getLink()
{ return artelink_.jrchc; }

struct MTMC {};
template <> inline ArteRelVector<MTMC>& ArteInvOneRelationPointer<MTMC,MCAL>::getLink()
{ return artelink_.jmtmc; }

struct MVME {};
template <> inline ArteRelVector<MVME>& ArteInvOneRelationPointer<MVME,MCME>::getLink()
{ return artelink_.jmvme; }

struct MTMI {};
template <> inline ArteRelVector<MTMI>& ArteInvOneRelationPointer<MTMI,MIMP>::getLink()
{ return artelink_.jmtmi; }

struct MTMP {};
template <> inline ArteRelVector<MTMP>& ArteInvOneRelationPointer<MTMP,MTCP>::getLink()
{ return artelink_.jmtmp; }

struct MTTO {};
template <> inline ArteRelVector<MTTO>& ArteInvOneRelationPointer<MTTO,MTRA>::getLink()
{ return artelink_.jmtto; }

struct RTMT {};
template <> inline ArteRelVector<RTMT>& ArteManRelationPointer<RTMT,RTRA>::getLink()
{ return artelink_.jrtmt; }

template <> inline ArteRelVector<RTMT>& ArteInvManRelationPointer<RTMT,MTRA>::getLink()
{ return artelink_.jrtmt; }

struct RCMT {};
template <> inline ArteRelVector<RCMT>& ArteManRelationPointer<RCMT,RCCL>::getLink()
{ return artelink_.jrcmt; }

template <> inline ArteRelVector<RCMT>& ArteInvManRelationPointer<RCMT,MTRA>::getLink()
{ return artelink_.jrcmt; }

struct MVMT {};
template <> inline ArteRelVector<MVMT>& ArteInvOneRelationPointer<MVMT,MTRA>::getLink()
{ return artelink_.jmvmt; }

struct MTMT {};
template <> inline ArteRelVector<MTMT>& ArteInvOneRelationPointer<MTMT,MTRA>::getLink()
{ return artelink_.jmtmt; }

struct MTMV {};
template <> inline ArteRelVector<MTMV>& ArteInvOneRelationPointer<MTMV,MVER>::getLink()
{ return artelink_.jmtmv; }

struct MTRS {};
template <> inline ArteRelVector<MTRS>& ArteManRelationPointer<MTRS,MTRA>::getLink()
{ return artelink_.jmtrs; }

template <> inline ArteRelVector<MTRS>& ArteInvManRelationPointer<MTRS,RSEG>::getLink()
{ return artelink_.jmtrs; }

struct NSNC {};
template <> inline ArteRelVector<NSNC>& ArteInvOneRelationPointer<NSNC,NCAL>::getLink()
{ return artelink_.jnsnc; }

struct NSND {};
template <> inline ArteRelVector<NSND>& ArteInvOneRelationPointer<NSND,NEDE>::getLink()
{ return artelink_.jnsnd; }

struct NSNW {};
template <> inline ArteRelVector<NSNW>& ArteInvOneRelationPointer<NSNW,NWAL>::getLink()
{ return artelink_.jnsnw; }

struct PXAF {};
template <> inline ArteRelVector<PXAF>& ArteInvOneRelationPointer<PXAF,PTAD>::getLink()
{ return artelink_.jpxaf; }

struct PXCA {};
template <> inline ArteRelVector<PXCA>& ArteInvOneRelationPointer<PXCA,PTCH>::getLink()
{ return artelink_.jpxca; }

struct PXGM {};
template <> inline ArteRelVector<PXGM>& ArteInvOneRelationPointer<PXGM,PTAL>::getLink()
{ return artelink_.jpxgm; }

struct PXGA {};
template <> inline ArteRelVector<PXGA>& ArteInvOneRelationPointer<PXGA,PTAL>::getLink()
{ return artelink_.jpxga; }

struct PXGC {};
template <> inline ArteRelVector<PXGC>& ArteInvOneRelationPointer<PXGC,PTCE>::getLink()
{ return artelink_.jpxgc; }

struct PXCC {};
template <> inline ArteRelVector<PXCC>& ArteInvOneRelationPointer<PXCC,PTCE>::getLink()
{ return artelink_.jpxcc; }

struct PXCM {};
template <> inline ArteRelVector<PXCM>& ArteInvOneRelationPointer<PXCM,PTCR>::getLink()
{ return artelink_.jpxcm; }

struct PXFC {};
template <> inline ArteRelVector<PXFC>& ArteInvOneRelationPointer<PXFC,PTFD>::getLink()
{ return artelink_.jpxfc; }

struct RTRC {};
template <> inline ArteRelVector<RTRC>& ArteManRelationPointer<RTRC,RTRA>::getLink()
{ return artelink_.jrtrc; }

template <> inline ArteRelVector<RTRC>& ArteInvManRelationPointer<RTRC,RCCL>::getLink()
{ return artelink_.jrtrc; }

struct RCRS {};
template <> inline ArteRelVector<RCRS>& ArteManRelationPointer<RCRS,RCCL>::getLink()
{ return artelink_.jrcrs; }

template <> inline ArteRelVector<RCRS>& ArteInvManRelationPointer<RCRS,RSEG>::getLink()
{ return artelink_.jrcrs; }

struct RSRH {};
template <> inline ArteRelVector<RSRH>& ArteInvOneRelationPointer<RSRH,RHIT>::getLink()
{ return artelink_.jrsrh; }

struct RTRP {};
template <> inline ArteRelVector<RTRP>& ArteManRelationPointer<RTRP,RTRA>::getLink()
{ return artelink_.jrtrp; }

template <> inline ArteRelVector<RTRP>& ArteInvManRelationPointer<RTRP,RPNT>::getLink()
{ return artelink_.jrtrp; }

struct RSRP {};
template <> inline ArteRelVector<RSRP>& ArteInvOneRelationPointer<RSRP,RPNT>::getLink()
{ return artelink_.jrsrp; }

struct RRRT {};
template <> inline ArteRelVector<RRRT>& ArteInvOneRelationPointer<RRRT,RREL>::getLink()
{ return artelink_.jrrrt; }

struct RRRV {};
template <> inline ArteRelVector<RRRV>& ArteInvOneRelationPointer<RRRV,RREL>::getLink()
{ return artelink_.jrrrv; }

struct RTRS {};
template <> inline ArteRelVector<RTRS>& ArteManRelationPointer<RTRS,RTRA>::getLink()
{ return artelink_.jrtrs; }

template <> inline ArteRelVector<RTRS>& ArteInvManRelationPointer<RTRS,RSEG>::getLink()
{ return artelink_.jrtrs; }

struct RSRS {};
template <> inline ArteRelVector<RSRS>& ArteManRelationPointer<RSRS,RSEG>::getLink()
{ return artelink_.jrsrs; }

template <> inline ArteRelVector<RSRS>& ArteInvManRelationPointer<RSRS,RSEG>::getLink()
{ return artelink_.jrsrs; }

struct RTTO {};
template <> inline ArteRelVector<RTTO>& ArteInvOneRelationPointer<RTTO,RTRA>::getLink()
{ return artelink_.jrtto; }

struct RVRT {};
template <> inline ArteRelVector<RVRT>& ArteInvOneRelationPointer<RVRT,RVER>::getLink()
{ return artelink_.jrvrt; }

struct SPSH {};
template <> inline ArteRelVector<SPSH>& ArteInvOneRelationPointer<SPSH,SHPR>::getLink()
{ return artelink_.jspsh; }

struct SRSH {};
template <> inline ArteRelVector<SRSH>& ArteInvOneRelationPointer<SRSH,SHRC>::getLink()
{ return artelink_.jsrsh; }

struct SBSN {};
template <> inline ArteRelVector<SBSN>& ArteInvOneRelationPointer<SBSN,SNAB>::getLink()
{ return artelink_.jsbsn; }

struct SNSN {};
template <> inline ArteRelVector<SNSN>& ArteInvOneRelationPointer<SNSN,SNAX>::getLink()
{ return artelink_.jsnsn; }

struct SPSS {};
template <> inline ArteRelVector<SPSS>& ArteInvOneRelationPointer<SPSS,SSEE>::getLink()
{ return artelink_.jspss; }

template <> inline void* ArteTable<TAHB>::getLink()
{ return &artelink_.jtahb; }

template <> inline void* ArteTable<TAHD>::getLink()
{ return &artelink_.jtahd; }

template <> inline void* ArteTable<TATR>::getLink()
{ return &artelink_.jtatr; }

template <> inline void* ArteTable<ACTR>::getLink()
{ return &artelink_.jactr; }

template <> inline void* ArteTable<EVRC>::getLink()
{ return &artelink_.jevrc; }

template <> inline void* ArteTable<RITH>::getLink()
{ return &artelink_.jrith; }

template <> inline void* ArteTable<EVHI>::getLink()
{ return &artelink_.jevhi; }

template <> inline void* ArteTable<DTA1>::getLink()
{ return &artelink_.jdta1; }

template <> inline void* ArteTable<EVTI>::getLink()
{ return &artelink_.jevti; }

template <> inline void* ArteTable<RTRI>::getLink()
{ return &artelink_.jrtri; }

template <> inline void* ArteTable<RTAR>::getLink()
{ return &artelink_.jrtar; }

template <> inline void* ArteTable<RSLA>::getLink()
{ return &artelink_.jrsla; }

template <> inline void* ArteTable<RSLI>::getLink()
{ return &artelink_.jrsli; }

template <> inline void* ArteTable<HITL>::getLink()
{ return &artelink_.jhitl; }

#endif  /* defined(_AUTO_HH_) */
