#ifndef __DGOCELL_HH__
#define __DGOCELL_HH__

#ifndef __SGI_STL_VECTOR
#include <vector>
#endif

#ifndef ARTE_HH
#include <arte/arte.hh>
#endif
#ifndef _ZGDIG_HH_
#include <digi/zgdig.hh>
#endif

namespace dgocell
{
  float PathLengthHC(float pitch, float x, float tx, float ty) ;
  float FirstCluster(float dd, float eff) ; // dd: distance track to wire
  float MeasuredTime(float d, float acc) ;  // d: distance of first clus to wire
  float EstimatedRadius(float time, float pit, float acc=-1) ; // t: drift time
  float EstimatedSigma(float time, float pit, float acc=-1) ;  // t: drift time
  void GenerateXTalkHits( vector<digx>& dgvec, ArtePointer<GEDE> gf) ;
  void GenerateNoiseHits( vector<digx>& dgvec, ArtePointer<GEDE> gf) ;
  void CalibrateRT() ;
  void Initialize() ;
  void ForceInitialization() ;
} ;

#endif
