
/**************************************************************/
/*         r. spighi                                          */
/*                                                            */
/* Declaration of Histograms                                  */
/*                                                            */
/* changes:                                                   */
/* 12 Dec 2000 (AG) polished printout                         */
/*                                                            */
/**************************************************************/ 

#include <stdlib.h>
#include <stdio.h>

#include "rhp.h"

#include "farm/farm.hh"
#include "dq/DQ.h"
#include "dq/DQ_ECAL.h"



int DQ_ECAL_raw_init()
{
  ARTE_mark( "DQ_ECAL_raw_init 0", 0 );
  printf("DQ_ECAL_raw_init\n");

  //  unsigned int histogram_id1 = 1;     /* lowest */
  //  unsigned int histogram_id2 = 65535; /* highest */

  int   nbinx = 226; /* binning in x */
  float xmin  = 15.5;   /* minimal x */
  float xmax  = 241.5;   /* maximal x */

  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_RAW,15),"ECAL raw: All Fed data",nbinx,xmin,xmax);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_RAW,16),"ECAL raw:Good Fed",nbinx,xmin,xmax);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_RAW,17),"ECAL raw:Duplicated good Fed ID",nbinx,xmin,xmax);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_RAW,18),"ECAL raw:Missing FED ID",nbinx,xmin,xmax);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_RAW,19),"ECAL raw:Header errors in FED",nbinx,xmin,xmax);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_RAW,20),"ECAL raw:BX errors in FED",nbinx,xmin,xmax);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_RAW,21),"ECAL raw:Data errors",nbinx,xmin,xmax);

  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_RAW,22),"ECAL raw: problem FIFO FULL BX",nbinx,xmin,xmax);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_RAW,23),"ECAL raw: problem FIFO FULL Event Buff",nbinx,xmin,xmax);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_RAW,24),"ECAL raw: problem FIFO FULL Trigger Buff",nbinx,xmin,xmax);

  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_RAW,25),"ECAL raw: problem Size",nbinx,xmin,xmax);

  ARTE_mark( "DQ_ECAL_raw_init 1", 0 );
  return 0;  /* return error code (0 = okay) */
}
