// ****************************************************************
// source:    DQ_ITR.h
// author:    Sonja Wunderlich
//                                                                 
// 12.2000 (SW)   define histogram numbers                         
// 12.2000 (SW)   define control loops                             
// 01/22 (SW) Funktion to fill rhp-and hbook histograms             
//  4/14 (SW) a couple of new const int...
// *******************************************************************
#ifndef _DQ_ITR_H_
#define _DQ_ITR_H_
/* to give out hbook histogramms please define DQ_ITR_CONTROL */
#define DQ_ITR_CODE
//#define DQ_ITR_CONTROL
//#define DQ_ITR_LARGECONTROL
//#define DQ_ITR_DEBUG
//#define DQ_ITR_COMPILE

/* includes */
#include "event.h"
#include "hbook.h"
#include "rhp.h"

/* prototypes */
#ifdef __cplusplus
extern "C" {
#endif

int DQ_ITR_raw_init();
int DQ_ITR_raw_evnt( EVENT_HDR *event );

#ifdef __cplusplus
}
#endif

int DQ_ITR_hit_init();
int DQ_ITR_hit_evnt();
int DQ_ITR_rec_init();
int DQ_ITR_rec_evnt();
int DQ_ITR_raw_init();
int DQ_ITR_raw_evnt();
int DQ_ITR_Noisebehavior();
int DQ_ITR_buildIndex();
int DQ_ITR_buildIndex2();
int DQ_ITR_isKnown(int);
int DQ_ITR_isKnown2(int);
int DQ_ITR_chamberIndex(int);
int DQ_ITR_chamberIndex2(int);
int DQ_ITR_indexChamber(int);
int DQ_ITR_my_hbook1(int, int, char , int, float, float);
int DQ_ITR_my_hbook2(int, int, char, int, float, float, int, float, float);
int DQ_ITR_my_hf1_fill(int, int, float, float);
int DQ_ITR_my_hf2_fill(int, int, float, float, float);

const int k_Typ1 = 32;                      // 32 typ1
const int k_Typ1Typ2 = 136;                 // 32 typ1 + 104 typ2
const int k_Typ1Typ2Typ3 = 184;             // 32 typ1 + 104 typ2 + 48 typ3
const int k_numChamber = 184;
const int k_numHalfStation = 20;            // 20 for 2001 ( 16 for 2000)
const int k_numStrips = 768;

const int k_HelixPerChamber = 6;

const int NBUCKET = 220;
// wichtige konstanten die veraendert werden koennen 
const int TimeHistogramAbdate = 200;
const int ResetByEvent = 2000; 
const int EventForCalculation = 50;
const float SigalOverNoiseCut = 3;            //sqrt(9) looks reasenable

/* Histogram IDs */
const int h_ITR_targetrate   = 1;
const int h_HitsOnRSEGPerEvent = 2;  
const int h_RSEGPerEvent = 22;               //cut on hits
const int h_HitsOnRSEGQU_all = 222;
const int h_BXSpectrum = 4;
const int h_Occupancy_raw = 5;
const int h_HitsPerEvent = 55;
const int h_HitsPerEventSL = 555;    
const int h_Occupancy_bin = 6;
const int h_NoiseMeanTenEvent = 7;
const int h_NoisePerChamber = 8;
const int h_Signalovernoise = 88;
const int h_hitsoverSNcut = 888;
const int h_Residual   = 9;
const int h_Residualfine = 99;
const int h_numWorkingCham = 33;

const int h_event = 11;
const int h_ITR_numRSEG      = 1000;
const int h_ITR_matchedRSEG  = 1001;
const int h_ITR_matchRatio   = 1002;











#if defined(DQ_ITR_LARGECONTROL)
const int h_ResidualCham = 90000;          // +XXXX
#endif


inline int DQ_ITR_my_hbook1 (int hid, int lvl, char* title, int xbin, float bxbin, float fxbin) {

#if defined (DQ_ITR_CODE)
  rhp_hbook1(DQ_ID(COMP_ITR, lvl, hid), title, xbin, bxbin, fxbin);
#endif

#if defined (DQ_ITR_CONTROL)
 hbook1(hid, title, xbin, bxbin, fxbin);
#endif

  return (GRR_OK);
}

inline int DQ_ITR_my_hbook2 (int hid, int lvl, char* title, int xbin, float bxbin, float fxbin, 
			     int ybin, float bybin, float fybin) {

#if defined (DQ_ITR_CODE)
  rhp_hbook2(DQ_ID(COMP_ITR, lvl, hid), title, xbin, bxbin, fxbin, ybin, bybin, fybin);
#endif

#if defined (DQ_ITR_CONTROL)
 hbook2(hid, title, xbin, bxbin, fxbin, ybin, bybin, fybin);
#endif

  return (GRR_OK);
  }
inline int DQ_ITR_my_hf1_fill (int hid, int lvl, float x, float wt) {

#if defined (DQ_ITR_CODE)
  rhp_hf1 (DQ_ID(COMP_ITR, lvl, hid), x, wt);
#endif

#if defined (DQ_ITR_CONTROL)
  hf1 (hid, x, wt);
#endif

  return (GRR_OK);
}

inline int DQ_ITR_my_hf2_fill (int hid, int lvl, float x, float y, float wt) {

#if defined (DQ_ITR_CODE)
  rhp_hfill (DQ_ID(COMP_ITR, lvl, hid), x, y, wt);
#endif

#if defined (DQ_ITR_CONTROL)
  hf2 (hid, x, y, wt);
#endif

  return (GRR_OK);
}

#endif
