
// ********************************************************************
//
// source:    usstop.C
//
// type:      source code
//
// author:    Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Physics Department
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// purpose:   simple usstop
//
// called by: ARTE
//
// hints:     uses /IOFILE/HBOOK <filename> to write HBOOK-file
//
// changes:
// 19 Jan 2001 (AG) added comments
//
// ********************************************************************

// standard includes
#include <iostream.h>

// ONLINE includes
#include "rhp2hbook.h"

// Arte includes
#include "farm/farm.hh"

//
// program code
//
extern "C" void
usstop_()
{
  ARTE_mark( "usstop BEGIN", 0 );
  cout << "usstop" << endl;
  
  // rhp to HBOOK converter for all rhp-histogramms
  ARTE_mark( "rhp_2hbook", 0 );
  rhp_2hbook( 0, 0, "anything" );

  // return
  ARTE_mark( "usstop END", 0 );
  return;
}
