// ********************************************************************
//
//  Routine:      gageFillRhpOtrRich.C
//  Author:       T. Oest
//
//  Description: fill rhp histograms for global RICH alignment
//
//  Modification:
//
// ********************************************************************

#include <iostream.h>
#include <math.h>
#include <algo.h>
#include "rhp.h"
#include "dq/DQ.h"
#include "arte/arte.hh"
#include "arte/RSEG_cmp.hh"
#include "gage/gage.hh"
 
//*********************************************************************
// function
//*********************************************************************

int gageFillRhpOtrEcal(){

//-----------------------------------------------------------------
//   OTR/ECAL correlation
//-----------------------------------------------------------------

    for( ArteTable<RCCL>::iterator rccl = ArteTable<RCCL>::begin();
         rccl != ArteTable<RCCL>::end(); ++rccl ) {

      if ((*rccl)->wid >=2){


    for( ArteTable<RSEG>::iterator rOTR = ArteTable<RSEG>::begin();
         rOTR != ArteTable<RSEG>::end(); ++rOTR ) {

      if ((*rOTR)->fit == 0 && ((*rOTR)->cmp & Rsegc::patt)){

         float dx, dy;
         dx = (*rOTR)->xe + ((*rccl)->z - (*rOTR)->ze) * (*rOTR)->txe
               - (*rccl)->x;
         dy = (*rOTR)->ye + ((*rccl)->z - (*rOTR)->ze) * (*rOTR)->tye
               - (*rccl)->y;

         if (fabs(dx) < gagePCutsOtrEcal[0] && 
             fabs(dy) < gagePCutsOtrEcal[1]) {
          rhp_hfill( AC_ID(COMP_CORR, LVL_REC, 120 ), dx, dy, 1 );

          if ((*rOTR)->xe > 0.0) {
           rhp_hfill( AC_ID(COMP_CORR, LVL_REC, 121 ), dx, dy, 1 );
          } else {
           rhp_hfill( AC_ID(COMP_CORR, LVL_REC, 122 ), dx, dy, 1 );
          };

         };


      };
    };
    };
    };
//------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------
  return 0;
};
