// ********************************************************************
//
//  Routine:      gageFillRhpOtrRich.C
//  Author:       T. Oest
//
//  Description: fill rhp histograms for global RICH alignment
//
//  Modification:
//
// ********************************************************************

#include <iostream.h>
#include <math.h>
#include <algo.h>
#include "rhp.h"
#include "dq/DQ.h"
#include "arte/arte.hh"
#include "arte/RSEG_cmp.hh" 
#include "gage/gage.hh" 


//*********************************************************************
// function
//*********************************************************************

int gageFillRhpOtrRich(){

//-----------------------------------------------------------------
//   OTR/RICH correlation
//-----------------------------------------------------------------

    for( ArteTable<RSEG>::iterator rRICH = ArteTable<RSEG>::begin();
         rRICH != ArteTable<RSEG>::end(); ++rRICH ) {

      if ((*rRICH)->cmp == 67108864 &&
          (*rRICH)->ze >= 3.*sqrt(max(float(1.),(*rRICH)->ye))){

    for( ArteTable<RSEG>::iterator rOTR = ArteTable<RSEG>::begin();
         rOTR != ArteTable<RSEG>::end(); ++rOTR ) {


      if ((*rOTR)->fit == 0 && ((*rOTR)->cmp & Rsegc::patt)){

         float dtx, dty;
         dtx = (*rOTR)->txe - (*rRICH)->txf;
         dty = (*rOTR)->tye - (*rRICH)->tyf;

         if (fabs(dtx) < gagePCutsOtrRich[2] && 
             fabs(dty) < gagePCutsOtrRich[3]){
          rhp_hfill( AC_ID(COMP_CORR, LVL_REC, 111 ), dtx, dty, 1 );

          if ((*rOTR)->xe > 0.0 ){
           rhp_hfill( AC_ID(COMP_CORR, LVL_REC, 112 ), dtx, dty, 1 );
          } else {
           rhp_hfill( AC_ID(COMP_CORR, LVL_REC, 113 ), dtx, dty, 1 );
          };

         };

      };
      };
    };
    };
//------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------
  return 0;
};
