/***********************************************************************
*
* CRPOS
* written by Siegmund Nowak
*
* This routine posit a copy of a volume in GEANT and ARTE banks 
*
************************************************************************/
#include "arte/arte.hh"
#include "arte/ArteMessage.hh"
#include "gean/gcvolu.h"
#include "gean/gclink.h"
#include "gean/Geant2Arte.hh"
 
extern "C" {

void gsposp_(char*,int*,char*,float*,float*,float*,int*,char*,float*,int *);

void crpos_(char *name,char *moth,int *ilay,int *isec,
            float *xp,float *yp,float *zp,int *irot,char *maon,float *par) {


static int nopar[] = {3,4,5,11,3,  5,5,7,6,6,  10,9,3,4,0,   0,0, 0,0,0,
                                            0,0,0,0,0,   0,0,12,0,0};

//  get detector shape (for number of parameters) and sensitive flag isv
    Geant2Arte G2A;
    int Gvolnum = G2A.GetGvolNumber(name);
    if(Gvolnum == 0) { 
       arteMsg << "crpos >> nonvalid volume " << name; arteMsg.error();
    }
    int jvos = *(gcbank_.lq + gclink_.jvolum -1 - Gvolnum);
    float *pjx = (float*)(gcbank_.iq + jvos-1);
    int npar =  nopar[int (*(pjx+2))-1]; 
    int* pjmd = gcbank_.lq + gclink_.jtmed -1 - int(*(pjx+4));
    pjx = (float*)(gcbank_.iq + *pjmd -1);
    int isv = int(*(pjx+7)); 
    if(isv) {
//     Book NEDE bank and connect it to NESL bank 
       int nnede = G2A.CreateNede();
       ArtePointer<NEDE> nd(nnede);
       nd->lay = *ilay;
       nd->sec = *isec;
//     posit GEANT volume
       gsposp_(name,&nnede,moth,xp,yp,zp,irot,maon,par,&npar);
//     fill NEDE table
       G2A.FillTree(name,nnede);
       G2A.FillGvolParameter(); 
       G2A.FillNedeParameter(nnede);
    }
    else {
//     Book NWAL bank and connect it to NESL bank
       int nnwal = G2A.CreateNwal();
//     posit GEANT volume
       gsposp_(name,&nnwal,moth,xp,yp,zp,irot,maon,par,&npar);
//     fill nwal table
       G2A.FillTree(name,nnwal);
       G2A.FillGvolParameter();
       G2A.FillNwalParameter(nnwal);
    }
    gcvolu_.nlevel =0;
}
}





