      subroutine pigepr
      implicit none
******************************************************************
*
* Draws Geant picture over existing Prism picture.
* (interactive command GEANPRIS)
*
* Parameters read from KUIP:
*   mode=1  - Geant DCUT (default for planar views)
*       =2    Geant DRAW (default for 3D view)
*   volnam  - which volume to draw (default=MOTH)
*   cutval  - cut value for section
*   hbgeant - whether to draw 'hbgean' label onto Prism header
*
* Called routines:
*   Prism:   dipro
*   Geant:   gdrawc gdraw
*   KUIP:    kugeti kugetr kugetc
*   HIGZ:    igqwk iselnt isclip iuwk
*   CERNlib: uhtoc
*
* Author:  Alexander Lanyov, Sep 1997
* updated: Alexander Lanyov, Mar 1999
*
******************************************************************

#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "gean/gcdraw.fi"
#include "pris/zgraf.fi"
ccc#include "pris/zframe.fi" ! c = 0.15

        integer iwkid,l,isl,nt,nt_prism,iaxis3,mode,hbgeant
        real rval(1),wn(4),vp(4),wn1(4)
        real xmoth(3),xxx,yyy,su,sv,u0,v0,cutval,cutthe,cutphi
        real theta,phi,psi,dnorm
        character*4 volnam,slnam,axisname(3)*1

	real c,ymin,ymax,ywi1,ywi2

#include "arte/Arte.ff"
#include "auto/GEO.ff"

        data axisname/'X','Y','Z'/

        call kugetc(volnam,l)
        call kugetr(cutval)
        call kugeti(mode)
        call kugeti(hbgeant)

c----------------------------------- Get PRISM info
        call iselnt(51)

        iwkid=1
        call igqwk(iwkid,'NTWN',wn)
        call igqwk(iwkid,'NTVP',vp)

        call igqwk(iwkid,'NTNB',rval)
        nt_prism = int(rval(1))

        c78 = 'Extracting Prism viewport and world coordinates ...'
        call me78sp('T')

c----------------------------------- Reset PRISM stuff
        call iselnt(1)          ! return to Geant NT=1

        wn1(1)=0.
        wn1(2)=20.
        wn1(3)=0.
        wn1(4)=20.

        call iswn  (nt,0.,20.,0.,20.)   ! Geant default workstation window
        call isclip(1)

        dnorm = 180. / 3.1415926536

c----------------------------------- Perform the drawing

        do isl=1,nnesl()
           call uhtoc(iq(hqnesl_name(isl)),4,slnam,4)
           if (slnam .eq. volnam) goto 100
        end do

        c78 = 'GEANPRIS: Superlayer "'
        call ch78ac(volnam)
        call ch78ac('" was not found at HNESL_NAME table')
        call me78wa
        return

100     continue
        if (iviewzg.eq.0) then          ! xy
           iaxis3=3

           theta= 0.
           phi  = 0.
           psi  = 0.

        else if (iviewzg.eq.1) then     ! zx
           iaxis3=2
           theta= 90.
           phi  = 90.
           psi  =  0.
        else if (iviewzg.eq.2) then     ! zy
           iaxis3=1
           theta= 90.
           phi  =180.
           psi  =  0.

        else if (iviewzg.eq.7) then     ! zu
           iaxis3=0
           theta= 90.
           phi  = 90. - 0.080*dnorm
           psi  =  0.

        else if (iviewzg.eq.8) then     ! zv
           iaxis3=0
           theta= 90.
           phi  = 90. + 0.080*dnorm
           psi  =  0.

        else if (iviewzg.eq.3) then     ! 3D
           mode=2

c=======================================================================
c Transform parameters Prism(thetgz phigz) --> Geant(theta phi psi)
c
c For Prism:
c===========
c thetgz - polar angle of observers view [-180, 180]
c phigz  - azimuthal angle of observers view [-360, 360]
c
c x = cos(thetgz) * sin(phigz)
c y = sin(thetgz)
c z = cos(thetgz) * cos(phigz)
c
c For Geant:
c===========
c theta - angle between the sight line and Z-axis of MARS [0, 180]
c phi   - angle between projection of sight line on plane (XY)
c                       and X-axis of MARS [0, 360]
c psi   - angle by which projected image will be rotated on the screen plane
c
c x = sin(theta) * cos(phi)
c y = sin(theta) * sin(phi)
c z = cos(theta)
c
c                                  Always psi = 0
c
c=======================================================================

           dnorm = 180. / 3.1415926536

           theta = dnorm * acos(cos(thetzg/dnorm)*cos(phizg/dnorm))

           if (sin(phizg/dnorm).eq.0. and. sin(thetzg/dnorm).eq.0.) then
              phi = 90.
           else
              phi = dnorm * atan2(sin(thetzg/dnorm),
     @                            cos(thetzg/dnorm)*sin(phizg/dnorm))
              if (phi.lt.0.) phi = phi + 360.
           end if

           psi   =  0.

c-----------------------------------------------------------------

        else
           c78 = 'GEANPRIS: this Prism view is not supported by Geant.'
     @           //' Using instead iviewzg=1'
           call me78wa

           iaxis3=2
           theta= 90.
           phi  = 90.
           psi  =  0.
        end if

        su = (wn1(2)-wn1(1))/(wn(2)-wn(1)) * (vp(2)-vp(1)) !/(vp2-vp1)
        sv = (wn1(4)-wn1(3))/(wn(4)-wn(3)) * (vp(4)-vp(3)) !/(vp4-vp3)

        xmoth(1) = 0.5*(fnesl_x1(isl) + fnesl_x2(isl))
        xmoth(2) = 0.5*(fnesl_y1(isl) + fnesl_y2(isl))
        xmoth(3) = 0.5*(fnesl_z1(isl) + fnesl_z2(isl))

        call dipro(xmoth,xxx,yyy)

        u0 = su*(xxx - 0.5*(wn(1)+wn(2))) + 0.5*(wn1(1)+wn1(2))
        v0 = sv*(yyy - 0.5*(wn(3)+wn(4))) + 0.5*(wn1(3)+wn1(4))

c------------------------------------------------------------- DCUT
        if (mode.eq.1) then

           if (iaxis3.ne.0) then
              if (cutval.ne.0.) cutval = cutval - xmoth(iaxis3)
              c78 = 'Executing Geant/Drawing/Dcut'
              call ch78bc(volnam)
              call ch78bc(axisname(iaxis3))
              call ch78bf(cutval,-2)
              call ch78bf(u0,-2)
              call ch78bf(v0,-2)
              call ch78bf(su,-4)
              call ch78bf(sv,-4)
              call me78sp('T')
              call gdrawc(volnam,iaxis3,cutval,u0,v0,su,sv)
c	      icut = iaxis3
              ngview = 0
              icut = 0
           else
              cutthe = theta
              cutphi = phi

c For view 7 picture is drawn rotated but not clear why.
              if (iviewzg.eq.7) theta = theta + 180. ! also does not help much

              c78 = 'Executing DXcut'
              call ch78bc(volnam)
              call ch78bf(cutthe,-2)
              call ch78bf(cutphi,-2)
              call ch78bf(cutval,-2)
              call ch78bf(theta,-2)
              call ch78bf(phi,-2)
              call ch78bf(u0,-2)
              call ch78bf(v0,-2)
              call ch78bf(su,-4)
              call ch78bf(sv,-4)
              call me78sp('T')

              call gdrawx(volnam,cutthe,cutphi,cutval,
     @                    theta,phi,u0,v0,su,sv)
c	      icut = iaxis3
              ngview = 0
              icut = 0
           end if

c------------------------------------------------------------- DRAW
        else if (mode.eq.2) then

           c78 = 'Executing Geant/Drawing/Draw'
           call ch78bc(volnam)
           call ch78bf(theta,-1)
           call ch78bf(phi,-1)
           call ch78bf(psi,-1)
           call ch78bf(u0,-2)
           call ch78bf(v0,-2)
           call ch78bf(su,-4)
           call ch78bf(sv,-4)
           call me78sp('T')

           call gdraw(volnam,theta,phi,psi,u0,v0,su,sv)

c-------------------------------------------------------------
        else
           c78 = 'GEANPRIS: Illegal mode = '
           call ch78ai(mode)
           call me78wa
        end if

c-------------------------- What else?
c dscale 11 15
c dman 1.1 10.5 man
c daxis 90 0 -4 6

c----------------------------------- Update Prism header
        call iselnt(nt_pictzg)

	c=0.15

        ymin = 100.*c
        ymax = 100.*(1.-c)
        
        ywi1 = ymin + 6.
        ywi2 = ymax - 8.

        call igset('PLCI',1.)
        call istxfp(0,2)
        call igset('TXAL',33.)	! alignment: right mid
        call ischh(5.)
        call igset('PASS',3.)
        call igset('TXCI',cotxtzg)
        call igset('TXFP',-20.)

	if (lheaderzg .and. hbgeant.ne.0)
     @      call itx(85., 0.5*(ywi2+ymax)+0.3, 'hbgean')

c----------------------------------- Turn on PRISM stuff back
        call iselnt(nt_prism)

c-----------------------------------
        call iuwk(0,1)          ! Flush buffer

c        write (*,*) '   Parameters from GEANT:'
c        write (*,*) 'gtheta=',gtheta,' gphi=',gphi,' gpsi=',gpsi
c        write (*,*) 'ctheta=',ctheta,' cphi=',cphi
c        write (*,*) 'icutfl=',icutfl,' icut=',icut,' dcut=',dcut
c        write (*,*) 'nsurf=',nsurf,' isurf=',isurf

        return
        end
