*-- Author :    Hartwig Albrecht   16/02/95

      SUBROUTINE KAHBOO

************************************************************************
*
* Description: HBOOK control card
*
* Called from: KUIP
*
* External references: HROPEN, ACCESSF(Cernlib)
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/MEIO.fi"

      CHARACTER COPT*3, CZFL*8, CNAME*(NAMECH)
      INTEGER L, LUN, NREC, CHIND1
      LOGICAL ACCESSF, A
      PARAMETER (NREC = 1024)

#include "arte/Arte.ff"
#include "auto/MEIO.ff"

      LUN = IMEIO_CURRENT(LHIST)
      IQ(IQMEIO_PACK(LUN)) = 1

      C78 = ' '
      CALL KUGETS (C78, L)

      IF (IMEIO_FLAG(LUN) .GT. 0 .AND. IMEIO_FLAG(LUN) .LE. 3)  THEN
        CALL MEERRC (33,
     +    'HBOOK: Attempt to open a second HBOOK file')
        GO TO 90
      END IF

C construct file name if not explicitely given

      IF (L .EQ. 0)  THEN
        C78 = JOBNAME
        CALL CH78AC ('.hbook')
      END IF

      CALL IOCONC (LUN, C78, 'O', 0)
      A = ACCESSF (C78, 0)

      C78 = ' '
      CALL KUGETC (C78, L)

      IF (A)  THEN
c what is wrong with the following statements ? --H.A.
c        IF (.NOT. ACCESSF (C78, 2))  CALL MEERRC (1234613,
c     +    'HBOOK: no write permission for HBOOK file')
        IF (CHIND1(C78(1:L), 'N') .NE. 0)  CALL MEERRC (1346459,
     +    'HBOOK: file declared as -N (new) but exists already')
        IF (CHIND1(C78(1:L), 'O') .EQ. 0 .AND.
     +      CHIND1(C78(1:L), 'U') .EQ. 0)  CALL MEERRC (7632436,
     +  'HBOOK: file exists; declare -O (overwrite) or -U (update)')
      END IF

      COPT = 'N'

      IF (CHIND1(C78(1:L), 'U') .NE. 0)  THEN
        IF (A)  THEN
          COPT = 'U'
          CALL CHHTOC (IQ(HQMEIO_ZOPTION(1,LUN)), CZFL)
          CALL CHAPPC (CZFL, 'I')
          CALL CHCTOH (CZFL, IQ(HQMEIO_ZOPTION(1,LUN)), NMEIO_ZOPTION)
        ELSE
          CALL MEWARC (4156745,
     +      'HBOOK: file declared as -U (update) but does not exist')
        END IF
      END IF

      IF (.NOT. A .AND. CHIND1(C78(1:L), 'O') .NE. 0)
     +  CALL MEWARC (9345745,
     +  'HBOOK: file declared as -O (overwrite) but does not exist')

      IF (CHIND1(C78(1:L), 'X') .NE. 0)  CALL CHAPPC (COPT, 'X')

      CALL CHHTOC (IQ(HQMEIO_NAME(1,LUN)), CNAME)
      CALL MEWARC (8763445, 'OPEN HBOOK file ' // CNAME)
      CALL HROPEN
     +     (LUN, 'ARTE', CNAME, COPT, NREC, IQ(IQMEIO_IOSTAT(LUN)))

      IF (IMEIO_IOSTAT(LUN) .NE. 0)  THEN
        IF (IMEIO_IOSTAT(LUN) .EQ. -1)  IQ(IQMEIO_IOSTAT(LUN)) = 999
        CALL MEERRC (31,
     +    'HBOOK: file cannot be opened')
        IQ(IQMEIO_FLAG(LUN)) = 0
      ELSE
        IQ(IQMEIO_RLENG(LUN)) = 1
        IQ(IQMEIO_FLAG(LUN)) = 3
        IQ(IQMEIO_FORMAT(LUN)) = 0
      END IF

 90   END

************************************************************************
* End of KAHBOO
************************************************************************
