*CMZ :  0.01/02 27/07/94  18.40.05  by  Dominik Ressing
*-- Author :    Dominik Ressing   27/07/94
cxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
c
c     calculate the opening angle of two tracks
c
c     INPUT only:
c
c     E1,Px1,Py1,Pz1 : is the 4-momentum of the first track
c     E2,Px2,Py2,Pz2 : is the 4-momentum of the second track
c
c     iA defines the mode of calculation: ( parameters from $l1kindf )
c           L1APPROXfull  : perform correct calculation
c           L1APPROXfirst : use only first approximation ( as in hardware )
c           L1APPROXseco  : use one more aproximation
c
cxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
c
      REAL FUNCTION t1kinto(E1,Px1,Py1,Pz1,E2,Px2,Py2,Pz2,iA)
c
      IMPLICIT NONE
c
#include "l1si/l1kindf.fi"
c
      REAL    E1,Px1,Py1,Pz1,E2,Px2,Py2,Pz2,
     &        xz1,yz1,xz2,yz2
      INTEGER iA
c
      IF ( iA.eq.L1APPROXfirst ) THEN
         xz1 = Px1/Pz1
         yz1 = Py1/Pz1
         xz2 = Px2/Pz2
         yz2 = Py2/Pz2
         t1kinto = sqrt((xz1-xz2)**2. + (yz1-yz2)**2.)
      ELSE IF ( iA.eq.L1APPROXseco ) THEN
         t1kinto = acos( ( Px2*Px1 + Py2*Py1 + Pz2*Pz1 )/E1/E2)
       ELSE
         t1kinto = acos( ( Px2*Px1 + Py2*Py1 + Pz2*Pz1 )/E1/E2)
      END IF
c
      RETURN
      END
