#ifndef MuDbHots_h
#define MuDbHots_h 1

//## Class: MuDbHots
//      /**Author:        Boris Fominykh
//
//      Date:             December 8, 1999
//
//      Class:            MuDbHots
//
//      Base Class:       MuDbTable
//
//      Description:
//      This class is for operations with hot channels in muon DB*/

#include "murec/MuDbTable.h"
typedef unsigned short Word;

class MuDbHots : public MuDbTable
{
  public:
    //## Constructor
           MuDbHots();
    //## Destructor
           ~MuDbHots();

    //public methods
      //        /**Create hot channel table in DB from temporary space*/
      int Create();
      //        /**Read the table from ascii-file into temporary space*/
      int ReadFile();
      //        /**Read the table from DB into temporary space*/
      int Read();
      //        /**Print hot channels from temporary space*/
      void Print();
      //        /**Get status of cable*/
      Word Status(char *cablename);
      //        /**release the temporary space*/
      void Release();

  protected:

  private:

      int SizeS; 
      int SizeMem; 
      char* Name;
      Word* Stts;
      int SizeW; 
    static const int SizeWQ = 500; 
      char* NameW;
      Word* StatW;

    //        /**Initialization*/
      void Ini();
    //        /**Add the next table line to temporary space*/
      int Add(char* name, int stat);
    //        /**Write the table from temporary space to DB*/
      int Write();
};

#endif





