// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

#include <iostream.h>
#include <math.h>
#include "rang/zfpar.hh"
#include "rang/ScatThin.hh"

rangerScatThin::rangerScatThin(double msEff, double Qp, 
				      double Tx, double Ty) {
  // msEff should contain the thickness correction due to angle
  double qPNoiseS = Qp * Qp;
  if (qPNoiseS > 100) qPNoiseS = 100;    // limit the m.s. correction to
                                         // that for a .01 GeV particle 
  dScat = zfpar_.fMolRF * msEff * qPNoiseS;
  dScat *= (1 + .105 * .105 * qPNoiseS); // beta correction assuming
                                         // muon mass
  
  double sqxy = sqrt(1 + Tx * Tx + Ty * Ty);

  cTxTx = (1 + Tx * Tx) * sqxy * sqxy * dScat;
  cTxTy =    Tx * Ty    * sqxy * sqxy * dScat;
  cTyTy = (1 + Ty * Ty) * sqxy * sqxy * dScat;

}


