// 
//  Author:  Rainer Mankel                     Created:  30-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// ranger composite layer

#ifndef RANGER_COMPLAY_HH
#define RANGER_COMPLAY_HH

#include <vector.h>
#include <utility>
#include "rang/SubLayerSet.hh"

class rangerCompLay {

public:
  rangerCompLay(){};
  rangerCompLay(const pair<int,rangerSubLayerSet>& p1);
  rangerCompLay(const pair<int,rangerSubLayerSet>& p1,
		const pair<int,rangerSubLayerSet>& p2);
  rangerCompLay(const pair<int,rangerSubLayerSet>& p1,
		const pair<int,rangerSubLayerSet>& p2,
		const pair<int,rangerSubLayerSet>& p3);
  ~rangerCompLay(){};

  void append(pair<int,rangerSubLayerSet>& c) { cmpSLS.push_back(c); };
  void append(int cmp,int nativeLSN,int gedeLayer,
	      int subLay1=1,int subLay2=99){
    cmpSLS.push_back( make_pair(nativeLSN,
				rangerSubLayerSet(cmp,
						  gedeLayer,
						  subLay1,subLay2)) );
      };
  rangerSubLayerSet* slSet(int cmp);
  int getGlay(int cmp);

  void dump(const int level=1);

private:
  vector<pair<int,rangerSubLayerSet> > cmpSLS;
};
#endif

