// 
//  Author:  Rainer Mankel                     Created:  25-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 


#ifndef RANGER_XWIN_HH
#define RANGER_XWIN_HH

class rangerDomain;
#include "rang/DomWin.hh"


class rangerXWin {

public:
  rangerXWin(){};
  rangerXWin(rangerDomain* dom);
  ~rangerXWin(){};

  void clr() { filledXW = 0;};
  int filled() { return (filledXW == 1);};
  void setx(float z,double x,double tx){
    zXW = z; xXW = x; txXW = tx; filledXW = 1;};
  void setWin(rangerDomWin* wi) { winXW = wi; };
  float z() { return zXW;};
  double x() { return xXW;};
  double tx() { return txXW;};
  rangerDomain* dom() { return domXW;};
  rangerDomWin* win() { return winXW;};
  rangerNavItem* ni() { return ((winXW)? winXW->getNI():0);};
  void dump();


private:
  int filledXW;
  float zXW;
  float xXW;
  float txXW;
  rangerDomWin* winXW;
  rangerDomain* domXW;
};
#endif
