*-- Author :    Rainer Mankel   05/01/96

      subroutine tfkres()

*     **** display residuals of track candidate
*     **** to be called by KUIP
      implicit none

#include "rang/zf.fi"
#include "rang/zfmode.fi"
#include "pris/zgraf.fi"
#include "pris/hgmagnhelp.fi"
#include "arte/Arte.fi"
#include "auto/GEO.fi"
      integer maxgraf
      parameter (maxgraf=100)

      integer ii, ft, nt, ngraf, izf, cmp, sl(maxgraf)
      real eplus(maxgraf), eminus(maxgraf), z(maxgraf),
     +     resid(maxgraf), erplus(maxgraf), erminus(maxgraf),
     +     x(maxgraf), maxval, col(maxgraf), colcmp(maxgraf), ylow,
     +     ycmp1, xxx(2), yyy(2)
      character*10 chopt
      data x / maxgraf*0 /

#include "arte/Arte.ff"
#include "auto/GEO.ff"

#ifdef RGRAF
      chopt = ' '
      call kugeti(ft)
      if (ft.le.0.or.ft.gt.nca_ft) then
         print *,' () tfkres: invalid candidate ft=', ft
         go to 999
      endif

*     **** colour index
**      call igset('PLCI',corczg)
**      call igset('PMCI',corczg)
**      call igset('LWID',6.)

      ngraf = 0
      maxval = 0.
*     **** loop over hits in candidate
      print *,' tfkres: ft, last_ft(ft)=', ft, last_ft(ft)
      do ii=1,maxgraf
         if (ii.eq.1) then
            izf = last_ft(ft)
         else
            izf = prev_zf(izf)
         endif
         if (izf.le.0) go to 11

         if (ii.gt.maxgraf) go to 11

         ngraf = ii
         z(ii) = z_zf(izf)
         eplus(ii) = 100. * dsqrt(cm_zf(1,1,izf))
         eminus(ii) = - eplus(ii)
         resid(ii) = 100. * xr_zf(1,izf)
         erplus(ii) = 100. * dsqrt(cr_zf(1,1,izf))
         erminus(ii) = -erplus(ii)
         if (eplus(ii).gt.maxval) maxval = eplus(ii)
         if (resid(ii).gt.maxval) maxval = resid(ii)

         if (z(ii).lt.200.) then
            col(ii) = 2.        ! vertex tracker
         elseif (sqrt((z(ii)-zposmg)**2+xx_zf(1,izf)**2).lt.rmag) then
            col(ii) = 3.        ! main tracker (magnet)
         elseif (z(ii).lt.1000.) then
            col(ii) = 4.        ! main tracker (outside magnet)
         else
            col(ii) = 7.        ! trigger area etc
         endif
         cmp = igede_cmp(plane_zf(izf))
         if (cmp.eq.1) then
            colcmp(ii) = 2.     ! Si
         elseif (cmp.eq.2) then
            colcmp(ii) = 4.     ! wire chamber
         elseif (cmp.eq.3) then
            colcmp(ii) = 6.     ! MSGC
         else
            colcmp(ii) = 7.     ! other
         endif
         sl(maxgraf) = ogede_gesl(plane_zf(izf))
      enddo
 11   continue

      nt = 5
      x(1) = .5
      x(2) = ngraf + .5
      x1zg = -2.
      x2zg = float(ngraf)+2.
      y1zg = -1.2*maxval
      y2zg = 1.2*maxval
      print *,' ngraf, maxval=', ngraf, maxval
      call tfdfram(nt) ! set up NDC -> WC transformation


*     **** clear workstation
      if (index(chopt,'A').eq.0) then
       call dinewp()
      endif

**      call iclrwk(0,1)
      call igset('PLCI',1.)
      call igset('FACI',5.)
      call igset('BORD',1.)
      call iselnt(nt)
      call ighist(ngraf,x,eplus,'HFA')
      call ighist(ngraf,x,eminus,'HF')
      call igset('PMCI',3.)
      call ighist(ngraf,x,erplus,'L')
      call ighist(ngraf,x,erminus,'L*')
      call igset('FACI',2.)
      call ighist(ngraf,x,resid,'B')

*     **** draw area and device liners
      ylow = y2zg-0.05*(y2zg-y1zg)
      ycmp1 = y2zg - 0.07*(y2zg-y1zg)
      call igset('FASI',1.)
      call igset('BORD',0.)
      call igset('PLCI',1.)
      call igset('LWID',2.)
      do ii=1,ngraf
         call igset('FACI',col(ii))
         call igbox(float(ii)-0.5,float(ii)+0.5,ylow,y2zg)
         call igset('FACI',colcmp(ii))
         call igbox(float(ii)-0.5,float(ii)+0.5,ycmp1,ylow)
         if (ii.ne.1.and.sl(ii).ne.sl(ii-1)) then
            call igset('PLCI',1.)
            call igset('LWID',5.)
            xxx(1) = float(ii) - 0.5
            xxx(2) = xxx(1)
            yyy(1) = ycmp1
            yyy(2) = y2zg
            call ipl(2,xxx,yyy)
         endif
      enddo

      call igset('PLCI',1.) ! make sure PLCI is set


*     **** axes
      if (laxiszg.and.index(chopt,'X').eq.0) call diaxis(chopt)

*     **** header text
      if (lheaderzg.and.index(chopt,'H').eq.0
     +     .and.index(chopt,'A').eq.0) call dihead()

*     **** complete frame
      if (lframezg) call diedge(chopt)

**      call diaxis()
      call iuwk(0,1)

#endif

 999  end
