*-- Author :    Rainer Mankel   02/06/96

      subroutine tfpropm0(ift1,direction)
*     **** 3D track-follow all alive seeds in /zf/ (may be in magnet)
      implicit none
#include "rang/zf.fi"
#include "rang/zfmode.fi"
#include "rang/zdomain.fi"
#include "arte/Arte.fi"
      integer nmax
      parameter (nmax=30)
      integer target_vec(nmax),n_target,tumchit,domlay,dlnext
      integer ift1,ift,izf,ipl,icycle,method,ncan,ii,
     +        zone,iplnext,imust,izfnew,nhl,nhlmx,ihl,dw
      real x_pred,y_pred,dx_window,dy_window,dz
      parameter (nhlmx=100)
      integer hl(nhlmx),nca_now,to_be_grown,direction,istat
      logical continued

#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "rang/sfdef.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "rang/sf.fi"

*     **** loop over growth cycles
      do 10 icycle=1,99

*      **** loop over present number of track candidates
       nca_now = nca_ft
       begin_ft = nca_ft + 1
       to_be_grown = 0
       do 20 ift=ift1,nca_now
        if (.not.alive_ft(ift)) go to 20
        if (mature_ft(ift))     go to 20
        to_be_grown = to_be_grown + 1

        if (diag_level.ge.5) then
         print *,' <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< '
         print *,' << track candidate ', ift, '                    <<'
         print *,' <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< '
        endif

*       **** loop over planes in zone
        izf = last_ft(ift)
        ipl = plane_zf(izf)
        domlay = domlay_zf(izf)
        zone = fault_zf(izf) + 1
        ncan = 0
        continued = .false.
        method = 1  ! 3D    tracking
        if (diag_level.ge.6) then
         print *,' tfpropm0: call tfdzone for domlay=', domlay,
     +           '  zone=', zone
        endif
        call tfdzone2(domlay,method,zone,direction,nmax,
     +       target_vec,n_target)

        if (diag_level.ge.5) then
         print *,' zone=', zone
         print '(6((a),i5))',
     +     'tfpropm0: for ipl=',ipl,' dl=',domlay,' meth=',method,
     +     ' zone=',zone,
     +     ' nmax=',nmax,' we get n_target=', n_target
        endif
        do 30 ii=1,n_target
         dlnext = target_vec(ii)
         if (diag_level.ge.5) print *,' tfpropm0: next target=', dlnext
*        **** check if plane is within scope

*        **** check if window is intersected
         dz = fgede_zmin(gede_dp(layplane1_dl(dlnext))) - z_zf(izf)
         x_pred = xx_zf(1,izf) + xx_zf(3,izf) * dz
         y_pred = xx_zf(2,izf) + xx_zf(4,izf) * dz
         dx_window = 5.
         dy_window = 20.0
         dw = win_dl(dlnext)
         if (x_pred.lt.(xmin_dw(dw)-dx_window).or.
     +        x_pred.gt.(xmax_dw(dw)+dx_window)) go to 30
         if (y_pred.lt.(ymin_dw(dw)-dy_window).or.
     +        y_pred.gt.(ymax_dw(dw)+dy_window)) go to 30

*        **** can/must plane found
         ncan = ncan + 1

*        **** loop over hits
         call tfdhlcr(izf,dlnext,nhlmx,hl,nhl)
         if (diag_level.ge.6) print *,' tfpropm0: hitlist nhl= ', nhl
         do 40 ihl=1,nhl
          if (diag_level.ge.5) then
           print *,' tfpropm0: hitlist ihl=', ihl, ' hit=', hl(nhl),
     +          ' imc=', tumchit(hl(nhl))
          endif
          iplnext = ihitb_gede(hl(ihl))
          call tffilm(hl(ihl),dlnext,iplnext,ift,izf,izfnew,istat)
          if (izfnew.gt.0) continued = .true.
 40      continue  ! hits in hitlist
 30     continue  ! planes in zone

*       **** allow fault on old candidate
        if (fault_zf(izf).lt.2) then
         fault_zf(izf) = fault_zf(izf) + 1
         nfault_ft(ift) = nfault_ft(ift) + 1
        else
*        **** kill or freeze old candidate
         if (whit_zf(izf).lt.9.) then
          alive_ft(ift) = .false.
         else
          mature_ft(ift) = .true.
          stat_ft(ift) = 4
         endif
        endif
        if (diag_level.ge.5) call tfl()

 20    continue
       call tfweed()
       if (diag_level.ge.4) then
        print *,' **********************************************'
        print *,' *                                            *'
        print *,' *                                            *'
        print *,' *           E  N  D     O  F                 *'
        print *,' *                                            *'
        print *,' *           G  R  O  W  T  H                 *'
        print *,' *                                            *'
        print *,' *            C  Y  C  L  E                   *'
        print *,' *                                            *'
        print *,' *                                            *'
        print *,' **********************************************'
        call tfl()
        if (l_diag) call tfwait()
       endif

       if (to_be_grown.le.0) go to 11

 10   continue

      print *,' () tfpropm0: loop ends ii=99'

 11   if (diag_level.ge.4) then
       call tfl()
       print *,' **** end growing of seed **** '
      endif

      if (l_diag) call tfwait()

      end

