
// *****************************************************************************
//
// source:    rcClassALIGN.C
//
// type:      source code
//
// created:   20 Dec 2000
//	
// author:    Dr. Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Physics Department
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            E-mail: Andreas.Gellrich@desy.de
//
// symbol:    rcClassALIGN
//
// called by: rcClassify
//
// purpose:   check for TAXX table
//
// hints:     do NOT set flagdst here!
//
// changes:
// 20 Dec 2000 (AG) creation
//
// *****************************************************************************

// includes
#include <iostream.h>

// ARTE includes
#include "arte/arte.hh"
#include "farm/farm.hh"
#include "reco/eclass.hh"

// externals
extern int FADEB; 

//
// function code
//
int
rcClassALIGN()
{
  // show up
  ARTE_mark( "rcClassALIGN 0", 0 );
  
  // inits
  int rc = 0;

  // check table
  if( ArteTable<TAHD>::size() ) rc = 1;

  // printout
  if( FADEB ){
    cout << " ALIGN: "
	 << "TAHD=" << ArteTable<TAHD>::size() << " "
	 << "TAHB=" << ArteTable<TAHB>::size() << " "
	 << "TATR=" << ArteTable<TATR>::size() << " "
	 << endl;
  }
  
  // return
  ARTE_mark( "rcClassALIGN 1", 0 );
  return rc;
}
