
// *****************************************************************************
//
// source:    rcClassVZERO.C
//
// type:      source code
//
// created:   19 Jul 2000
//	
// author:    Dr. Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Physics Department
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            E-mail: Andreas.Gellrich@desy.de
//
// symbol:    rcClassVZERO
//
// called by: rcClassify
//
// purpose:   class events with V0 candidate
//
// hints:
//
// changes:
// 19 Jul 2000 (AG) creation
// 21 Jul 2000 (AG) fix bug
// 25 Jul 2000 (AG) added rcSelectVZERO() and rcSelectVZERO2()
// 26 Jul 2000 (AG) stick to one VZERO selection function
// 26 Jul 2000 (AG) use seperate function for VZERO2
// 04 Dec 2000 (AG) introduce VZERO finder on Federico's code
//
// *****************************************************************************

// standard includes
#include <iostream.h>

// ARTE includes
#include "arte/arte.hh"
#include "farm/farm.hh"

// externals
extern int FADEB;

// prototypes
int rcSelectVZERO();

//
// function code
//
int
rcClassVZERO()
{
  ARTE_mark( "rcClassVZERO 0", 0 );

  // ints
  int rc = 0;

  //
  // Ignacio's V0 finder
  //
  //ARTE_mark( "rcSelectVZERO", 0 )
  //int flag = rcSelectVZERO(); // bit 1:K0s 2:Lambda
  //if( flag & 0x1 ) rc |= 0x1;
  //if( flag & 0x2 ) rc |= 0x2;

  //
  // Federico's V0 finder
  //
  for( ArteTable<RVER>::iterator rver = ArteTable<RVER>::begin();
       rver != ArteTable<RVER>::end();
       ++rver ){
    ArtePointer<RTRA> part = rver->btra;
    int topp = ( part->topp )->lund;
    
    if( topp ==   310 ) rc |= 0x1;
    if( topp ==  3122 ) rc |= 0x2;
    if( topp == -3122 ) rc |= 0x2;
  }
  
  // print
  if( rc ) cout << " VZERO: rc=0x" << hex << rc << dec << endl;

  ARTE_mark( "rcClassVZERO 1", 0 );
  return rc;
}
