
// ********************************************************************
//
//  Routine:      rcMatch.C
//  Author:       T. Oest
//
//  Description:  steering routine for matching
//
//  Modification:
//  -- OTR-ECAL match added                      14/01/00 O.Igonkina
//  -- OTR match added                           06/12/99 O.Igonkina
//  -- remove rc99MarpleRtra, track selection is done
//     in rc99inventRTRA.C                       26/01/00 T.Oest
//  -- call to downstream track propagation rgdownstr
//                                           23/07/00 D.Samtleben
//  -- add SVD-PC match                       04/08/00 O.Igonkina
// 02 Jan 2001 (AG) removed 99
// 03 Jan 2000 (AG) removed 99A
//
// ********************************************************************

// includes
#include <iostream.h>
#include <stdlib.h>
#include <math.h>
#include "marple/marple.hh"

#include "arte/arte.hh"
#include "reco/rcflags.hh"

extern int matchMARPLEVdsPc;
extern "C" void matchsvdpc_();

extern "C" void rgdownstr_();
void            rcSelRTRA();

//
// function
//
int
rcMatch()
{

//-----------------------------------------------------------------
//   fit98 matching
//-----------------------------------------------------------------

  rcSelRTRA();

//-----------------------------------------------------------------
//   marple matching
//-----------------------------------------------------------------
  if (matchMARPLEVdsEcal){
    static float Ktrig = 0.0;
   matchsvdecal_(& Ktrig);
  };
  if (matchMARPLEVdsRich)  matchsvdrich_();
  if (matchMARPLEVdsOtr)  matchsvdot_();
  if (matchMARPLEVdsPc)  matchsvdpc_();
  if (matchMARPLEOtrRich)  matchotrrich_();
  if (matchMARPLEOtrEcal)  matchotrecal_();
  if (matchMARPLEEcalRich){
   static float Ktrig = 0.0;
   static float RichSb = 0.0;
   matchrichecal_(& Ktrig, & RichSb);
  };

  rgdownstr_();

return 0;
};


