// ********************************************************************
//
//
//
// cuts: ECAL     >= 2 towers per cluster
//       RICH     >= 3 sigma rings
// 
// 03 Jan 2001 (AG) removed 99
//
// ********************************************************************

// includes
#include <iostream.h>
#include <stdlib.h>
#include <math.h>
#include <algo.h>

#include "arte/arte.hh"

extern int matchVdsEcal;
extern int matchVdsRich;
extern int matchVdsEcalRich;

extern float MatchsigRICHCut;


void rcSelVdsEcal(ArtePointer<RSEG>, ArtePointer<RCCL>);
void rcSelVdsRich(ArtePointer<RSEG>, ArtePointer<RSEG>);
void rcSelRichEcal(ArtePointer<RSEG>, ArtePointer<RCCL>);
void rcSelVdsRichEcal(ArtePointer<RSEG>, ArtePointer<RSEG>, 
		      ArtePointer<RCCL>);

//
// function
//
void rcSelVDStracks()
{

//-----------------------------------------------------------------
// VDS loop
//-----------------------------------------------------------------
    for( ArteTable<RSEG>::iterator rVDS = ArteTable<RSEG>::begin();
         rVDS != ArteTable<RSEG>::end();
         ++rVDS ) {

      if ((*rVDS)->cmp == 1 || (*rVDS)->cmp == 65537){

//-----------------------------------------------------------------
// VDS,ECAL loop
//-----------------------------------------------------------------
    if (matchVdsEcal == 1 || matchVdsEcalRich == 1){

    for( ArteTable<RCCL>::iterator rccl = ArteTable<RCCL>::begin();
         rccl != ArteTable<RCCL>::end();
         ++rccl ) {
    if ((*rccl)->wid >= 2.){

    if (matchVdsEcal == 1) rcSelVdsEcal((*rVDS),(*rccl));

//-----------------------------------------------------------------
// VDS,ECAL,RICH loop
//-----------------------------------------------------------------
    if (matchVdsEcalRich == 1){
 
    for( ArteTable<RSEG>::iterator rRICH = ArteTable<RSEG>::begin();
         rRICH != ArteTable<RSEG>::end();
         ++rRICH ) {

      if ((*rRICH)->cmp == 67108864 &&
          (*rRICH)->ze >= 
             MatchsigRICHCut * sqrt(max(float(1.),(*rRICH)->ye)))

	rcSelVdsRichEcal((*rVDS),(*rRICH),(*rccl));
    };
    };

//-----------------------------------------------------------------
// end ECAL loop
//-----------------------------------------------------------------
    };};
    };
//-----------------------------------------------------------------
// VDS,RICH loop
//-----------------------------------------------------------------
    if (matchVdsRich == 1){

    for( ArteTable<RSEG>::iterator rRICH = ArteTable<RSEG>::begin();
         rRICH != ArteTable<RSEG>::end();
         ++rRICH ) {

      if ((*rRICH)->cmp == 67108864 &&
         (*rRICH)->ze >= 
               MatchsigRICHCut * sqrt(max(float(1.),(*rRICH)->ye)))

       	rcSelVdsRich((*rVDS),(*rRICH));
    };
    };
//-----------------------------------------------------------------
// end VDS loop
//-----------------------------------------------------------------
    }; };

      
};



