//--*-C++-*--
//
//  Created: Apr 04 2001
//
//  Modifications:
//
//
#ifndef _RERRORMSG_H__
#define _RERRORMSG_H__
#include <stdio.h>
#include <string.h>
#include <map.h>

#define WHAT_MAX 80

class RErrorMsg {
 public:
  /// Constructor
  RErrorMsg(char *w, int c) {
    code=c;
    if ((int)strlen(w)<WHAT_MAX-1) {
      strcpy(what,w);
    } else {
      strcpy(what,"----> RING: ERROR in ring fitting (original message too long)");
    }
    map<const char*, int>::iterator imsg=msg_list.find(w);
    if (imsg==msg_list.end()) msg_list.insert( pair<const char*,int>(w,1) );
    else                      imsg->second++;
  }
  /// Error message
  char   what[WHAT_MAX];
  /// Error code
  int    code;
  /// Print error
  inline void  print() {
    cerr<<"----> RING RErrorMsg: "<<what<<", rc="<<code<<endl;
  }
  /// Count error messages (debug)
  static map<const char*, int>  msg_list;
  /// Print error messages (debug)
  static void print_debug();
  /// Do nothing
  inline void idle() {;}
};

#endif








