#ifndef _TLT_H_
#define _TLT_H_
// *****************************************************************************
//
// source:    tlt.h
//
// type:      include file
//
// created:   06 Dec 1999
//
// authors:   Stefan Scharein, Ullrich Schwanke
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: scharein@ifh.de, schwanke@ifh.de
//
// changes:
//
// *****************************************************************************

/* slp.h wants rpm_addr to be defined */
#ifdef L2_FARM_MODE /*** defined if not running in simulation mode ***/
#include "rpm.h"
#else
#ifndef rpm_addr
#define rpm_addr int
#endif
#endif

#include "slp.h"

 /*** the smc handlers for TLT Package defined in main.C ***/
int TLT_startup(SLP_transitions which);      /*called at init */
int TLT_initialize(SLP_transitions which);   /*called at ready */
int TLT_zero(SLP_transitions which);         /*called at runStart */
                                             /* nothing called at runEnd */
int TLT_shutdown(SLP_transitions which);     /*called at to-exit */
SLP_RETURN TLT_trigger(int event, int parameter);  /*** event start handler ***/
/** The initiate handler is called first when event processing advances to
    the Pack. If it returns with SLP_ACCEPT or SLP_REJECT processing
    advances to the next Pack - on SLP_CONTINUE all SDS messages are
    routed to the appropirate handler of the PACK (or the timeout handler
    if non arrive). **/
void TLT_free(int event);                           /*** free event handler  ***/
SLP_RETURN  TLT_handle(int isRPS, int msg_class, void *header, void *data);
                                                    /*** sds handler         ***/
SLP_RETURN TLT_handleTimeout();                     /*** timeout handler     ***/
/** Handle timeout while in event processing.
    If this handler returns with SLP_ACCEPT or SLP_REJECT processing
    advances to the next Pack - on SLP_CONTINUE the messages continue 
    to be routed to the sds handler of this Pack or to this timeout 
    handler if non arrive. **/

#endif

