*CMZ :          07/11/96  12.55.17  by  T. Oest
*-- Author :    T. Oest   27/09/96

      SUBROUTINE V0MASS(MASS, PTRK, VTRK, IRET)

************************************************************************
*
* Description:  perform mass constraint
*
* Called from:
*
* External references:
*
* Argument in/out description
* MASS     in     mass constraint
* PTRK(7)  in/out partibel parameter (z,x,y,tx,ty,r,m)
* VTRK(7,7)in/out covariance matrix for PTRK
* IRET     out    =0  ok
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/EV.fi"
#include "auto/CON.fi"

      INTEGER          IRET
      DOUBLE PRECISION PTRK(7), VTRK(7,7), MASS

      INTEGER          I, J
      DOUBLE PRECISION WTRK(7,7), V6(6,6), RW7(7), RW6(6)
      DOUBLE PRECISION DP(6)


#include "arte/Arte.ff"
#include "auto/EV.ff"
#include "auto/CON.ff"

C-----------------------------------------------------------------
      IRET  = 0
C-----------------------------------------------------------------
C  inversion of covariance matrix
C-----------------------------------------------------------------
      DO I=1,7
      DO J=1,7
       WTRK(I,J) = VTRK(I,J)
      ENDDO
      ENDDO
      CALL DINV(7, WTRK, 7, RW7, IRET)

      IF (IRET.NE.0) GOTO 9000

      DO I=1,6
      DO J=1,6
       V6(I,J) = WTRK(I,J) 
      ENDDO
      ENDDO
      CALL DINV(6, V6, 6, RW6, IRET)

      IF (IRET.NE.0) GOTO 9000

C-----------------------------------------------------------------
C  parameter change (up to a factor delta(MASS) )
C-----------------------------------------------------------------
      DO I=1,6
       DP(I) = 0.0D0
       DO J=1,6
        DP(I) = DP(I) + V6(I,J) * WTRK(J,7)
       ENDDO
      ENDDO
C-----------------------------------------------------------------
C  new parameter, covariance matrix
C-----------------------------------------------------------------
      DO I=1,6
       PTRK(I) = PTRK(I) + DP(I) * (PTRK(7)-MASS)
      ENDDO


      DO I=1,6
      DO J=1,6
       VTRK(I,J) = V6(I,J) 
      ENDDO
      ENDDO
C-----------------------------------------------------------------
C  the end
C-----------------------------------------------------------------

 9000 END

************************************************************************
* End of V0MASS
************************************************************************





