#ifndef __VTUTIL_HH
#define __VTUTIL_HH
// *****************************************************************************
//
// source:
//
// type:      source code
//
// created:   21. Aug 2000
//
// author:    Thorsten Glebe
//            HERA-B Collaboration
//            Max-Planck-Institut fuer Kernphysik
//            Saupfercheckweg 1
//            69117 Heidelberg
//            Germany
//            E-mail: T.Glebe@mpi-hd.mpg.de
//
// Description: Some helper routines
//
// changes:
// 21 Aug 2000 (TG) creation
//
// *****************************************************************************

#include "arte/arte.hh"

namespace VERTEX {
  class abc; // to fake doc++

  /** @name Global utility functions */
  //==============================================================================
  // sqr: x*x
  //==============================================================================
  /// compute the square of a number: $x*x$
  template <class T>
    inline const T sqr(const T& x) { return x*x; }

  //==============================================================================
  // sgn: sign
  //==============================================================================
  /// compute the sign of a number
  template <class T>
  inline const short int sgn(const T& x) { return (x==0)? 0 : (x<0)? -1 : 1; }
 
  //==============================================================================
  // getIDX:
  //==============================================================================
  /// calc ArteTable index from ArtePointer
  template <class T>
  inline unsigned int getIDX( ArtePointer<T> ptr ) {
    return (ptr - *ArteTable<T>::begin() + 1);
  }

  //==============================================================================
  // getPTR:
  //==============================================================================
  /// get ArtePointer from ArteTable index
  template <class T>
  inline ArtePointer<T> getPTR( unsigned int idx ) {
    return *(ArteTable<T>::begin() + idx - 1);
  }
} // end of namespace VERTEX
#endif
