*  Author   :    A.Spiridonov    16/92/98
*  changed  :    A.Spiridonov    14/05/98
*  changed  :    A.Spiridonov    29/07/9
**************************************************************
*                                                            *
      subroutine vtpsto(flag)
*                                                            *
*     Store information about primary vertices               *
*             version ARTE-01-08                             *
*     (t0 shifts was not included in RTRA )                  *
*                                                            *
*                                                            *
* input :                                                    *
*          flag - flag of vertex fit from vtrec              *    
*                                                            *
**************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"

#include "auto/RVER.fi"
#include "auto/RTRA.fi"
#include "auto/RREL.fi"

#include "vt/vtdat.fi"
#include "vt/vtwire.fi"
#include "vt/vtpatt.fi"
#include "vt/vt_rtra.fi"

      integer iv,iv_prim,flag,it,n_tracks_v
      integer tpname,topp_prim
      real    p_incom

#include "arte/Arte.ff"
#include "auto/RVER.ff"
#include "auto/RTRA.ff"
#include "auto/RREL.ff"

*=============================================================
*
*
*      print *,'N primary vertices = ',nvprim     
      if(nvprim.le.0) go to 999
*                                  
      do iv=1,nvprim
        call mmbook(jrver,1)                 ! book and fill RVER tables
        iv_prim = ivprim(iv)
*
        q (qrver_xv_l()) = xvs(1,iv_prim)
        q (qrver_yv_l()) = xvs(2,iv_prim)
        q (qrver_zv_l()) = xvs(3,iv_prim)
*
        q (qrver_cv_l(1)) = CS(1,1,iv_prim)
        q (qrver_cv_l(2)) = CS(1,2,iv_prim)
        q (qrver_cv_l(3)) = CS(2,2,iv_prim)
        q (qrver_cv_l(4)) = CS(1,3,iv_prim)
        q (qrver_cv_l(5)) = CS(2,3,iv_prim)
        q (qrver_cv_l(6)) = CS(3,3,iv_prim)
*  
        q (qrver_mass_l())= 0.
        q (qrver_merr_l())= 0.
        iq(iqrver_nt_l() ) = ntr(iv_prim)
*
*                                           book relation between 
*                                           tracks and vertices
        n_tracks_v=0
        do it=1,trmult    
          if(jv(iv_prim,it).ne.0) then
            n_tracks_v = n_tracks_v + 1
*
            call mmbook(jrrel,1)
*
            iq(iqrrel_flag_l()) = 1
            iq(iqrrel_topp_l()) = 0
            if(n_tracks_v.eq.1) then
              q (qrrel_chi_l())   = chi2(iv_prim,n_tracks_v)
            else
              q (qrrel_chi_l())   = chi2(iv_prim,n_tracks_v     ) 
     +                            - chi2(iv_prim,n_tracks_v - 1 )
            end if
*
*                                   relation one track to many RREL
*
            call mmbrel(jrrrt,vt_rtra(it),nrrel())
*
*                                   relation one vertex to many RREl
*
            call mmbrel(jrrrv,nrver(),nrrel())

*            print *,'iv_prim,it,rtra,p' , iv_prim,it,vt_rtra(it),p(5,it)

          end if                    ! end if /track participate in fit 
        end do                      ! end of loop on tracks from buffer
*
*        print *,'n_tracks_v ' , n_tracks_v
* 
      end do                        ! end of loop on iv_prim (primary vetices)
*
  999 return
      end

