*CMZ :          20/05/96  12.58.00  by  Unknown
*-- Author :   T.Lohse
c
c-------------------------------------------------------------
c
c       subroutine:   VTWITR(it1,it2)
c
c       input:    it1 = starting track number            Int
c                 it2 = last track number                Int
c                 if 0 ===> loop over all tracks
c
c       output:   ch2wi(iw,it) = chi2-distance (NDF=1)   R*8
c
c-------------------------------------------------------------
c
      subroutine  VTWITR(it1,it2)

      implicit none
#include "vt/vtdat.fi"
#include "vt/vtwire.fi"
#include "vt/vtpatt.fi"

      integer it1,it2

      double precision 
     1  x(3), cov(3,3)
      double precision 
     1  Vmat(4,4)
      integer i,j,iit,iw,ifail,iv,l

c
c--->  loop over all wires
c
      do  iw = 1, nw
c
c--->  fill the wire covariance matrix
c--->  and initialize an auxiliary vertex
c
        do  i = 1, 3
          x(i) = xw(i,iw)
          do  j = 1, 3
            cov(i,j) = Cw(i,j,iw)
          enddo
        enddo
        call VTINIT(x,cov,iv,ifail)
        if (ifail.lt.0) then
          do  iit = it1, it2
            ch2wi(iw,iit) = 1000.
          enddo
          goto   200
        endif
c
c--->  loop over all tracks
c
        do  iit = it1, it2

c--->  invert the covariance matrix of the track
          if (invflg(iit).ne.4) then
            do  j = 1, 4
              do  l = 1, 4
                Vmat(j,l) = V(j,l,iit)
              enddo
            enddo
            call DSINV(4,Vmat,4,ifail)
            if (ifail.eq.-1) goto 150
            invflg(iit) = 4
            do  j = 1, 4
              do  l = 1, 4
                G(j,l,iit) = Vmat(j,l)
              enddo
            enddo
          endif
c
c--->  put the track on the vertex
c
          ktr(iv,1)   = iit
          ntr(iv)     = 1
          qvs(1,iv,1) = p(1,iit)
          qvs(2,iv,1) = p(2,iit)

c
c--->  fit the vertex (no iteration)
c
          call VTFILT(iv,0,ifail)
          if (ifail.lt.0) then
            ch2wi(iw,iit) = 1000.
          else
            ch2wi(iw,iit) = chi2(iv,1)
          endif

c
c--->  remove the track from the vertex
c
          ktr(iv,1)   = 0
          ntr(iv)     = 0

  150     continue

        enddo

c
c--->  delete the auxiliary vertex
c
        call VTDEL(iv,ifail)

  200   continue

      enddo

      return
      end
